#!/bin/ksh
#############################################################
# Program:	upload.cgi
#               Copyright 1999
#
# Description:	
#
# Author:	Dana French (dfrench@aignetplex.com)
#		 
#		(405) 936-2342
#
# Date:		04/26/99
#
#############################################################
# Modifications:
#
# 04/26/99	Version: 1.0
#		Original Code
################################################################
#
# httpd Environment Variables used
#
#	DOCUMENT_ROOT		Full path to top level html dir
#	SCRIPT_NAME		CGI path to this script
#	SCRIPT_FILENAME		Full path to this script
#
################################################################
h2a()
{
  sed -e "s/%\(..\)/\`print \"ibase=16; \1\" \| bc \| awk \'\{printf\(\"%c\",\$1\)\}\'\`/g"
}
################################################################
hex2ascii()
{
  HEXTMP=`h2a`
  eval print "${HEXTMP}"
}
################################################################
sedit()
{
hex2ascii | sed -e "\
s/,/,/g;\
s/\`/\'/g;\
s/+/ /g;\
s/%2[Ff]/\//g;\
s/     / /g;\
s/    / /g;\
s/   / /g;\
s/  / /g;\
s/^ //g"
}
################################################################
DOCUMENT_ROOT="/home/httpd/html"
# SCRIPT_NAME="/cgi-bin/fancyIndex/upload.cgi"
# SCRIPT_FILENAME="/external/ns-home/cgi-bin/fancyIndex/upload.cgi"

DOCUMENT_BASE="/fancyIndex/"
DOCUMENT_DIR="${DOCUMENT_ROOT}${DOCUMENT_BASE}"
SCRIPT_DIR=`dirname "${SCRIPT_FILENAME}"`
SCRIPT_CGI=`dirname "${SCRIPT_NAME}"`
SEARCHTERM=""

if [ "_${*}" = "_" ]
then
    DDDIR=""
    DD_DIR=""
else
    DDDIR=`print "${*}" | sedit`
    DD_DIR=`print "${*}" | sedit`
fi

for VARVAL in `print "${QUERY_STRING}" | sed -e "s/&/	/g"`
do
  if print "${VARVAL}" | grep -i "=" > /dev/null
  then
    VAR=`print "${VARVAL%=*}" | sedit`
    VAL=`print "${VARVAL#*=}" | sedit`
    eval ${VAR}="\"${VAL}\""
  fi
done

DDDIR=`print "${DDDIR}/" | sed -e "s|//$|/|g;s|^/$||g"`
DD_DIR=`print "${DDDIR}/" | sed -e "s/ /%20/g;s|//$|/|g;s|^/$||g"`

print "content-type:text/html
pragma: no-cache

<HTML>
<HEAD>
<TITLE>Apache FancyIndex - /${DDDIR}</TITLE>
</HEAD>
<BODY>
"

################################################################
if [[ -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.titlebar" ]]
then
    SUBTITLE=`basename "/${DDDIR}"`
    sed -e "s|<!-- Begin subtitle -->.*<!-- End subtitle -->|<!-- Begin subtitle -->${SUBTITLE}<!-- End subtitle -->|" "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.titlebar"
fi

[[ -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.linkbar" ]] && cat "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.linkbar"
################################################################

print "
<!-- Begin directories -->
<P><BLOCKQUOTE><FONT Size=\"+1\"><STRONG>
"

cd "${DOCUMENT_DIR}${DDDIR}"
URLPATH="${DOCUMENT_BASE}"
pwd | sed -e "s|${DOCUMENT_ROOT}||g;s|^/||g;s|/$||g" | tr '/' '\012' | while read DIR
do
    if [[ "_${DIR}" = "_fancyIndex" ]]
    then

      print "<A Href=\"${URLPATH}\"> Home </A>"

    else

      URLPATH=`print "${URLPATH}${DIR}/" | sed -e "s/ /%20/g;s/	/%20/g"`
      print " : <A Href=\"${URLPATH}\"> ${DIR} </A>"

    fi

  done

  print "
</STRONG></FONT></BLOCKQUOTE></P>
<!-- End directories -->
"

################################################################
[[ -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.description" ]] && cat "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.description"
################################################################


################################################################
# Begin upload code
################################################################

if [[ ! -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.admuploadFile" ]]
then
    print "<P><BR><STRONG>ERROR:</STRONG> File uploads to this directory are not allowed.<BR></P>";
    [[ -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.linkbar" ]] && cat "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.linkbar"
    [[ -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.forinfo" ]] && cat "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.forinfo"
    print "</BODY></HTML>"
    exit
fi

print "
<FORM Method=\"post\" Enctype=\"multipart/form-data\" Action=\"${SCRIPT_CGI}/admuploadFile.cgi\">
<INPUT Type=\"hidden\" Name=\"DDDIR\" Value=\"${DDDIR}\">

<P><HR></P>
<P>
<TABLE Border=\"0\">
<P>
  <CAPTION>
    <FONT Size=\"+2\"><STRONG>
Enter directory administrator's ID and password.
    </STRONG></FONT>
  </CAPTION>
</P>
<P>
  <TR>
    <TD Align=\"right\" Valign=\"top\">
      <FONT Size=\"+1\"><STRONG>
Administrator ID:
      </STRONG></FONT>
    </TD>
    <TD Align=\"left\" Valign=\"top\">
      <FONT Size=\"+1\"><STRONG>
<INPUT Type=\"text\" Name=\"ADM_USERID\" Size=\"8\" Maxlength=\"8\">
      </STRONG></FONT>
<BR>
      <FONT Size=\"-1\"><I>

Enter the administrator's ID for this directory.  Only the administrator
of this directory is permitted to upload files. The administrator ID can
be up to 8 characters and must  contain only letters, numbers or spaces.

      </I></FONT>
<HR>
    </TD>
  </TR>
</P>
<P>
  <TR>
    <TD Align=\"right\" Valign=\"top\">
      <FONT Size=\"+1\"><STRONG>
Password:
      </STRONG></FONT>
    </TD>
    <TD Align=\"left\" Valign=\"top\">
      <FONT Size=\"+1\"><STRONG>
<INPUT Type=\"password\" Name=\"ADM_PASSWORD\" Size=\"8\" Maxlength=\"8\">
      </STRONG></FONT>
<BR>
      <FONT Size=\"-1\"><I>

Enter the administrator's password for this directory.  Only the
administrator of this directory is permitted to upload files.  The
administrator password can be up to 8 characters and must  contain only
letters, numbers or spaces.

      </I></FONT>
<HR>
    </TD>
  </TR>
</P>
</TABLE>
</P>

<P><HR></P>

<P>
<CENTER>
<TABLE Border="0" Cellspacing="2" Cellpadding="2">
  <P>
  <CAPTION Align="top"><B><FONT Size="5" Color="darkblue">
File Upload to Current Directory
  </FONT></B></CAPTION>
  </P>
  <P>
    <TR Rowspan="1">
    <!-- ########    ROW 1    COLUMN 1    ######## -->
        <TD Bgcolor="white" Align="left" Valign="middle" Colspan="1">
            <FONT Size="4" Color="black"><STRONG>
File to upload:
            </STRONG></FONT>
        </TD>
    <!-- ########    ROW 1    COLUMN 2    ######## -->
        <TD Bgcolor="white" Align="left" Valign="middle" Colspan="1">
            <FONT Size="4" Color="black">
<INPUT Type=\"file\" Name=\"UPFILE\">
            </FONT>
        </TD>
    </TR>
  </P>
  <P>
    <TR Rowspan="1">
    <!-- ########    ROW 2    COLUMN 1    ######## -->
        <TD Bgcolor="white" Align="left" Valign="middle" Colspan="1">
            <FONT Size="4" Color="black"><STRONG>
Save As Filename:
            </STRONG></FONT>
        </TD>
    <!-- ########    ROW 2    COLUMN 2    ######## -->
        <TD Bgcolor="white" Align="left" Valign="middle" Colspan="1">
            <FONT Size="4" Color="black">
<INPUT Type=\"text\" Name=\"SAVEASNAME\">
            </FONT>
        </TD>
    </TR>
  </P>
  <P>
    <TR Rowspan="1">
    <!-- ########    ROW 3    COLUMN 1    ######## -->
        <TD Bgcolor="white" Align="left" Valign="middle" Colspan="1">
            <FONT Size="4" Color="black"><STRONG>
File Description:
            </STRONG></FONT>
        </TD>
    <!-- ########    ROW 3    COLUMN 2    ######## -->
        <TD Bgcolor="white" Align="left" Valign="middle" Colspan="1">
            <FONT Size="4" Color="black">
<INPUT Type=\"text\" Name=\"NOTE\">
            </FONT>
        </TD>
    </TR>
  </P>
  <P>
    <TR Rowspan="1">
    <!-- ########    ROW 3    COLUMN 1    ######## -->
        <TD Bgcolor="white" Align="left" Valign="middle" Colspan="1">
            <FONT Size="4" Color="black"><STRONG>
&nbsp;
            </STRONG></FONT>
        </TD>
    <!-- ########    ROW 3    COLUMN 2    ######## -->
        <TD Bgcolor="white" Align="left" Valign="middle" Colspan="1">
            <FONT Size="4" Color="black">
<INPUT Type=\"submit\" Value=\"Upload File\">
            </FONT>
        </TD>
    </TR>
  </P>
</TABLE>
</CENTER>
</P>
</FORM>
"
################################################################
# end upload code
################################################################

[[ -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.linkbar" ]] && cat "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.linkbar"
[[ -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.forinfo" ]] && cat "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.forinfo"

print "
</BODY>
</HTML>"

