#!/bin/ksh
#############################################################
# Program:	contactAdd.cgi
#               Copyright 1999
#
# Description:	
#
# Author:	Dana French (dfrench@aignetplex.com)
#		 
#		(405) 936-2342
#
# Date:		04/26/99
#
#############################################################
# Modifications:
#
# 04/26/99	Version: 1.0
#		Original Code
################################################################
#
# httpd Environment Variables used
#
#	DOCUMENT_ROOT		Full path to top level html dir
#	SCRIPT_NAME		CGI path to this script
#	SCRIPT_FILENAME		Full path to this script
#
################################################################
h2a()
{
  sed -e "s/%\(..\)/\`print \"ibase=16; \1\" \| bc \| awk \'\{printf\(\"%c\",\$1\)\}\'\`/g"
}
################################################################
hex2ascii()
{
  HEXTMP=`h2a`
  eval print "${HEXTMP}"
}
################################################################
sedit()
{
hex2ascii | sed -e "\
s/,/,/g;\
s/\`/\'/g;\
s/+/ /g;\
s/%2[Ff]/\//g;\
s/     / /g;\
s/    / /g;\
s/   / /g;\
s/  / /g;\
s/^ //g"
}
################################################################
chkvalue()
{
  if [[ "_${3}" != "_NULL_OK" && "_${1}" = "_" ]]
  then
    print "<STRONG>ERROR:</STRONG> You did not supply a ${2}. Go back and try again.<BR>"
    EXITLEVEL="$(( ${EXITLEVEL} + 1 ))"
  else
    CHKVALUE_REMAIN=`print "${1}" | sed -e "s|[a-z,A-Z,0-9, ,\.,:,\,,\@,/]||g"`
    if [[ "_${#CHKVALUE_REMAIN}" != "_" ]]
    then
      if [[ ${#CHKVALUE_REMAIN} -eq 0 ]]
      then
        print "<I>${2}</I> checked and accepted.<BR>"
      else
        print "<STRONG>ERROR:</STRONG> Invalid ${2}. Go back and try again.<BR>"
        EXITLEVEL="$(( ${EXITLEVEL} + 1 ))"
      fi
    else
      print "<STRONG>ERROR:</STRONG> Unable to perform validity check on ${2}. Go back and try again.<BR>"
      EXITLEVEL="$(( ${EXITLEVEL} + 1 ))"
    fi
  fi
}
################################################################
# DOCUMENT_ROOT="/external/ns-home/docs"
# SCRIPT_NAME="/cgi-bin/engine/engine.cgi"
# SCRIPT_FILENAME="/external/ns-home/cgi-bin/engine/engine.cgi"

DOCUMENT_BASE="/fancyIndex/"
DOCUMENT_DIR="${DOCUMENT_ROOT}${DOCUMENT_BASE}"
SCRIPT_DIR=`dirname "${SCRIPT_FILENAME}"`
SCRIPT_CGI=`dirname "${SCRIPT_NAME}"`
SEARCHTERM=""
PWPROTECTED="0"
CON_URL=""
CON_COMMENT=""

if [ "_${*}" = "_" ]
then
    DDDIR=""
    DD_DIR=""
else
    DDDIR=`print "${*}" | sedit`
    DD_DIR=`print "${*}" | sedit`
fi

DAYCNT="0"
for VARVAL in `print "${QUERY_STRING}" | sed -e "s/&/	/g"`
do
  if print "${VARVAL}" | grep -i "=" > /dev/null
  then
    VAR=`print "${VARVAL%=*}" | sedit`
    VAL=`print "${VARVAL#*=}" | sedit`
    eval ${VAR}="\"${VAL}\""
    if [[ "_${VAR}" = "_CON_DAYS" ]]
    then
        CON_DAYLIST[${DAYCNT}]="${VAL}"
        DAYCNT="$(( ${DAYCNT} + 1 ))"
    fi
  fi
done

DDDIR=`print "${DDDIR}/" | sed -e "s|//$|/|g;s|^/$||g"`
DD_DIR=`print "${DDDIR}/" | sed -e "s/ /%20/g;s|//$|/|g;s|^/$||g"`

print "content-type:text/html
pragma: no-cache

<HTML>
<HEAD>
<TITLE>Apache FancyIndex - /${DDDIR}</TITLE>
</HEAD>
"

if [[ -d "${DOCUMENT_DIR}" ]]
then
    if [[ -f "${DOCUMENT_DIR}${DDDIR}.bodytag" ]]
    then
        cat "${DOCUMENT_DIR}${DDDIR}.bodytag"
    else
        print "
<BODY Bgcolor=\"white\" Text=\"black\" Link=\"blue\" Vlink=\"red\" Alink=\"yellow\">
<BASEFONT Size=\"3\" Face=\"Arial\">
"
    fi
    if [[ -s "${DOCUMENT_DIR}${DDDIR}HEADER.html" ]]
    then
        cat "${DOCUMENT_DIR}${DDDIR}HEADER.html"
    elif [[ -s "${DOCUMENT_DIR}${DDDIR}.titlebar" ]]
    then
        cat "${DOCUMENT_DIR}${DDDIR}.titlebar"
    else
        print "<H2>Apache Fancy Index Input Form</H2>"
    fi
fi

# set | sed -e "s/$/<BR>/g"

print "<P><H2>Attempting to create the directory ${DOCUMENT_BASE}${DDDIR}</H2></P>"

################################################################
####	First check the password protection parameters
################################################################

EXITLEVEL="0"

chkvalue "${CON_FNAME}" "First Name" "NULL_OK"
chkvalue "${CON_LNAME}" "Last Name" "NULL_OK"
chkvalue "${CON_TITLE}" "Title/Position" "NULL_OK"
chkvalue "${CON_EMAIL}" "E-mail address" "NULL_OK"
chkvalue "${CON_URL}" "URL address" "NULL_OK"
chkvalue "${CON_COMPANY}" "Company Name" "NULL_OK"
chkvalue "${CON_COMPANYURL}" "Company URL" "NULL_OK"
chkvalue "${CON_DEPT}" "Department" "NULL_OK"
chkvalue "${CON_REGION}" "Geographic Region" "NULL_OK"
chkvalue "${CON_ADDR1}" "Street Address Line 1" "NULL_OK"
chkvalue "${CON_ADDR2}" "Street Address Line 2" "NULL_OK"
chkvalue "${CON_CITY}" "City" "NULL_OK"
chkvalue "${CON_STATE}" "State/Province" "NULL_OK"
chkvalue "${CON_ZIP}" "Zip/Postal Code" "NULL_OK"
chkvalue "${CON_PHONE}" "Phone Number" "NULL_OK"
chkvalue "${CON_FAX}" "FAX Number" "NULL_OK"
chkvalue "${CON_PAGER}" "Pager Number" "NULL_OK"
chkvalue "${CON_MOBILE}" "Mobile Phone Number" "NULL_OK"
chkvalue "${CON_MAPURL}" "Map URL" "NULL_OK"
chkvalue "${CON_DRIVEURL}" "Driving directions URL" "NULL_OK"

if [[ ${EXITLEVEL} -gt 0 ]]
then
  print "</BODY></HTML>"
  exit
fi

cd "${DOCUMENT_DIR}${DDDIR}"

OUTNAME=`date +"%Y%m%d%H%M%S"`
OUTFILE="${DOCUMENT_DIR}${DDDIR}${OUTNAME}.sub"

> ${OUTFILE}

print "CON_FNAME=\"${CON_FNAME}\"" >> ${OUTFILE}
print "CON_LNAME=\"${CON_LNAME}\"" >> ${OUTFILE}
print "CON_TITLE=\"${CON_TITLE}\"" >> ${OUTFILE}
print "CON_EMAIL=\"${CON_EMAIL}\"" >> ${OUTFILE}
print "CON_URL=\"${CON_URL}\"" >> ${OUTFILE}
print "CON_COMPANY=\"${CON_COMPANY}\"" >> ${OUTFILE}
print "CON_COMPANYURL=\"${CON_COMPANYURL}\"" >> ${OUTFILE}
print "CON_DEPT=\"${CON_DEPT}\"" >> ${OUTFILE}
print "CON_REGION=\"${CON_REGION}\"" >> ${OUTFILE}
print "CON_ADDR1=\"${CON_ADDR1}\"" >> ${OUTFILE}
print "CON_ADDR2=\"${CON_ADDR2}\"" >> ${OUTFILE}
print "CON_CITY=\"${CON_CITY}\"" >> ${OUTFILE}
print "CON_STATE=\"${CON_STATE}\"" >> ${OUTFILE}
print "CON_ZIP=\"${CON_ZIP}\"" >> ${OUTFILE}
print "CON_PHONE=\"${CON_PHONE}\"" >> ${OUTFILE}
print "CON_FAX=\"${CON_FAX}\"" >> ${OUTFILE}
print "CON_PAGER=\"${CON_PAGER}\"" >> ${OUTFILE}
print "CON_MOBILE=\"${CON_MOBILE}\"" >> ${OUTFILE}
print "CON_MAPURL=\"${CON_MAPURL}\"" >> ${OUTFILE}
print "CON_DRIVEURL=\"${CON_DRIVEURL}\"" >> ${OUTFILE}

# if [[ "_${CON_CITY}" != "_" ]]
# then ln -s "../${OUTNAME}.sub" "./Sorted by City/${CON_CITY}.${OUTNAME}.sub"
# else ln -s "../${OUTNAME}.sub" "./Sorted by City/zzz.${OUTNAME}.sub"
# fi
# 
# if [[ "_${CON_COMPANY}" != "_" ]]
# then ln -s "../${OUTNAME}.sub" "./Sorted by Company/${CON_COMPANY}.${OUTNAME}.sub"
# else ln -s "../${OUTNAME}.sub" "./Sorted by Company/zzz.${OUTNAME}.sub"
# fi
# 
# if [[ "_${CON_DEPARTMENT}" != "_" ]]
# then ln -s "../${OUTNAME}.sub" "./Sorted by Department/${CON_DEPARTMENT}.${OUTNAME}.sub"
# else ln -s "../${OUTNAME}.sub" "./Sorted by Department/zzz.${OUTNAME}.sub"
# fi
# 
# if [[ "_${CON_EMAIL}" != "_" ]]
# then ln -s "../${OUTNAME}.sub" "./Sorted by E-mail/${CON_EMAIL}.${OUTNAME}.sub"
# else ln -s "../${OUTNAME}.sub" "./Sorted by E-mail/zzz.${OUTNAME}.sub"
# fi
# 
# if [[ "_${CON_FAX}" != "_" ]]
# then ln -s "../${OUTNAME}.sub" "./Sorted by FAX Number/${CON_FAX}.${OUTNAME}.sub"
# else ln -s "../${OUTNAME}.sub" "./Sorted by FAX Number/zzz.${OUTNAME}.sub"
# fi
# 
# if [[ "_${CON_FNAME}" != "_" ]]
# then ln -s "../${OUTNAME}.sub" "./Sorted by First Name/${CON_FNAME}.${OUTNAME}.sub"
# else ln -s "../${OUTNAME}.sub" "./Sorted by First Name/zzz.${OUTNAME}.sub"
# fi
# 
# if [[ "_${CON_LNAME}" != "_" ]]
# then ln -s "../${OUTNAME}.sub" "./Sorted by Last Name/${CON_LNAME}.${OUTNAME}.sub"
# else ln -s "../${OUTNAME}.sub" "./Sorted by Last Name/zzz.${OUTNAME}.sub"
# fi
# 
# if [[ "_${CON_PHONE}" != "_" ]]
# then ln -s "../${OUTNAME}.sub" "./Sorted by Phone Number/${CON_PHONE}.${OUTNAME}.sub"
# else ln -s "../${OUTNAME}.sub" "./Sorted by Phone Number/zzz.${OUTNAME}.sub"
# fi
# 
# if [[ "_${CON_REGION}" != "_" ]]
# then ln -s "../${OUTNAME}.sub" "./Sorted by Region/${CON_REGION}.${OUTNAME}.sub"
# else ln -s "../${OUTNAME}.sub" "./Sorted by Region/zzz.${OUTNAME}.sub"
# fi
# 
# if [[ "_${CON_STATE}" != "_" ]]
# then ln -s "../${OUTNAME}.sub" "./Sorted by State or Province/${CON_STATE}.${OUTNAME}.sub"
# else ln -s "../${OUTNAME}.sub" "./Sorted by State or Province/zzz.${OUTNAME}.sub"
# fi
# 
# if [[ "_${CON_TITLE}" != "_" ]]
# then ln -s "../${OUTNAME}.sub" "./Sorted by Title/${CON_TITLE}.${OUTNAME}.sub"
# else ln -s "../${OUTNAME}.sub" "./Sorted by Title/zzz.${OUTNAME}.sub"
# fi
# 
# if [[ "_${CON_ZIP}" != "_" ]]
# then ln -s "../${OUTNAME}.sub" "./Sorted by Zip or Postal Code/${CON_ZIP}.${OUTNAME}.sub"
# else ln -s "../${OUTNAME}.sub" "./Sorted by Zip or Postal Code/zzz.${OUTNAME}.sub"
# fi

print "<P><STRONG>Contact Submitted</STRONG>: Administrator must approve 
this contact before it will appear on the contact list.</P>"

if [[ -s "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.admin" ]]
then
    ADM_EMAIL=""
    . "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.admin"
    if [[ "_${ADM_EMAIL}" != "_" ]]
    then

print "
A contact has been submitted to your Contact List at:

http://`uname -n`${DOCUMENT_BASE}${DD_DIR}

As the administrator of this contact list, you must approve,
disapprove, or remove any submitted contacts before they
will appear on the contact list.
" | mail -s "Contact submitted to your contact list" "${ADM_EMAIL}"

print "<P><STRONG>Notification Sent</STRONG>: The administrator
of this contact list has been sent notification that a contact
has been submitted.</P>"

    fi
fi

print "<P>"
print "<BR><A Href=\"${SCRIPT_CGI}/contactAddForm.cgi?${DD_DIR}\">Add another contact to the Contact List</A>"
print "<BR><A Href=\"${SCRIPT_CGI}/contactManageForm.cgi?${DD_DIR}\">Manage submitted contacts</A>"
print "<BR><A href=\"${SCRIPT_CGI}/contactReindex.cgi?${DD_DIR}\">Reindex Current Contact List</A>"
print "<BR><A href=\"${DOCUMENT_BASE}${DD_DIR}\">Return to Contact List</A>"
print "</P>"

[[ -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.linkbar" ]] && cat "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.linkbar"
[[ -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.forinfo" ]] && cat "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.forinfo"

print "</BODY>
</HTML>"
