#!/bin/ksh
#############################################################
# Program:	contactManage.cgi
#               Copyright 1999
#
# Description:	
#
# Author:	Dana French (dfrench@aignetplex.com)
#		 
#		(405) 936-2342
#
# Date:		04/26/99
#
#############################################################
# Modifications:
#
# 04/26/99	Version: 1.0
#		Original Code
################################################################
#
# httpd Environment Variables used
#
#	DOCUMENT_ROOT		Full path to top level html dir
#	SCRIPT_NAME		CGI path to this script
#	SCRIPT_FILENAME		Full path to this script
#
################################################################
h2a()
{
  sed -e "s/%\(..\)/\`print \"ibase=16; \1\" \| bc \| awk \'\{printf\(\"%c\",\$1\)\}\'\`/g"
}
################################################################
hex2ascii()
{
  HEXTMP=`h2a`
  eval print "${HEXTMP}"
}
################################################################
sedit()
{
hex2ascii | sed -e "\
s/,/,/g;\
s/\`/\'/g;\
s/+/ /g;\
s/%2[Ff]/\//g;\
s/     / /g;\
s/    / /g;\
s/   / /g;\
s/  / /g;\
s/^ //g"
}
################################################################
chkvalue()
{
  if [[ "_${1}" = "_" ]]
  then
    print "<STRONG>ERROR:</STRONG> You did not supply a ${2}. Go back and try again.<BR>"
    EXITLEVEL="$(( ${EXITLEVEL} + 1 ))"
  else
    CHKVALUE_REMAIN=`print "${1}" | sed -e "s|[a-z,A-Z,0-9, ]||g"`
    if [[ "_${#CHKVALUE_REMAIN}" != "_" ]]
    then
      if [[ ${#CHKVALUE_REMAIN} -eq 0 ]]
      then
        print "<I>${2}</I> checked and accepted.<BR>"
      else
        print "<STRONG>ERROR:</STRONG> Invalid ${2}. Go back and try again.<BR>"
        EXITLEVEL="$(( ${EXITLEVEL} + 1 ))"
      fi
    else
      print "<STRONG>ERROR:</STRONG> Unable to perform validity check on ${2}. Go back and try again.<BR>"
      EXITLEVEL="$(( ${EXITLEVEL} + 1 ))"
    fi
  fi
}

################################################################
# DOCUMENT_ROOT="/external/ns-home/docs"
# SCRIPT_NAME="/cgi-bin/engine/engine.cgi"
# SCRIPT_FILENAME="/external/ns-home/cgi-bin/engine/engine.cgi"

DOCUMENT_BASE="/fancyIndex/"
DOCUMENT_DIR="${DOCUMENT_ROOT}${DOCUMENT_BASE}"
SCRIPT_DIR=`dirname "${SCRIPT_FILENAME}"`
SCRIPT_CGI=`dirname "${SCRIPT_NAME}"`
SEARCHTERM=""
PWPROTECTED="0"

SORTBY_DIR[0]="Sorted by City"
SORTBY_VAR[0]="CON_CITY"
SORTBY_DIR[1]="Sorted by Company"
SORTBY_VAR[1]="CON_COMPANY"
SORTBY_DIR[2]="Sorted by Department"
SORTBY_VAR[2]="CON_DEPT"
SORTBY_DIR[3]="Sorted by E-mail"
SORTBY_VAR[3]="CON_EMAIL"
SORTBY_DIR[4]="Sorted by FAX Number"
SORTBY_VAR[4]="CON_FAX"
SORTBY_DIR[5]="Sorted by First Name"
SORTBY_VAR[5]="CON_FNAME"
SORTBY_DIR[6]="Sorted by Last Name"
SORTBY_VAR[6]="CON_LNAME"
SORTBY_DIR[7]="Sorted by Phone Number"
SORTBY_VAR[7]="CON_PHONE"
SORTBY_DIR[8]="Sorted by Region"
SORTBY_VAR[8]="CON_REGION"
SORTBY_DIR[9]="Sorted by State or Province"
SORTBY_VAR[9]="CON_STATE"
SORTBY_DIR[10]="Sorted by Title"
SORTBY_VAR[10]="CON_TITLE"
SORTBY_DIR[11]="Sorted by Zip or Postal Code"
SORTBY_VAR[11]="CON_ZIP"

if [ "_${*}" = "_" ]
then
    DDDIR=""
    DD_DIR=""
else
    DDDIR=`print "${*}" | sedit`
    DD_DIR=`print "${*}" | sedit`
fi

for VARVAL in `print "${QUERY_STRING}" | sed -e "s/&/	/g"`
do
  if print "${VARVAL}" | grep -i "=" > /dev/null
  then
    VAR=`print "${VARVAL%=*}" | sedit`
    VAL=`print "${VARVAL#*=}" | sedit`
    eval ${VAR}="\"${VAL}\""
  fi
done

DDDIR=`print "${DDDIR}/" | sed -e "s|//$|/|g;s|^/$||g"`
DD_DIR=`print "${DDDIR}/" | sed -e "s/ /%20/g;s|//$|/|g;s|^/$||g"`

print "content-type:text/html
pragma: no-cache

<HTML>
<HEAD>
<TITLE>Apache FancyIndex - /${DDDIR}</TITLE>
</HEAD>
"

if [[ -d "${DOCUMENT_DIR}" ]]
then
    if [[ -f "${DOCUMENT_DIR}${DDDIR}.bodytag" ]]
    then
        cat "${DOCUMENT_DIR}${DDDIR}.bodytag"
    else
        print "
<BODY Bgcolor=\"white\" Text=\"black\" Link=\"blue\" Vlink=\"red\" Alink=\"yellow\">
<BASEFONT Size=\"3\" Face=\"Arial\">
"
    fi
    if [[ -s "${DOCUMENT_DIR}${DDDIR}HEADER.html" ]]
    then
        cat "${DOCUMENT_DIR}${DDDIR}HEADER.html"
    elif [[ -s "${DOCUMENT_DIR}${DDDIR}.titlebar" ]]
    then
        cat "${DOCUMENT_DIR}${DDDIR}.titlebar"
    else
        print "<H2>Apache Fancy Index Input Form</H2>"
    fi
fi

# set | sed -e "s/$/<BR>/g"

print "<P><H2>Attempting to modify the directory ${DOCUMENT_BASE}${DDDIR}</H2></P>"

################################################################
####	First check the password protection parameters
################################################################

EXITLEVEL="0"
chkvalue "${CON_USERID}" "User ID"
chkvalue "${CON_PASSWORD}" "Password"

################################################################
####	compare passwords
################################################################
EXITLEVEL="1"
if [[ -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.diradmin" ]]
then

rm -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}diradmin.tmp"
/usr/local/apache/bin/htpasswd -b -c -p "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}diradmin.tmp" "${CON_USERID}" "${CON_PASSWORD}" >/dev/null 2>&1
  if [[ -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}diradmin.tmp" ]]
  then

    if grep "${CON_USERID}" "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.diradmin" | head -1 | diff "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}diradmin.tmp" - > /dev/null 2>&1
    then
      print "<BR>Administrative User Verified.<BR>"
      EXITLEVEL="0"
    else
      print "<BR><STRONG>ERROR:</STRONG> Administrative login failed.<BR>"
    fi
    rm -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}diradmin.tmp"
  else
    print "<BR><STRONG>ERROR:</STRONG> Unable to compare administrative login.<BR>"
  fi

else

  print "<BR><STRONG>ERROR:</STRONG> Unable to verify administrative user.<BR>"

fi

if [[ ${EXITLEVEL} -gt 0 ]]
then

[[ -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.linkbar" ]] && cat "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.linkbar"
[[ -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.forinfo" ]] && cat "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.forinfo"

print "</BODY></HTML>"
exit

fi
################################################################
# Begin deleting contacts
################################################################

print "<P><H2>Modifying Contacts</H2></P>"

for VARVAL in `print "${QUERY_STRING}" | sed -e "s/&/	/g"`
do
  if print "${VARVAL}" | grep -i "=" > /dev/null
  then
    VAR=`print "${VARVAL%=*}" | sedit`
    VAL=`print "${VARVAL#*=}" | sedit`
    if print "${VAR}" | grep "CON_FILE_" >/dev/null 2>&1
    then
      CON_FILE=`print "${VAR}" | sed -e "s|CON_FILE_||g"`

      if [[ "_${VAL}" = "_delete" ]]
      then
        if [[ -f "${DOCUMENT_DIR}${DDDIR}${CON_FILE}" ]]
        then
          if cp "${DOCUMENT_DIR}${DDDIR}${CON_FILE}" "${DOCUMENT_DIR}${DDDIR}${CON_FILE%.*}.del"
          then
            rm -f "${DOCUMENT_DIR}${DDDIR}${CON_FILE}"
          fi
        fi

        cd "${DOCUMENT_DIR}${DDDIR}"
        find . -type d -print | grep -v "^\.$" | grep -v "^\.\.$" | cut -d"/" -f2 | while read DIRNAME
        do
          SUBDIRNAME=`print "${DIRNAME}" | cut -d"/" -f2`
          rm -f "${DOCUMENT_DIR}${DDDIR}${SUBDIRNAME}/"*".${CON_FILE}"
        done
        print "\"${DOCUMENT_DIR}${DDDIR}${CON_FILE}\" Contact deleted<BR>"
      fi

      if [[ "_${VAL}" = "_approve" ]]
      then
        if [[ -f "${DOCUMENT_DIR}${DDDIR}${CON_FILE%.*}.app" ]]
        then
          print "<BR><STRONG>ERROR</STRONG>: Unable to approve contact \"${DOCUMENT_DIR}${DDDIR}${CON_FILE}\"<BR>"
        else  
          mv "${DOCUMENT_DIR}${DDDIR}${CON_FILE}" "${DOCUMENT_DIR}${DDDIR}${CON_FILE%.*}.app"

          cd "${DOCUMENT_DIR}${DDDIR}"
          find . -type d -print | grep -v "^\.$" | grep -v "^\.\.$" | cut -d"/" -f2 | while read DIRNAME
          do

            SUBDIRNAME=`print "${DIRNAME}" | cut -d"/" -f2`
            cd "${DOCUMENT_DIR}${DDDIR}${SUBDIRNAME}"
            . "${DOCUMENT_DIR}${DDDIR}${CON_FILE%.*}.app"
 
            FRONT=""
            SORTBY_CNT="0"
            while [[ ${SORTBY_CNT} -le ${#SORTBY_DIR[*]} ]]
            do
              if [[ "_${SORTBY_DIR[${SORTBY_CNT}]}" = "_${SUBDIRNAME}" ]]
              then
                eval FRONT="\"\${${SORTBY_VAR[${SORTBY_CNT}]}}\""
                break
              fi
              SORTBY_CNT="$(( ${SORTBY_CNT} + 1 ))"
            done

            rm -f *".${CON_FILE}"
            rm -f *".${CON_FILE%.*}.app"
            ln -s "../${CON_FILE%.*}.app" "${DOCUMENT_DIR}${DDDIR}${SUBDIRNAME}/${FRONT}.${CON_FILE%.*}.app"
          done
          print "\"${DOCUMENT_DIR}${DDDIR}${CON_FILE}\" contact approved<BR>"
        fi
      fi

      CON_DIR=`dirname "${DOCUMENT_DIR}${DDDIR}${CON_FILE}"`
      rmdir "${CON_DIR}" 2>/dev/null
    fi
  fi
done

print "<P>"
print "<BR><A Href=\"${SCRIPT_CGI}/contactAddForm.cgi?${DD_DIR}\">Add another contact to the Contact List</A>"
print "<BR><A Href=\"${SCRIPT_CGI}/contactManageForm.cgi?${DD_DIR}\">Manage submitted contact</A>"
print "<BR><A href=\"${SCRIPT_CGI}/contactReindex.cgi?${DD_DIR}\">Reindex Current Contact List</A>"
print "<BR><A href=\"${DOCUMENT_BASE}${DD_DIR}\">Return to Contact List</A>"
print "</P>"

[[ -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.linkbar" ]] && cat "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.linkbar"
[[ -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.forinfo" ]] && cat "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.forinfo"

print "</BODY>
</HTML>"

