#!/bin/ksh
#############################################################
# Program:	contactManageForm.cgi
#               Copyright 1999
#
# Description:	
#
# Author:	Dana French (dfrench@aignetplex.com)
#		 
#		(405) 936-2342
#
# Date:		04/26/99
#
#############################################################
# Modifications:
#
# 04/26/99	Version: 1.0
#		Original Code
################################################################
#
# httpd Environment Variables used
#
#	DOCUMENT_ROOT		Full path to top level html dir
#	SCRIPT_NAME		CGI path to this script
#	SCRIPT_FILENAME		Full path to this script
#
################################################################
h2a()
{
  sed -e "s/%\(..\)/\`print \"ibase=16; \1\" \| bc \| awk \'\{printf\(\"%c\",\$1\)\}\'\`/g"
}
################################################################
hex2ascii()
{
  HEXTMP=`h2a`
  eval print "${HEXTMP}"
}
################################################################
sedit()
{
hex2ascii | sed -e "\
s/,/,/g;\
s/\`/\'/g;\
s/+/ /g;\
s/%2[Ff]/\//g;\
s/     / /g;\
s/    / /g;\
s/   / /g;\
s/  / /g;\
s/^ //g"
}
################################################################
chkvalue()
{
  if [[ "_${1}" = "_" ]]
  then
    print "<STRONG>ERROR:</STRONG> You did not supply a ${2}. Go back and try again.<BR>"
    EXITLEVEL="$(( ${EXITLEVEL} + 1 ))"
  else
    CHKVALUE_REMAIN=`print "${1}" | sed -e "s|[a-z,A-Z,0-9, ,\.,:]||g"`
    if [[ "_${#CHKVALUE_REMAIN}" != "_" ]]
    then
      if [[ ${#CHKVALUE_REMAIN} -eq 0 ]]
      then
        print "<I>${2}</I> checked and accepted.<BR>"
      else
        print "<STRONG>ERROR:</STRONG> Invalid ${2}. Go back and try again.<BR>"
        EXITLEVEL="$(( ${EXITLEVEL} + 1 ))"
      fi
    else
      print "<STRONG>ERROR:</STRONG> Unable to perform validity check on ${2}. Go back and try again.<BR>"
      EXITLEVEL="$(( ${EXITLEVEL} + 1 ))"
    fi
  fi
}
################################################################
# DOCUMENT_ROOT="/external/ns-home/docs"
# SCRIPT_NAME="/cgi-bin/engine/engine.cgi"
# SCRIPT_FILENAME="/external/ns-home/cgi-bin/engine/engine.cgi"

DOCUMENT_BASE="/fancyIndex/"
DOCUMENT_DIR="${DOCUMENT_ROOT}${DOCUMENT_BASE}"
SCRIPT_DIR=`dirname "${SCRIPT_FILENAME}"`
SCRIPT_CGI=`dirname "${SCRIPT_NAME}"`
SEARCHTERM=""
PWPROTECTED="0"

if [ "_${*}" = "_" ]
then
    DDDIR=""
    DD_DIR=""
else
    DDDIR=`print "${*}" | sedit`
    DD_DIR=`print "${*}" | sedit`
fi

DAYCNT="0"
for VARVAL in `print "${QUERY_STRING}" | sed -e "s/&/	/g"`
do
  if print "${VARVAL}" | grep -i "=" > /dev/null
  then
    VAR=`print "${VARVAL%=*}" | sedit`
    VAL=`print "${VARVAL#*=}" | sedit`
    eval ${VAR}="\"${VAL}\""
  fi
done

DDDIR=`print "${DDDIR}/" | sed -e "s|//$|/|g;s|^/$||g"`
DD_DIR=`print "${DDDIR}/" | sed -e "s/ /%20/g;s|//$|/|g;s|^/$||g"`

print "content-type:text/html
pragma: no-cache

<HTML>
<HEAD>
<TITLE>Apache FancyIndex - /${DDDIR}</TITLE>
</HEAD>
"

if [[ -d "${DOCUMENT_DIR}" ]]
then
    if [[ -f "${DOCUMENT_DIR}${DDDIR}.bodytag" ]]
    then
        cat "${DOCUMENT_DIR}${DDDIR}.bodytag"
    else
        print "
<BODY Bgcolor=\"white\" Text=\"black\" Link=\"blue\" Vlink=\"red\" Alink=\"yellow\">
<BASEFONT Size=\"3\" Face=\"Arial\">
"
    fi
    if [[ -s "${DOCUMENT_DIR}${DDDIR}HEADER.html" ]]
    then
        cat "${DOCUMENT_DIR}${DDDIR}HEADER.html"
    elif [[ -s "${DOCUMENT_DIR}${DDDIR}.titlebar" ]]
    then
        cat "${DOCUMENT_DIR}${DDDIR}.titlebar"
    else
        print "<H2>Apache Fancy Index Input Form</H2>"
    fi
fi

# set | sed -e "s/$/<BR>/g"

################################################################
####	First check the password protection parameters
################################################################

print "
<FORM Method=\"get\" Action=\"contactManage.cgi\">
<INPUT Type=\"hidden\" Name=\"DDDIR\" Value=\"${DDDIR}\">
"

print "
<P><HR></P>
<P>
<TABLE Border=\"0\">
<P>
  <CAPTION>
    <FONT Size=\"+2\"><STRONG>
Enter the Administrator's ID and Password for this Contact List
    </STRONG></FONT>
  </CAPTION>
</P>
<P>
  <TR>
    <TD Align=\"right\" Valign=\"top\">
      <FONT Size=\"+1\"><STRONG>
Administrator ID:
      </STRONG></FONT>
    </TD>
    <TD Align=\"left\" Valign=\"top\">
      <FONT Size=\"+1\"><STRONG>
<INPUT Type=\"text\" Name=\"CON_USERID\" Size=\"8\" Maxlength=\"8\">
      </STRONG></FONT>
<BR>
      <FONT Size=\"-1\"><I>
Enter the administrator's ID for this Contact List.  Only
the administrator for this Contact List is permitted to
approve contacts, delete contacts, or modify the look and feel.
The administrator ID can be up to 8 characters and must 
contain only letters, numbers or spaces.
      </I></FONT>
<HR>
    </TD>
  </TR>
</P>
<P>
  <TR>
    <TD Align=\"right\" Valign=\"top\">
      <FONT Size=\"+1\"><STRONG>
Password:
      </STRONG></FONT>
    </TD>
    <TD Align=\"left\" Valign=\"top\">
      <FONT Size=\"+1\"><STRONG>
<INPUT Type=\"password\" Name=\"CON_PASSWORD\" Size=\"8\" Maxlength=\"8\">
      </STRONG></FONT>
<BR>
      <FONT Size=\"-1\"><I>
Enter the administrator's password for this Contact List.  Only
the administrator for this Contact List is permitted to
approve contacts, delete contacts, or modify the look and feel.
The administrator password can be up to 8 characters and must 
contain only letters, numbers or spaces.
      </I></FONT>
<HR>
    </TD>
  </TR>
</P>
</TABLE>
</P>
"

print "<P><CENTER><H2>Contacts</H2></CENTER></P>"

print "
<P><CENTER><TABLE Border=\"1\">
<P>
  <TR>
    <TH Bgcolor="lightblue">
      <FONT Size=\"+1\" Color=\"darkblue\">
Check to Approve
      </FONT>
    </TH>
    <TH Bgcolor="lightblue">
      <FONT Size=\"+1\" Color=\"darkblue\">
Check to Delete
      </FONT>
    </TH>
    <TH Bgcolor="lightblue">
      <FONT Size=\"+1\" Color=\"darkblue\">
Contact<BR>
      </FONT>
    </TH>
    <TH Bgcolor="lightblue">
      <FONT Size=\"+1\" Color=\"darkblue\">
Company Info
      </FONT>
    </TH>
    <TH Bgcolor="lightblue">
      <FONT Size=\"+1\" Color=\"darkblue\">
Phone's/URL's
      </FONT>
    </TH>
  </TR>
</P>
"

cd "${DOCUMENT_DIR}${DDDIR}"
ls -1 "${DOCUMENT_DIR}${DDDIR}"*.sub | while read CON_FULLFILE
do

. "${CON_FULLFILE}"

CON_FILE=`print "${CON_FULLFILE}" | sed -e "s|${DOCUMENT_DIR}${DDDIR}||g"`

print "
<P>
  <TR>
    <TD>
      <FONT Size=\"1\">
 <INPUT Type=\"checkbox\" Name=\"CON_FILE_${CON_FILE}\" Value=\"approve\"> ${CON_FILE}
      </FONT>
    </TD>
    <TD>
      <FONT Size=\"1\">
 <INPUT Type=\"checkbox\" Name=\"CON_FILE_${CON_FILE}\" Value=\"delete\"> ${CON_FILE}
      </FONT>
    </TD>
    <TD>
      <FONT Size=\"3\">
<BR>${CON_LNAME}, ${CON_FNAME}
<BR>${CON_TITLE}
<BR>${CON_EMAIL}
<BR>${CON_DEPARTMENT}
      </FONT>
    </TD>
    <TD>
      <FONT Size=\"3\">
<BR>${CON_COMPANY}
<BR>${CON_ADDR1}
<BR>${CON_ADDR2}
<BR>${CON_CITY}, ${STATE}
<BR>${CON_ZIP}
      </FONT>
    </TD>
    <TD>
      <FONT Size=\"3\">
<BR>${CON_PHONE}
<BR>${CON_FAX}
<BR>${CON_REGION}
<BR>${CON_MAPURL}
<BR>${CON_DRIVEURL}
      </FONT>
    </TD>
  </TR>
</P>
"
done


print "
<P>
  <TR>
    <TH Bgcolor="lightblue">
      <FONT Size=\"+1\" Color=\"darkblue\">
&nbsp;
      </FONT>
    </TH>
    <TH Bgcolor="lightblue">
      <FONT Size=\"+1\" Color=\"darkblue\">
Check to Delete
      </FONT>
    </TH>
    <TH Bgcolor="lightblue">
      <FONT Size=\"+1\" Color=\"darkblue\">
Contact<BR>
      </FONT>
    </TH>
    <TH Bgcolor="lightblue">
      <FONT Size=\"+1\" Color=\"darkblue\">
Company Info
      </FONT>
    </TH>
    <TH Bgcolor="lightblue">
      <FONT Size=\"+1\" Color=\"darkblue\">
Phone's/URL's
      </FONT>
    </TH>
  </TR>
</P>
"

cd "${DOCUMENT_DIR}${DDDIR}"
ls -1 "${DOCUMENT_DIR}${DDDIR}"*.app | while read CON_FULLFILE
do

. "${CON_FULLFILE}"

CON_FILE=`print "${CON_FULLFILE}" | sed -e "s|${DOCUMENT_DIR}${DDDIR}||g"`

print "
<P>
  <TR>
    <TD Align=\"center\" Valign=\"middle\">
      <FONT Size=\"2\">
Approved
      </FONT>
    </TD>
    <TD>
      <FONT Size=\"1\">
 <INPUT Type=\"checkbox\" Name=\"CON_FILE_${CON_FILE}\" Value=\"delete\"> ${CON_FILE}
      </FONT>
    </TD>
    <TD>
      <FONT Size=\"3\">
<BR>${CON_LNAME}, ${CON_FNAME}
<BR>${CON_TITLE}
<BR>${CON_EMAIL}
<BR>${CON_DEPARTMENT}
      </FONT>
    </TD>
    <TD>
      <FONT Size=\"3\">
<BR>${CON_COMPANY}
<BR>${CON_ADDR1}
<BR>${CON_ADDR2}
<BR>${CON_CITY}, ${STATE}
<BR>${CON_ZIP}
      </FONT>
    </TD>
    <TD>
      <FONT Size=\"3\">
<BR>${CON_PHONE}
<BR>${CON_FAX}
<BR>${CON_REGION}
<BR>${CON_MAPURL}
<BR>${CON_DRIVEURL}
      </FONT>
    </TD>
  </TR>
</P>
"
done


print "</TABLE></CENTER></P>"

################################################################

print "
<P><CENTER>
<INPUT Type=\"submit\" Value=\"Commit Changes\">
</CENTER></P>
</FORM>"

[[ -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.linkbar" ]] && cat "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.linkbar"
[[ -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.forinfo" ]] && cat "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.forinfo"

print "</BODY>
</HTML>"

