#!/bin/ksh
#############################################################
# Program:	eventsAdd.cgi
#               Copyright 1999
#
# Description:	
#
# Author:	Dana French (dfrench@aignetplex.com)
#		 
#		(405) 936-2342
#
# Date:		04/26/99
#
#############################################################
# Modifications:
#
# 04/26/99	Version: 1.0
#		Original Code
################################################################
#
# httpd Environment Variables used
#
#	DOCUMENT_ROOT		Full path to top level html dir
#	SCRIPT_NAME		CGI path to this script
#	SCRIPT_FILENAME		Full path to this script
#
################################################################
h2a()
{
  sed -e "s/%\(..\)/\`print \"ibase=16; \1\" \| bc \| awk \'\{printf\(\"%c\",\$1\)\}\'\`/g"
}
################################################################
hex2ascii()
{
  HEXTMP=`h2a`
  eval print "${HEXTMP}"
}
################################################################
sedit()
{
hex2ascii | sed -e "\
s/,/,/g;\
s/\`/\'/g;\
s/+/ /g;\
s/%2[Ff]/\//g;\
s/     / /g;\
s/    / /g;\
s/   / /g;\
s/  / /g;\
s/^ //g"
}
################################################################
chkvalue()
{
  if [[ "_${3}" != "_NULL_OK" && "_${1}" = "_" ]]
  then
    print "<STRONG>ERROR:</STRONG> You did not supply a ${2}. Go back and try again.<BR>"
    EXITLEVEL="$(( ${EXITLEVEL} + 1 ))"
  else
    CHKVALUE_REMAIN=`print "${1}" | sed -e "s|[a-z,A-Z,0-9, ,\.,:,\,]||g"`
    if [[ "_${#CHKVALUE_REMAIN}" != "_" ]]
    then
      if [[ ${#CHKVALUE_REMAIN} -eq 0 ]]
      then
        print "<I>${2}</I> checked and accepted.<BR>"
      else
        print "<STRONG>ERROR:</STRONG> Invalid ${2}. Go back and try again.<BR>"
        EXITLEVEL="$(( ${EXITLEVEL} + 1 ))"
      fi
    else
      print "<STRONG>ERROR:</STRONG> Unable to perform validity check on ${2}. Go back and try again.<BR>"
      EXITLEVEL="$(( ${EXITLEVEL} + 1 ))"
    fi
  fi
}
################################################################
mkdotfile()
{
  print "<BR>Working on \"${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${DIRNAME}/${3}\"<BR>"
  cd "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${DIRNAME}"
  if [[ "_${1}" = "_1" ]]
  then
    print "Checking existance of \"${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${DIRNAME}/${3}\"<BR>"
    if [[ -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${DIRNAME}/${3}" ]]
    then
      print "Removing \"${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${DIRNAME}/${3}\"<BR>"
      rm -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${DIRNAME}/${3}"
    fi
  elif [[ "_${2}" = "_1" ]]
  then
    print "Checking existance of \"${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${DIRNAME}/${3}\"<BR>"
    if [[ -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${DIRNAME}/${3}" ]]
    then
      print "Removing \"${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${DIRNAME}/${3}\"<BR>"
      rm -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${DIRNAME}/${3}"
    fi
    print "Linking \"../${3}\" to \"./${3}\"<BR>"
    ln -s "../${3}" "./${3}"
  else
    print "Creating \"${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${DIRNAME}/${3}\"<BR>"
    print "${VAL}" | tr '\015' '\012' > "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${DIRNAME}/${3}"
  fi
}
################################################################
# DOCUMENT_ROOT="/external/ns-home/docs"
# SCRIPT_NAME="/cgi-bin/engine/engine.cgi"
# SCRIPT_FILENAME="/external/ns-home/cgi-bin/engine/engine.cgi"

DOCUMENT_BASE="/fancyIndex/"
DOCUMENT_DIR="${DOCUMENT_ROOT}${DOCUMENT_BASE}"
SCRIPT_DIR=`dirname "${SCRIPT_FILENAME}"`
SCRIPT_CGI=`dirname "${SCRIPT_NAME}"`
SEARCHTERM=""
PWPROTECTED="0"
EC_URL=""
EC_COMMENT=""

if [ "_${*}" = "_" ]
then
    DDDIR=""
    DD_DIR=""
else
    DDDIR=`print "${*}" | sedit`
    DD_DIR=`print "${*}" | sedit`
fi

DAYCNT="0"
for VARVAL in `print "${QUERY_STRING}" | sed -e "s/&/	/g"`
do
  if print "${VARVAL}" | grep -i "=" > /dev/null
  then
    VAR=`print "${VARVAL%=*}" | sedit`
    VAL=`print "${VARVAL#*=}" | sedit`
    eval ${VAR}="\"${VAL}\""
    if [[ "_${VAR}" = "_EC_DAYS" ]]
    then
        EC_DAYLIST[${DAYCNT}]="${VAL}"
        DAYCNT="$(( ${DAYCNT} + 1 ))"
    fi
  fi
done

DDDIR=`print "${DDDIR}/" | sed -e "s|//$|/|g;s|^/$||g"`
DD_DIR=`print "${DDDIR}/" | sed -e "s/ /%20/g;s|//$|/|g;s|^/$||g"`

print "content-type:text/html
pragma: no-cache

<HTML>
<HEAD>
<TITLE>Apache FancyIndex - /${DDDIR}</TITLE>
</HEAD>
"

if [[ -d "${DOCUMENT_DIR}" ]]
then
    if [[ -f "${DOCUMENT_DIR}${DDDIR}.bodytag" ]]
    then
        cat "${DOCUMENT_DIR}${DDDIR}.bodytag"
    else
        print "
<BODY Bgcolor=\"white\" Text=\"black\" Link=\"blue\" Vlink=\"red\" Alink=\"yellow\">
<BASEFONT Size=\"3\" Face=\"Arial\">
"
    fi
    if [[ -s "${DOCUMENT_DIR}${DDDIR}HEADER.html" ]]
    then
        cat "${DOCUMENT_DIR}${DDDIR}HEADER.html"
    elif [[ -s "${DOCUMENT_DIR}${DDDIR}.titlebar" ]]
    then
        cat "${DOCUMENT_DIR}${DDDIR}.titlebar"
    else
        print "<H2>Apache Fancy Index Input Form</H2>"
    fi
fi

# set | sed -e "s/$/<BR>/g"

print "<P><H2>Attempting to create the directory ${DOCUMENT_BASE}${DDDIR}${DIRNAME}</H2></P>"

################################################################
####	First check the password protection parameters
################################################################

EXITLEVEL="0"
chkvalue "${EC_NAME}" "Event Name"
chkvalue "${EC_COMMENT}" "Event Description" "NULL_OK"
if [[ "_${EC_URL}" != "_" ]]
then
  print "<I>Event URL</I> checked and accepted.<BR>"
fi
chkvalue "${EC_YEAR}" "Year"
chkvalue "${EC_MONTH}" "Month"
chkvalue "${EC_DAYS}" "Day"
chkvalue "${EC_SHOUR}" "Start Hour"
chkvalue "${EC_SMINUTE}" "Start Minute"
chkvalue "${EC_EHOUR}" "End Hour"
chkvalue "${EC_EMINUTE}" "End Minute"

if [[ ${EXITLEVEL} -gt 0 ]]
then
  print "</BODY></HTML>"
  exit
fi

DAYCNT="${#EC_DAYLIST[*]}"

print "DAYCNT=${DAYCNT}<br>"

LISTCNT="0"
OUTNAME="`date +'%Y%m%d%H%M%S'`${$}"
while [[ ${LISTCNT} -lt ${DAYCNT} ]]
do
  DATEDIR="${EC_YEAR}-${EC_MONTH}-${EC_DAYLIST[${LISTCNT}]}"
  print "Working on ${DATEDIR}<BR>"
  if [[ ! -d "${DOCUMENT_DIR}${DDDIR}${DIRNAME}${DATEDIR}" ]]
  then 
    if mkdir "${DOCUMENT_DIR}${DDDIR}${DIRNAME}${DATEDIR}" 2>&1
    then
      print "${DATEDIR} directory created successfully<BR>"
    fi
  fi

  OUTFILE="${DOCUMENT_DIR}${DDDIR}${DIRNAME}${DATEDIR}/${OUTNAME}.sub"

> ${OUTFILE}
  print "EC_NAME=\"${EC_NAME}\"" >> ${OUTFILE}
  print "EC_COMMENT=\"${EC_COMMENT}\"" >> ${OUTFILE}
  print "EC_URL=\"${EC_URL}\"" >> ${OUTFILE}
  print "EC_YEAR=\"${EC_YEAR}\"" >> ${OUTFILE}
  print "EC_MONTH=\"${EC_MONTH}\"" >> ${OUTFILE}
  print "EC_DAY=\"${EC_DAYLIST[${LISTCNT}]}\"" >> ${OUTFILE}
  print "EC_SHOUR=\"${EC_SHOUR}\"" >> ${OUTFILE}
  print "EC_SMINUTE=\"${EC_SMINUTE}\"" >> ${OUTFILE}
  print "EC_EHOUR=\"${EC_EHOUR}\"" >> ${OUTFILE}
  print "EC_EMINUTE=\"${EC_EMINUTE}\"" >> ${OUTFILE}

  LISTCNT="$(( ${LISTCNT} + 1 ))"
done        

print "<P><STRONG>Event Submitted</STRONG>: Administrator must approve 
this event before it will appear on the calendar.</P>"

if [[ -s "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.admin" ]]
then
    EC_EMAIL=""
    . "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.admin"
    if [[ "_${EC_EMAIL}" != "_" ]]
    then

print "
An event has been submitted to your events calendar at:

http://`uname -n`${DOCUMENT_BASE}${DD_DIR}

As the administrator of this calendar, you must approve,
disapprove, or remove any submitted events before they
will appear on the calendar.
" | mail -s "Event submitted to your calendar" "${EC_EMAIL}"

print "<P><STRONG>Notification Sent</STRONG>: The administrator
of this calendar has been sent notification that an event
has been submitted.</P>"

    fi
fi

print "<P>"
print "<BR><A Href=\"${SCRIPT_CGI}/eventsAddForm.cgi?${DD_DIR}\">Add another Event to the Events Calendar</A>"
print "<BR><A Href=\"${SCRIPT_CGI}/eventsManageForm.cgi?${DD_DIR}\">Manage submitted events</A>"
print "<BR><A href=\"${SCRIPT_CGI}/eventsReindex.cgi?${DD_DIR}\">Reindex Current Events Calendar</A>"
print "<BR><A href=\"${DOCUMENT_BASE}${DD_DIR}\">Return to Events Calendar</A>"
print "</P>"

[[ -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.linkbar" ]] && cat "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.linkbar"
[[ -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.forinfo" ]] && cat "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.forinfo"

print "</BODY>
</HTML>"


