#!/bin/ksh
#############################################################
# Program:	itemManage.cgi
#               Copyright 1999
#
# Description:	
#
# Author:	Dana French (dfrench@aignetplex.com)
#		 
#		(405) 936-2342
#
# Date:		04/26/99
#
#############################################################
# Modifications:
#
# 04/26/99	Version: 1.0
#		Original Code
################################################################
#
# httpd Environment Variables used
#
#	DOCUMENT_ROOT		Full path to top level html dir
#	SCRIPT_NAME		CGI path to this script
#	SCRIPT_FILENAME		Full path to this script
#
################################################################
h2a()
{
  sed -e "s/%\(..\)/\`print \"ibase=16; \1\" \| bc \| awk \'\{printf\(\"%c\",\$1\)\}\'\`/g"
}
################################################################
hex2ascii()
{
  HEXTMP=`h2a`
  eval print "${HEXTMP}"
}
################################################################
sedit()
{
hex2ascii | sed -e "\
s/,/,/g;\
s/\`/\'/g;\
s/+/ /g;\
s/%2[Ff]/\//g;\
s/     / /g;\
s/    / /g;\
s/   / /g;\
s/  / /g;\
s/^ //g"
}
################################################################
chkvalue()
{
  if [[ "_${1}" = "_" ]]
  then
    print "<STRONG>ERROR:</STRONG> You did not supply a ${2}. Go back and try again.<BR>"
    EXITLEVEL="$(( ${EXITLEVEL} + 1 ))"
  else
    CHKVALUE_REMAIN=`print "${1}" | sed -e "s|[a-z,A-Z,0-9, ]||g"`
    if [[ "_${#CHKVALUE_REMAIN}" != "_" ]]
    then
      if [[ ${#CHKVALUE_REMAIN} -eq 0 ]]
      then
        print "<I>${2}</I> checked and accepted.<BR>"
      else
        print "<STRONG>ERROR:</STRONG> Invalid ${2}. Go back and try again.<BR>"
        EXITLEVEL="$(( ${EXITLEVEL} + 1 ))"
      fi
    else
      print "<STRONG>ERROR:</STRONG> Unable to perform validity check on ${2}. Go back and try again.<BR>"
      EXITLEVEL="$(( ${EXITLEVEL} + 1 ))"
    fi
  fi
}

################################################################
mkdotfile()
{
  print "<BR>Working on \"${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${3}\"<BR>"
  cd "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}"
  if [[ "${1}" = "_1" ]]
  then
    print "Checking existance of \"${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${3}\"<BR>"
    if [[ -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${3}" ]]
    then
      print "Removing \"${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${3}\"<BR>"
      rm -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${3}"
    fi
  elif [[ "${2}" = "_1" ]]
  then
    print "Checking existance of \"${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${3}\"<BR>"
    if [[ -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${3}" ]]
    then
      print "Removing \"${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${3}\"<BR>"
      rm -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${3}"
    fi
    print "Linking \"../${3}\" to \"./${3}\"<BR>"
    ln -s "../${3}" "./${3}"
  else
    print "Creating \"${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${3}\"<BR>"
    print "${VAL}" | tr '\015' '\012' > "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${3}"
  fi
}
################################################################
# DOCUMENT_ROOT="/external/ns-home/docs"
# SCRIPT_NAME="/cgi-bin/engine/engine.cgi"
# SCRIPT_FILENAME="/external/ns-home/cgi-bin/engine/engine.cgi"

DOCUMENT_BASE="/fancyIndex/"
DOCUMENT_DIR="${DOCUMENT_ROOT}${DOCUMENT_BASE}"
SCRIPT_DIR=`dirname "${SCRIPT_FILENAME}"`
SCRIPT_CGI=`dirname "${SCRIPT_NAME}"`
SEARCHTERM=""
PWPROTECTED="0"

if [ "_${*}" = "_" ]
then
    DDDIR=""
    DD_DIR=""
else
    DDDIR=`print "${*}" | sedit`
    DD_DIR=`print "${*}" | sedit`
fi

for VARVAL in `print "${QUERY_STRING}" | sed -e "s/&/	/g"`
do
  if print "${VARVAL}" | grep -i "=" > /dev/null
  then
    VAR=`print "${VARVAL%=*}" | sedit`
    VAL=`print "${VARVAL#*=}" | sedit`
    eval ${VAR}="\"${VAL}\""
  fi
done

DDDIR=`print "${DDDIR}/" | sed -e "s|//$|/|g;s|^/$||g"`
DD_DIR=`print "${DDDIR}/" | sed -e "s/ /%20/g;s|//$|/|g;s|^/$||g"`

print "content-type:text/html
pragma: no-cache

<HTML>
<HEAD>
<TITLE>Apache FancyIndex - /${DDDIR}</TITLE>
</HEAD>
"

if [[ -d "${DOCUMENT_DIR}" ]]
then
    if [[ -f "${DOCUMENT_DIR}${DDDIR}.bodytag" ]]
    then
        cat "${DOCUMENT_DIR}${DDDIR}.bodytag"
    else
        print "
<BODY Bgcolor=\"white\" Text=\"black\" Link=\"blue\" Vlink=\"red\" Alink=\"yellow\">
<BASEFONT Size=\"3\" Face=\"Arial\">
"
    fi
    if [[ -s "${DOCUMENT_DIR}${DDDIR}HEADER.html" ]]
    then
        cat "${DOCUMENT_DIR}${DDDIR}HEADER.html"
    elif [[ -s "${DOCUMENT_DIR}${DDDIR}.titlebar" ]]
    then
        cat "${DOCUMENT_DIR}${DDDIR}.titlebar"
    else
        print "<H2>Apache Fancy Index Input Form</H2>"
    fi
fi

# set | sed -e "s/$/<BR>/g"

print "<P><H2>Modifying Item Catalog</H2></P>"

################################################################
####	First check the password protection parameters
################################################################

EXITLEVEL="0"
chkvalue "${ITM_USERID}" "User ID"
chkvalue "${ITM_PASSWORD}" "Password"

################################################################
####	begin comparing passwords
################################################################
EXITLEVEL="1"
if [[ -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.diradmin" ]]
then

rm -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}diradmin.tmp"
/usr/local/apache/bin/htpasswd -b -c -p "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}diradmin.tmp" "${ITM_USERID}" "${ITM_PASSWORD}" >/dev/null 2>&1
  if [[ -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}diradmin.tmp" ]]
  then
    if grep "${ITM_USERID}" "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.diradmin" | head -1 | diff - "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}diradmin.tmp" > /dev/null 2>&1
    then
      print "<BR>Administrative User Verified.<BR>"
      EXITLEVEL="0"
    else
      print "<BR><STRONG>ERROR:</STRONG> Administrative login failed.<BR>"
    fi
    rm -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}diradmin.tmp"
  else
    print "<BR><STRONG>ERROR:</STRONG> Unable to compare administrative login.<BR>"
  fi

else

  print "<BR><STRONG>ERROR:</STRONG> Unable to verify administrative user.<BR>"

fi

if [[ ${EXITLEVEL} -gt 0 ]]
then

[[ -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.linkbar" ]] && cat "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.linkbar"
[[ -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.forinfo" ]] && cat "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.forinfo"

print "</BODY></HTML>"
exit

fi
################################################################
####	end comparing passwords
################################################################
	
################################################################
#    begin updating item catalog
################################################################

for VARVAL in `print "${QUERY_STRING}" | sed -e "s/&/	/g"`
do
  if print "${VARVAL}" | grep -i "=" > /dev/null
  then
    VAR=`print "${VARVAL%=*}" | sedit`
    VAL=`print "${VARVAL#*=}" | sedit`
    if print "${VAR}" | grep "ITM_FILE_" >/dev/null 2>&1
    then
      ITM_FILE=`print "${VAR}" | sed -e "s|ITM_FILE_||g"`

      if [[ "_${VAL}" = "_delete" ]]
      then
        if [[ -f "${DOCUMENT_DIR}${DDDIR}${ITM_FILE%.*}.del" ]]
        then
          rm -f "${DOCUMENT_DIR}${DDDIR}${ITM_FILE%.*}.del"
        fi
        mv "${DOCUMENT_DIR}${DDDIR}${ITM_FILE}" "${DOCUMENT_DIR}${DDDIR}${ITM_FILE%.*}.del"
        print "\"${DOCUMENT_DIR}${DDDIR}${ITM_FILE}\" item deleted<BR>"
      fi

      if [[ "_${VAL}" = "_approve" ]]
      then
        if [[ -f "${DOCUMENT_DIR}${DDDIR}${ITM_FILE%.*}.app" ]]
        then
          print "<BR><STRONG>ERROR</STRONG>: Unable to approve item \"${DOCUMENT_DIR}${DDDIR}${ITM_FILE}\"<BR>"
        else  
          mv "${DOCUMENT_DIR}${DDDIR}${ITM_FILE}" "${DOCUMENT_DIR}${DDDIR}${ITM_FILE%.*}.app"
          print "\"${DOCUMENT_DIR}${DDDIR}${ITM_FILE}\" item approved<BR>"
        fi
      fi

      if [[ "_${VAL}" = "_unapprove" ]]
      then
        if [[ -f "${DOCUMENT_DIR}${DDDIR}${ITM_FILE%.*}.sub" ]]
        then
          print "<BR><STRONG>ERROR</STRONG>: Unable to unapprove item \"${DOCUMENT_DIR}${DDDIR}${ITM_FILE}\"<BR>"
        else
          mv "${DOCUMENT_DIR}${DDDIR}${ITM_FILE}" "${DOCUMENT_DIR}${DDDIR}${ITM_FILE%.*}.sub"
          print "\"${DOCUMENT_DIR}${DDDIR}${ITM_FILE}\" item unapproved<BR>"
        fi
      fi

      if [[ "_${VAL}" = "_feature" ]]
      then
        if [[ -f "${DOCUMENT_DIR}${DDDIR}FEATURE.app" ]]
        then
          . "${DOCUMENT_DIR}${DDDIR}FEATURE.app"
          cp "${DOCUMENT_DIR}${DDDIR}FEATURE.app" "${DOCUMENT_DIR}${DDDIR}${ITM_ID}.app"
          if cp "${DOCUMENT_DIR}${DDDIR}FEATURE.app" "${DOCUMENT_DIR}${DDDIR}${ITM_ID}.app"
          then
              rm -f "${DOCUMENT_DIR}${DDDIR}FEATURE.app"
          fi          
        fi
        if [[ -f "${DOCUMENT_DIR}${DDDIR}FEATURE.sub" ]]
        then
          . "${DOCUMENT_DIR}${DDDIR}FEATURE.sub"
          if cp "${DOCUMENT_DIR}${DDDIR}FEATURE.sub" "${DOCUMENT_DIR}${DDDIR}${ITM_ID}.sub"
          then
              rm -f "${DOCUMENT_DIR}${DDDIR}FEATURE.sub"
          fi          
        fi
        mv "${DOCUMENT_DIR}${DDDIR}${ITM_FILE}" "${DOCUMENT_DIR}${DDDIR}FEATURE.app"
        print "\"${DOCUMENT_DIR}${DDDIR}${ITM_FILE}\" item selected as FEATURE<BR>"
      fi

      if [[ "_${VAL}" = "_purge" ]]
      then
        rm -f "${DOCUMENT_DIR}${DDDIR}${ITM_FILE}"
        print "\"${DOCUMENT_DIR}${DDDIR}${ITM_FILE}\" item purged<BR>"
      fi

    fi
  fi
done

print "<P>"
print "<BR><A Href=\"${SCRIPT_CGI}/itemAddForm.cgi?${DD_DIR}\">Add another item</A>"
print "<BR><A Href=\"${SCRIPT_CGI}/itemManageForm.cgi?${DD_DIR}\">Manage items</A>"
print "<BR><A href=\"${SCRIPT_CGI}/itemReindex.cgi?${DD_DIR}\">Reindex items</A>"
print "<BR><A href=\"${DOCUMENT_BASE}${DD_DIR}\">Return to Item Catalog</A>"
print "</P>"

[[ -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.linkbar" ]] && cat "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.linkbar"
[[ -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.forinfo" ]] && cat "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.forinfo"

print "</BODY>
</HTML>"

