#!/bin/ksh
#############################################################
# Program:	itemReindex.cgi
#               Copyright 1999
#
# Description:	
#
# Author:	Dana French (dfrench@aignetplex.com)
#		 
#		(405) 936-2342
#
# Date:		04/26/99
#
#############################################################
# Modifications:
#
# 04/26/99	Version: 1.0
#		Original Code
################################################################
#
# httpd Environment Variables used
#
#	DOCUMENT_ROOT		Full path to top level html dir
#	SCRIPT_NAME		CGI path to this script
#	SCRIPT_FILENAME		Full path to this script
#
################################################################
h2a()
{
  sed -e "s/%\(..\)/\`print \"ibase=16; \1\" \| bc \| awk \'\{printf\(\"%c\",\$1\)\}\'\`/g"
}
################################################################
hex2ascii()
{
  HEXTMP=`h2a`
  eval print "${HEXTMP}"
}
################################################################
sedit()
{
hex2ascii | sed -e "\
s/,/,/g;\
s/\`/\'/g;\
s/+/ /g;\
s/%2[Ff]/\//g;\
s/     / /g;\
s/    / /g;\
s/   / /g;\
s/  / /g;\
s/^ //g"
}
################################################################
DOCUMENT_ROOT="/home/httpd/html"
# SCRIPT_NAME="/cgi-bin/fancyIndex/itemReindex.cgi"
# SCRIPT_FILENAME="/external/ns-home/cgi-bin/fancyIndex/itemReindex.cgi"

DOCUMENT_BASE="/fancyIndex/"
DOCUMENT_DIR="${DOCUMENT_ROOT}${DOCUMENT_BASE}"
SCRIPT_DIR=`dirname "${SCRIPT_FILENAME}"`
SCRIPT_CGI=`dirname "${SCRIPT_NAME}"`
SEARCHTERM=""

if [ "_${*}" = "_" ]
then
    DDDIR=""
    DD_DIR=""
else
    DDDIR=`print "${*}" | sedit`
    DD_DIR=`print "${*}" | sedit`
fi

for VARVAL in `print "${QUERY_STRING}" | sed -e "s/&/	/g"`
do
  if print "${VARVAL}" | grep -i "=" > /dev/null
  then
    VAR=`print "${VARVAL%=*}" | sedit`
    VAL=`print "${VARVAL#*=}" | sedit`
    eval ${VAR}="\"${VAL}\""
  fi
done

DDDIR=`print "${DDDIR}/" | sed -e "s|//$|/|g;s|^/$||g"`
DD_DIR=`print "${DDDIR}/" | sed -e "s/ /%20/g;s|//$|/|g;s|^/$||g"`

print "content-type:text/html
pragma: no-cache

<HTML>
<HEAD>
<TITLE>Apache FancyIndex - /${DDDIR}</TITLE>
</HEAD>
<BODY>
"

################################################################
# [[ -f "${DOCUMENT_DIR}${DDDIR}.titlebar" ]] && cat "${DOCUMENT_DIR}${DDDIR}.titlebar" | tee "${DOCUMENT_DIR}${DDDIR}HEADER.html"
# [[ -f "${DOCUMENT_DIR}${DDDIR}.linkbar" ]] && cat "${DOCUMENT_DIR}${DDDIR}.linkbar" | tee -a >> "${DOCUMENT_DIR}${DDDIR}HEADER.html"

# original .titlebar [[ -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.titlebar" ]] && cat "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.titlebar" | tee "${DOCUMENT_DIR}${DDDIR}HEADER.html"

rm -f "${DOCUMENT_DIR}${DDDIR}HEADER.html"
if [[ -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.titlebar" ]]
then
    SUBTITLE=`basename "/${DDDIR}"`
    sed -e "s|<!-- Begin subtitle -->.*<!-- End subtitle -->|<!-- Begin subtitle -->${SUBTITLE}<!-- End subtitle -->|" "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.titlebar" | tee "${DOCUMENT_DIR}${DDDIR}HEADER.html"
fi

[[ -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.linkbar" ]] && cat "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.linkbar" | tee -a >> "${DOCUMENT_DIR}${DDDIR}HEADER.html"
################################################################

print "
<!-- Begin directories -->
<P><BLOCKQUOTE><FONT Size=\"+1\"><STRONG>
" | tee -a "${DOCUMENT_DIR}${DDDIR}HEADER.html"

cd "${DOCUMENT_DIR}${DDDIR}"
URLPATH="${DOCUMENT_BASE}"
pwd | sed -e "s|${DOCUMENT_ROOT}||g;s|^/||g;s|/$||g" | tr '/' '\012' | while read DIR
do
    if [[ "_${DIR}" = "_fancyIndex" ]]
    then

      print "<A Href=\"${URLPATH}\"> Home </A>" | tee -a "${DOCUMENT_DIR}${DDDIR}HEADER.html"

    else

      URLPATH=`print "${URLPATH}${DIR}/" | sed -e "s/ /%20/g;s/	/%20/g"`
      print " : <A Href=\"${URLPATH}\"> ${DIR} </A>" | tee -a "${DOCUMENT_DIR}${DDDIR}HEADER.html"

    fi

  done

  print "
</STRONG></FONT></BLOCKQUOTE></P>
<!-- End directories -->
" | tee -a "${DOCUMENT_DIR}${DDDIR}HEADER.html"

################################################################
# [[ -f "${DOCUMENT_DIR}${DDDIR}.description" ]] && cat "${DOCUMENT_DIR}${DDDIR}.description" | tee -a "${DOCUMENT_DIR}${DDDIR}HEADER.html"
[[ -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.description" ]] && cat "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.description" | tee -a "${DOCUMENT_DIR}${DDDIR}HEADER.html"
################################################################


################################################################
# Begin inserting item catalog
################################################################

print "<HTML>
<HEAD>
<TITLE>`basename "${DDDIR}"` Item Catalog</TITLE>
</HEAD>
<BODY>
" | tee ./itemCatalog.html

print "
<P>
<CENTER>
<TABLE Border=\"3\" Width=\"100%\">
<P>
  <CAPTION>
    <FONT Size=\"+2\"><STRONG>
" | tee -a ./itemCatalog.html

basename "${DDDIR}" | tee -a itemCatalog.html

print "
    </STRONG></FONT>
  </CAPTION>
</P>
" | tee -a itemCatalog.html

cd "${DOCUMENT_DIR}${DDDIR}"
COLS=`ls -1d */ | wc -l`
[[ ${COLS} -eq 0 ]] && COLS="1"
SIZE=`print "100/${COLS}" | bc`

    print "
<P>
  <TR>
    <TD Bgcolor=\"white\" Align=\"center\" Valign=\"middle\" Colspan=\"${COLS}\">
      <FONT Size=\"+2\" Color=\"black\">
" | tee -a itemCatalog.html

    if [[ -s "./FEATURE.app" ]]
    then
        . "./FEATURE.app"
        if [[ "_${ITM_URL}" != "_" ]]
        then
            print "<A Href=\"${ITM_URL}\">${ITM_NAME}</A><BR>${ITM_COMMENT}" | tee -a itemCatalog.html
        else
            print "${ITM_NAME}<BR>${ITM_COMMENT}" | tee -a itemCatalog.html
        fi
    fi

    print "
      </FONT>
    </TD>
  </TR>
</P>
<P>
  <TR>
" | tee -a itemCatalog.html


ls -1d */ | while read DIRNAME
do
    print "
    <TD Bgcolor=\"lightblue\" Align=\"center\" Valign=\"middle\" Size=\"${SIZE}%\">
      <FONT Size=\"+1\" Color=\"darkblue\">
" | tee -a itemCatalog.html

    HREF=`print "${DOCUMENT_BASE}${DD_DIR}${DIRNAME}/itemCatalog.html" | sed -e "s| |%20|g"`
    print "<A Href=\"${HREF}\">" | tee -a itemCatalog.html
    basename "${DIRNAME%/*}" | tee -a itemCatalog.html
    print "</A>" | tee -a itemCatalog.html

print "
      </FONT>
    </TD>
" | tee -a itemCatalog.html
done

print "
  </TR>
</P>
<P>
  <TR>
" | tee -a itemCatalog.html

ls -1d */ | while read DIRNAME
do
    print "
    <TD Bgcolor=\"white\" Align=\"center\" Valign=\"middle\" Size=\"${SIZE}%\">
      <FONT Size=\"+1\" Color=\"black\">
" | tee -a itemCatalog.html
    if [[ -s "${DIRNAME}/FEATURE.app" ]]
    then
        . "${DIRNAME}/FEATURE.app"
        if [[ "_${ITM_URL}" != "_" ]]
        then
            print "<A Href=\"${ITM_URL}\">${ITM_NAME}</A><BR>${ITM_COMMENT}" | tee -a itemCatalog.html
        else
            print "${ITM_NAME}<BR>${ITM_COMMENT}" | tee -a itemCatalog.html
        fi
    fi
    print "
      </FONT>
    </TD>
" | tee -a itemCatalog.html
done

print "
  </TR>
</P>
<P>
  <TR>
" | tee -a itemCatalog.html

ls -1d */ | while read DIRNAME
do
    print "
    <TD Bgcolor=\"white\" Align=\"left\" Valign=\"top\" Size=\"${SIZE}%\">
      <FONT Size=\"+1\" Color=\"black\">
" | tee -a itemCatalog.html

    ls -1 "${DIRNAME}/"*.app | grep -v "FEATURE.app" | while read APPNAME
    do
        . "${APPNAME}"
        if [[ "_${ITM_URL}" != "_" ]]
        then
            print "<A Href=\"${ITM_URL}\">${ITM_NAME}</A>: ${ITM_COMMENT}<BR>" | tee -a itemCatalog.html
        else
            print "${ITM_NAME}: ${ITM_COMMENT}<BR>" | tee -a itemCatalog.html
        fi
    done

    ls -1d ${DIRNAME}/*/ | while read SUBNAME
    do
        HREF=`print "${DOCUMENT_BASE}${DD_DIR}${SUBNAME}/itemCatalog.html" | sed -e "s| |%20|g"`
        print "<A Href=\"${HREF}\">" | tee -a itemCatalog.html
        basename "${SUBNAME}" | tee -a itemCatalog.html
        print "</A>:<BR>" | tee -a itemCatalog.html
    done

    print "
      </FONT>
    </TD>
" | tee -a itemCatalog.html
done

DIRCNT=`ls -1d */ | wc -l`
if [[ ${DIRCNT} -eq 0 ]]
then
    print "
    <TD Bgcolor=\"white\" Align=\"left\" Valign=\"top\" Size=\"${SIZE}%\">
      <FONT Size=\"+1\" Color=\"black\">
" | tee -a itemCatalog.html

    ls -1 *.app | grep -v "FEATURE.app" | while read APPNAME
    do
        . "./${APPNAME}"
        if [[ "_${ITM_URL}" != "_" ]]
        then
            print "<A Href=\"${ITM_URL}\">${ITM_NAME}</A>: ${ITM_COMMENT}<BR>" | tee -a itemCatalog.html
        else
            print "${ITM_NAME}: ${ITM_COMMENT}<BR>" | tee -a itemCatalog.html
        fi
    done

    print "
      </FONT>
    </TD>
" | tee -a itemCatalog.html

fi


print "
  </TR>
</P>
</TABLE>
</CENTER>
</P>
" | tee -a itemCatalog.html

print "</BODY>
</HTML>
" | tee -a ./itemCatalog.html



################################################################
# end inserting item catalog
################################################################

print "
<P><B>Links:</B><BR>
<P><CENTER><TABLE Border=\"0\" Cellpadding=\"2\" Cellspacing=\"2\" Width=\"100%\">
" | tee "${DOCUMENT_DIR}${DDDIR}README.html"

rm -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.index"
cd "${DOCUMENT_DIR}${DDDIR}"
ls -1 *.url 2>/dev/null | while read LINKNAME
do
  if [[ "_${LINKNAME}" != "_" ]]
  then
    URL_LINK=""
    URL_NAME=""
    URL_DESC=""

    [[ ! -x "./${LINKNAME}" ]] && chmod 775 "./${LINKNAME}"
    . "./${LINKNAME}"

    if [[ "_${URL_LINK}" != "_" ]]
    then
      if [[ "_${URL_NAME}" != "_" ]]
      then
        if [[ "_${URL_DESC}" != "_" ]]
        then
print "${URL_NAME}|${URL_LINK}|${URL_DESC}" >> "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.index"
        fi
      fi
    fi
  fi

done

# if [[ -s "${DOCUMENT_DIR}${DDDIR}.index" ]]
if [[ -s "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.index" ]]
then

sed -e "s/|\(.*\)$/FIELDPIPE01\1/g\
;s/|\(.*\)$/FIELDPIPE02\1/g\
;s|^\(.*\)FIELDPIPE01\(.*\)FIELDPIPE02\(.*\)$|<P><TR><TD Width=\"20%\" Align=\"left\" Valign=\"middle\"><FONT Size=\"-1\"><A Href=\"\2\">\1</A>:</FONT></TD><TD><FONT Size=\"-1\">\3</FONT></TD></TR></P>|g\
;s|<A Href=\"\">\(.*\)</A>:|<A Href=\"${DOCUMENT_BASE}${DD_DIR}\1\">\1</A>:|g" < "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.index" | tee -a "${DOCUMENT_DIR}${DDDIR}README.html"

fi

if [[ -s "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.index" ]] \
&& [[ -s "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.links" ]]
then

print "
<P><TR><TD Width=\"20%\" Align=\"left\" Valign=\"middle\">
<FONT Size=\"-1\"><HR></FONT>
</TD><TD>
<FONT Size=\"-1\"><HR></FONT>
</TD></TR></P>
" | tee -a "${DOCUMENT_DIR}${DDDIR}README.html"

fi


# if [[ -s "${DOCUMENT_DIR}${DDDIR}.links" ]]
if [[ -s "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.links" ]]
then

sed -e "s/|\(.*\)$/FIELDPIPE01\1/g\
;s/|\(.*\)$/FIELDPIPE02\1/g\
;s|^\(.*\)FIELDPIPE01\(.*\)FIELDPIPE02\(.*\)$|<P><TR><TD Width=\"20%\" Align=\"left\" Valign=\"middle\"><FONT Size=\"-1\"><A Href=\"\2\">\1</A>:</FONT></TD><TD><FONT Size=\"-1\">\3</FONT></TD></TR></P>|g\
;s|<A Href=\"\">\(.*\)</A>:|<A Href=\"${DOCUMENT_BASE}${DD_DIR}\1\">\1</A>:|g" < "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.links" | tee -a "${DOCUMENT_DIR}${DDDIR}README.html"

fi

print "</TABLE></CENTER></P>" | tee -a "${DOCUMENT_DIR}${DDDIR}README.html"

# [[ -f "${DOCUMENT_DIR}${DDDIR}.linkbar" ]] && cat "${DOCUMENT_DIR}${DDDIR}.linkbar" | tee -a "${DOCUMENT_DIR}${DDDIR}README.html"
# [[ -f "${DOCUMENT_DIR}${DDDIR}.forinfo" ]] && cat "${DOCUMENT_DIR}${DDDIR}.forinfo" | tee -a "${DOCUMENT_DIR}${DDDIR}README.html"
[[ -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.linkbar" ]] && cat "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.linkbar" | tee -a "${DOCUMENT_DIR}${DDDIR}README.html"
[[ -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.forinfo" ]] && cat "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.forinfo" | tee -a "${DOCUMENT_DIR}${DDDIR}README.html"

################################################################
####  subdir htaccess file creation
####  and parent dir htaccess file modification
################################################################

# [[ -f "${DOCUMENT_DIR}${DDDIR}.htaccessrc" ]] && cat "${DOCUMENT_DIR}${DDDIR}.htaccessrc" > "${DOCUMENT_DIR}${DDDIR}.htaccess"
[[ -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.htaccessrc" ]] && cat "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.htaccessrc" > "${DOCUMENT_DIR}${DDDIR}.htaccess"

cd "${DOCUMENT_DIR}${DDDIR}"
ls -1 *.desc 2>/dev/null | while read FILENAME
do
  if [[ "_${FILENAME}" != "_" ]]
  then
    FILE_LINK=""
    FILE_NAME=""
    FILE_DESC=""

    [[ ! -x "./${FILENAME}" ]] && chmod 775 "./${FILENAME}"
    . "./${FILENAME}" 2>&1

    if [[ "_${FILE_NAME}" != "_" ]]
    then
      if [[ "_${FILE_DESC}" != "_" ]]
      then
print "AddDescription \"${FILE_DESC}\" \"${FILE_NAME}\"" >> "${DOCUMENT_DIR}${DDDIR}.htaccess"
      fi
    fi
  fi

done

################################################################

# cd "${DOCUMENT_DIR}${DDDIR}"
cd "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}"
# ls -a1 .DD_* | while read DIR
ls -a1 */.shortdescription 2>/dev/null | while read DIR
do
    DD_DESC=`cat "${DIR}"`
    print "AddDescription \"${DD_DESC}\" \"${DIR%/*}\"" >> "${DOCUMENT_DIR}${DDDIR}.htaccess"
done

################################################################

print "
</BODY>
</HTML>"
