#!/bin/ksh
#############################################################
# Program:	mkdir.cgi
#               Copyright 1999
#
# Description:	
#
# Author:	Dana French (dfrench@aignetplex.com)
#		 
#		(405) 936-2342
#
# Date:		04/26/99
#
#############################################################
# Modifications:
#
# 04/26/99	Version: 1.0
#		Original Code
################################################################
#
# httpd Environment Variables used
#
#	DOCUMENT_ROOT		Full path to top level html dir
#	SCRIPT_NAME		CGI path to this script
#	SCRIPT_FILENAME		Full path to this script
#
################################################################
h2a()
{
  sed -e "s/%\(..\)/\`print \"ibase=16; \1\" \| bc \| awk \'\{printf\(\"%c\",\$1\)\}\'\`/g"
}
################################################################
hex2ascii()
{
  HEXTMP=`h2a`
  eval print "${HEXTMP}"
}
################################################################
sedit()
{
hex2ascii | sed -e "\
s/,/,/g;\
s/\`/\'/g;\
s/+/ /g;\
s/%2[Ff]/\//g;\
s/     / /g;\
s/    / /g;\
s/   / /g;\
s/  / /g;\
s/^ //g"
}
################################################################
chkvalue()
{
  if [[ "_${1}" = "_" ]]
  then
    print "<STRONG>ERROR:</STRONG> You did not supply a ${2}. Go back and try again.<BR>"
    EXITLEVEL="$(( ${EXITLEVEL} + 1 ))"
  else
    CHKVALUE_REMAIN=`print "${1}" | sed -e "s|[a-z,A-Z,0-9, ,\.]||g"`
    if [[ "_${#CHKVALUE_REMAIN}" != "_" ]]
    then
      if [[ ${#CHKVALUE_REMAIN} -eq 0 ]]
      then
        print "<I>${2}</I> checked and accepted.<BR>"
      else
        print "<STRONG>ERROR:</STRONG> Invalid ${2}. Go back and try again.<BR>"
        EXITLEVEL="$(( ${EXITLEVEL} + 1 ))"
      fi
    else
      print "<STRONG>ERROR:</STRONG> Unable to perform validity check on ${2}. Go back and try again.<BR>"
      EXITLEVEL="$(( ${EXITLEVEL} + 1 ))"
    fi
  fi
}
################################################################
mkdotfile()
{
  print "<BR>Working on \"${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${DIRNAME}/${3}\"<BR>"
  cd "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${DIRNAME}"
  if [[ "_${1}" = "_1" ]]
  then
    print "Checking existance of \"${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${DIRNAME}/${3}\"<BR>"
    if [[ -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${DIRNAME}/${3}" ]]
    then
      print "Removing \"${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${DIRNAME}/${3}\"<BR>"
      rm -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${DIRNAME}/${3}"
    fi
  elif [[ "_${2}" = "_1" ]]
  then
    print "Checking existance of \"${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${DIRNAME}/${3}\"<BR>"
    if [[ -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${DIRNAME}/${3}" ]]
    then
      print "Removing \"${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${DIRNAME}/${3}\"<BR>"
      rm -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${DIRNAME}/${3}"
    fi
    print "Linking \"../${3}\" to \"./${3}\"<BR>"
    ln -s "../${3}" "./${3}"
  else
    print "Creating \"${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${DIRNAME}/${3}\"<BR>"
    print "${VAL}" | tr '\015' '\012' > "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${DIRNAME}/${3}"
  fi
}
################################################################
# DOCUMENT_ROOT="/external/ns-home/docs"
# SCRIPT_NAME="/cgi-bin/engine/engine.cgi"
# SCRIPT_FILENAME="/external/ns-home/cgi-bin/engine/engine.cgi"

DOCUMENT_BASE="/fancyIndex/"
DOCUMENT_DIR="${DOCUMENT_ROOT}${DOCUMENT_BASE}"
SCRIPT_DIR=`dirname "${SCRIPT_FILENAME}"`
SCRIPT_CGI=`dirname "${SCRIPT_NAME}"`
SEARCHTERM=""
PWPROTECTED="0"
################################################################
. ${SCRIPT_DIR}/hex2ascii.ksh
################################################################

if [ "_${*}" = "_" ]
then
    DDDIR=""
    DD_DIR=""
else
    DDDIR=`print "${*}" | sedit`
    DD_DIR=`print "${*}" | sedit`
fi

for VARVAL in `print "${QUERY_STRING}" | sed -e "s/&/	/g"`
do
  if print "${VARVAL}" | grep -i "=" > /dev/null
  then
    VAR=`print "${VARVAL%=*}" | sedit`
    VAL=`print "${VARVAL#*=}" | sedit`
    eval ${VAR}="\"${VAL}\""
  fi
done

DDDIR=`print "${DDDIR}/" | sed -e "s|//$|/|g;s|^/$||g"`
DD_DIR=`print "${DDDIR}/" | sed -e "s/ /%20/g;s|//$|/|g;s|^/$||g"`

print "content-type:text/html
pragma: no-cache

<HTML>
<HEAD>
<TITLE>Apache FancyIndex - /${DDDIR}</TITLE>
</HEAD>
"

if [[ -d "${DOCUMENT_DIR}" ]]
then
    if [[ -f "${DOCUMENT_DIR}${DDDIR}.bodytag" ]]
    then
        cat "${DOCUMENT_DIR}${DDDIR}.bodytag"
    else
        print "
<BODY Bgcolor=\"white\" Text=\"black\" Link=\"blue\" Vlink=\"red\" Alink=\"yellow\">
<BASEFONT Size=\"3\" Face=\"Arial\">
"
    fi
    if [[ -s "${DOCUMENT_DIR}${DDDIR}HEADER.html" ]]
    then
        cat "${DOCUMENT_DIR}${DDDIR}HEADER.html"
    elif [[ -s "${DOCUMENT_DIR}${DDDIR}.titlebar" ]]
    then
        cat "${DOCUMENT_DIR}${DDDIR}.titlebar"
    else
        print "<H2>Apache Fancy Index Input Form</H2>"
    fi
fi

# set | sed -e "s/$/<BR>/g"

print "<P><H2>Attempting to create the directory ${DOCUMENT_BASE}${DDDIR}${DIRNAME}</H2></P>"

################################################################
####	First check the password protection parameters
################################################################

EXITLEVEL="0"
chkvalue "${DIRNAME}" "Directory Name"
chkvalue "${DIRDESC}" "Short Description"
chkvalue "${USERID}" "User ID"
chkvalue "${PASSWORD}" "Password"
chkvalue "${RETYPEPASSWORD}" "Retyped Password"

if [[ "_${PASSWORD}" != "_${RETYPEPASSWORD}" ]]
then
  print "<STRONG>ERROR:</STRONG> Passwords do not match. Go back and try again.<BR>"
  EXITLEVEL="$(( ${EXITLEVEL} + 1 ))"
fi

if [[ ${EXITLEVEL} -gt 0 ]]
then
  print "</BODY></HTML>"
  exit
fi
	
if [[ ! -d "${DOCUMENT_DIR}${DDDIR}${DIRNAME}" ]]
then 
    if mkdir "${DOCUMENT_DIR}${DDDIR}${DIRNAME}" 2>&1
    then
        print "${DOCUMENT_BASE}${DDDIR}${DIRNAME} directory created successfully<BR>"
        if mkdir "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${DIRNAME}" 2>&1
        then
            print "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${DIRNAME} directory created successfully<BR>"
        else
            print "<BR><STRONG>ERROR:</STRONG> Unable to create directory ${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${DIRNAME}<BR>"
            print "</BODY></HTML>"
            exit
        fi
    else
        print "<BR><STRONG>ERROR:</STRONG> unable to create directory ${DOCUMENT_BASE}${DDDIR}${DIRNAME}<BR>"
        print "</BODY></HTML>"
        exit
    fi
else
    print "<STRONG>ERROR:</STRONG> ${DOCUMENT_BASE}${DDDIR}${DIRNAME} directory already exists<BR>"
fi

for VARVAL in `print "${QUERY_STRING}" | sed -e "s/&/	/g"`
do
  if print "${VARVAL}" | grep -i "=" > /dev/null
  then
    VAR=`print "${VARVAL%=*}" | sedit`
    VAL=`print "${VARVAL#*=}" | sedit`
    eval ${VAR}="\"${VAL}\""
  fi

  print "Working on <CODE>${VAR}</CODE>..."

#     case "_${VAR}" in
#         "_TITLEBAR") print "${VAL}" | tr '\015' '\012' > "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${DIRNAME}/.titlebar";;
#         "_LINKBAR") print "${VAL}" | tr '\015' '\012' > "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${DIRNAME}/.linkbar";;
#         "_DESCRIPTION") print "${VAL}" | tr '\015' '\012' > "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${DIRNAME}/.description";;
#         "_FORINFO") print "${VAL}" | tr '\015' '\012' > "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${DIRNAME}/.forinfo";;
#         "_HTACCESS") print "${VAL}" | tr '\015' '\012' > "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${DIRNAME}/.htaccessrc";;
#         "_DIRDESC") print "${VAL}" | tr '\015' '\012' > "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${DIRNAME}/.shortdescription";;
# 	"_DIRNAME") DIRNAME_PERCENT=`print "${DIRNAME}" | sed -e "s/ /%20/g;s/	/%20/g"`;;
#     esac

    case "_${VAR}" in
        "_TITLEBAR") mkdotfile "${DELTITLEBAR}" "${SLINKTITLEBAR}" ".titlebar";;
        "_LINKBAR") mkdotfile "${DELLINKBAR}" "${SLINKLINKBAR}" ".linkbar";;
        "_DESCRIPTION") mkdotfile "${DELDESCRIPTION}" "${SLINKDESCRIPTION}" ".description";;
        "_FORINFO") mkdotfile "${DELFORINFO}" "${SLINKFORINFO}" ".forinfo";;
        "_HTACCESS") mkdotfile "${DELHTACCESS}" "${SLINKHTACCESS}" ".htaccessrc";;
        "_DIRDESC") print "${VAL}" | tr '\015' '\012' > "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${DIRNAME}/.shortdescription";;
	"_DIRNAME") DIRNAME_PERCENT=`print "${DIRNAME}" | sed -e "s/ /%20/g;s/	/%20/g"`;;
    esac
    print "<BR>"

done

print "Utilities|${SCRIPT_CGI}/utilities.cgi?${DD_DIR}${DIRNAME_PERCENT}|Utilities to control the look and feel of the current directory.  Also user and password utils for password protected directories" > "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${DIRNAME}/.links"
# print "Create new sub-directory|${SCRIPT_CGI}/mkdirform.cgi?${DD_DIR}${DIRNAME_PERCENT}|Create a new sub-directory under the current directory" > "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${DIRNAME}/.links"
# print "Reindex current directory|${SCRIPT_CGI}/reindex.cgi?${DD_DIR}${DIRNAME_PERCENT}|Reindex the control files under the current directory" >> "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${DIRNAME}/.links"
# print "Modify appearance|${SCRIPT_CGI}/modform.cgi?${DD_DIR}${DIRNAME_PERCENT}|Modify the appearance of the current directory" >> "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${DIRNAME}/.links"
# print "Add URL link|${SCRIPT_CGI}/addlinkform.cgi?${DD_DIR}${DIRNAME_PERCENT}|Add a URL Link to the current directory" >> "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${DIRNAME}/.links"

################################################################
####  subdir htaccess file creation
####  and parent dir htaccess file modification
################################################################

[[ -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${DIRNAME}/.htaccessrc" ]] && cat "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${DIRNAME}/.htaccessrc" > "${DOCUMENT_DIR}${DDDIR}${DIRNAME}/.htaccess"

[[ -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.htaccessrc" ]] && cat "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.htaccessrc" > "${DOCUMENT_DIR}${DDDIR}.htaccess"

cd "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}"
ls -a1 */.shortdescription 2>/dev/null | while read DIR
do
    DD_DESC=`cat "${DIR}"`
    print "AddDescription \"${DD_DESC}\" \"${DIR%/*}\"" >> "${DOCUMENT_DIR}${DDDIR}.htaccess"
done

################################################################
####  create the directory administrator file
################################################################

if [[ ! -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${DIRNAME}/.diradmin" ]]
then
  if touch "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${DIRNAME}/.diradmin" 2>&1
  then

chmod 600 "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${DIRNAME}/.diradmin" 2>&1
/usr/local/apache/bin/htpasswd -b -c -p "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${DIRNAME}/.diradmin" "${USERID}" "${PASSWORD}" >/dev/null 2>&1

    if [[ -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${DIRNAME}/.diradmin" ]]
    then
      print "<BR>Directory administration of \"${DOCUMENT_DIR}${DDDIR}${DIRNAME}\" has been assigned to \"${USERID}\"<BR>"
    else
      print "<BR><STRONG>ERROR:</STRONG> Unable to add the directory administrators password to the file ${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${DIRNAME}/.diradmin<BR>"
    fi
  else
    print "<BR><STRONG>ERROR:</STRONG> Unable to create the directory administration file ${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${DIRNAME}/.diradmin<BR>"
  fi
else
  print "<BR><STRONG>ERROR:</STRONG> Unable to reassign directory administration of \"${DOCUMENT_DIR}${DDDIR}${DIRNAME}\" to \"${USERID}\"<BR>"
fi

################################################################
####  Password protect the directory
################################################################

if [[ ${PWPROTECTED} -eq 1 ]]
then
    if touch "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${DIRNAME}/.htpasswd" 2>&1
    then

touch "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${DIRNAME}/.UID_${USERID}" 2>&1
chmod 600 "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${DIRNAME}/.htpasswd" 2>&1
chmod 600 "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${DIRNAME}/.UID_${USERID}" 2>&1
/usr/local/apache/bin/htpasswd -b "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${DIRNAME}/.htpasswd" "${USERID}" "${PASSWORD}" 2>&1
/usr/local/apache/bin/htpasswd -b -p "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${DIRNAME}/.UID_${USERID}" "${USERID}" "${PASSWORD}" > /dev/null 2>&1

print "<P><STRONG><EM>"
grep "${USERID}" "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${DIRNAME}/.htpasswd" 2>&1 | sed -e "s/$/<BR>/g"
print "</EM></STRONG></P>"

print "Access to \"${DOCUMENT_DIR}${DDDIR}${DIRNAME}\" has been granted to \"${USERID}\"<BR>"

print "Appending access restrictions to ${DOCUMENT_DIR}${DDDIR}${DIRNAME}/.htaccessrc<BR>"

print "
AuthName \"${DIRDESC}\"
AuthType Basic
AuthUserFile \"${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${DIRNAME}/.htpasswd\"
require valid-user
" >> "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${DIRNAME}/.htaccessrc"


print "Appending access restrictions to ${DOCUMENT_DIR}${DDDIR}${DIRNAME}/.htaccess<BR>"

print "
AuthName \"${DIRDESC}\"
AuthType Basic
AuthUserFile \"${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${DIRNAME}/.htpasswd\"
require valid-user
" >> "${DOCUMENT_DIR}${DDDIR}${DIRNAME}/.htaccess"

  fi
fi

################################################################
####  permit file uploads
################################################################

if [[ ${UPLOADFILE} -eq 1 ]]
then

print "<P><STRONG>To obtain permission to upload files to this directory,
please contact <A Href=\"mailto:dfrench@netplexgroup.com\">Dana French</A>
at <A Href=\"mailto:dfrench@netplexgroup.com\">dfrench@netplexgroup.com</A>
and request upload permission for this directory.  Be sure to include
the name of the directory to which you want upload permission.</STRONG></P>"

#     if touch "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${DIRNAME}/.admuploadFile" 2>&1
#     then
# print "File upload permission for the directory \"${DOCUMENT_DIR}${DDDIR}${DIRNAME}\" has been granted to the directory administrator.<BR>"
#     else
# print "<BR><STRONG>ERROR:</STRONG> Unable to grant file upload permission for the directory \"${DOCUMENT_DIR}${DDDIR}${DIRNAME}\" to the directory administrator.<BR>"
#     fi

fi

if [[ ${UPLOADFILE} -eq 2 ]]
then

print "<P><STRONG>To obtain permission to upload files to this directory,
please contact <A Href=\"mailto:dfrench@netplexgroup.com\">Dana French</A>
at <A Href=\"mailto:dfrench@netplexgroup.com\">dfrench@netplexgroup.com</A>
and request upload permission for this directory.  Be sure to include
the name of the directory to which you want upload permission.</STRONG></P>"

#     if touch "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${DIRNAME}/.uploadFile" 2>&1
#     then
# print "File upload permission for the directory \"${DOCUMENT_DIR}${DDDIR}${DIRNAME}\" has been granted to all users.<BR>"
#     else
# print "<BR><STRONG>ERROR:</STRONG> Unable to grant file upload permission for the directory \"${DOCUMENT_DIR}${DDDIR}${DIRNAME}\" to any users.<BR>"
#     fi

fi

################################################################

print "<P><HR></P>"

if [[ -d "${DOCUMENT_DIR}${DDDIR}${DIRNAME}" ]] \
&& [[ -d "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${DIRNAME}" ]]
then

    if [[ -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${DIRNAME}/.shortdescription" ]]
    then

print "
<P>The directory ${DOCUMENT_BASE}${DDDIR}${DIRNAME} was created successfully.
To continue, you must now run the index program.<BR>
<FORM action="reindex.cgi">
<INPUT Type=\"hidden\" Name=\"DDDIR\" Value=\"${DDDIR}${DIRNAME}\">
<input Type=\"submit\" Value=\"Click here to run the index program\">
</P>
"
    else
print "
<P>The directory description file 
${DOCUMENT_BASE}${DDDIR}${DIRNAME}/.shortdescription
does not exist.  You must contact the appropriate personnel to fix this
problem before you can continue.</P>
"
    fi
else

print "
<P>The directory ${DOCUMENT_BASE}${DDDIR}${DIRNAME}
does not exist.  You must contact the appropriate personnel to fix this
problem before you can continue.</P>
"

fi

print "</BODY>
</HTML>"

