#!/bin/ksh
#############################################################
# Program:	modform.cgi
#               Copyright 1999
#
# Description:	
#
# Author:	Dana French (dfrench@aignetplex.com)
#		 
#		(405) 936-2342
#
# Date:		04/26/99
#
#############################################################
# Modifications:
#
# 04/26/99	Version: 1.0
#		Original Code
################################################################
#
# httpd Environment Variables used
#
#	DOCUMENT_ROOT		Full path to top level html dir
#	SCRIPT_NAME		CGI path to this script
#	SCRIPT_FILENAME		Full path to this script
#
################################################################
h2a()
{
  sed -e "s/%\(..\)/\`print \"ibase=16; \1\" \| bc \| awk \'\{printf\(\"%c\",\$1\)\}\'\`/g"
}
################################################################
hex2ascii()
{
  HEXTMP=`h2a`
  eval print "${HEXTMP}"
}
################################################################
sedit()
{
hex2ascii | sed -e "\
s/,/,/g;\
s/\`/\'/g;\
s/+/ /g;\
s/%2[Ff]/\//g;\
s/     / /g;\
s/    / /g;\
s/   / /g;\
s/  / /g;\
s/^ //g"
}
################################################################
# DOCUMENT_ROOT="/external/ns-home/docs"
# SCRIPT_NAME="/cgi-bin/engine/engine.cgi"
# SCRIPT_FILENAME="/external/ns-home/cgi-bin/engine/engine.cgi"

DOCUMENT_BASE="/fancyIndex/"
DOCUMENT_DIR="${DOCUMENT_ROOT}${DOCUMENT_BASE}"
SCRIPT_DIR=`dirname "${SCRIPT_FILENAME}"`
SCRIPT_CGI=`dirname "${SCRIPT_NAME}"`
SEARCHTERM=""

if [ "_${*}" = "_" ]
then
    DDDIR=""
    DD_DIR=""
else
    DDDIR=`print "${*}" | sedit`
    DD_DIR=`print "${*}" | sedit`
fi

for VARVAL in `print "${QUERY_STRING}" | sed -e "s/&/	/g"`
do
  if print "${VARVAL}" | grep -i "=" > /dev/null
  then
    VAR=`print "${VARVAL%=*}" | sedit`
    VAL=`print "${VARVAL#*=}" | sedit`
    eval ${VAR}="\"${VAL}\""
  fi
done

DDDIR=`print "${DDDIR}/" | sed -e "s|//$|/|g;s|^/$||g"`
DD_DIR=`print "${DDDIR}/" | sed -e "s/ /%20/g;s|//$|/|g;s|^/$||g"`

print "content-type:text/html
pragma: no-cache

<HTML>
<HEAD>
<TITLE>Apache FancyIndex - /${DDDIR}</TITLE>
</HEAD>
"

if [[ -d "${DOCUMENT_DIR}" ]]
then
    if [[ -f "${DOCUMENT_DIR}${DDDIR}.bodytag" ]]
    then
        cat "${DOCUMENT_DIR}${DDDIR}.bodytag"
    else
        print "
<BODY Bgcolor=\"white\" Text=\"black\" Link=\"blue\" Vlink=\"red\" Alink=\"yellow\">
<BASEFONT Size=\"3\" Face=\"Arial\">
"
    fi
    if [[ -s "${DOCUMENT_DIR}${DDDIR}HEADER.html" ]]
    then
        cat "${DOCUMENT_DIR}${DDDIR}HEADER.html"
    elif [[ -s "${DOCUMENT_DIR}${DDDIR}.titlebar" ]]
    then
        cat "${DOCUMENT_DIR}${DDDIR}.titlebar"
    else
        print "<H2>Apache Fancy Index Input Form</H2>"
    fi

    if [[ -s "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.shortdescription" ]]
    then
        DIRDESC=`cat "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.shortdescription" | grep -v "^$"`
    else
        DIRDESC=""
    fi
fi

DIRNAME=`basename "${DOCUMENT_DIR}${DDDIR}"`

# set | sed -e "s/$/<BR>/g"

print "
<P><HR></P>

<P><FONT Size=\"+1\">This form allows the user to modify
the appearance of the current directory.</FONT></P>

<FORM Method=\"get\" Action=\"modify.cgi\">
<INPUT Type=\"hidden\" Name=\"DDDIR\" Value=\"${DDDIR}\"><BR>
<INPUT Type=\"hidden\" Name=\"DIRNAME\" Value=\"${DIRNAME}\"><BR>

<TABLE Border=\"0\">
<P>
  <CAPTION>
    <FONT Size=\"+2\"><STRONG>
Modify the Current Directory</STRONG>
    </STRONG></FONT>
  </CAPTION>
</P>
<P>
  <TR>
    <TD Align=\"right\" Valign=\"top\">
      <FONT Size=\"+1\"><STRONG>
Directory&nbsp;Name:
      </STRONG></FONT>
    </TD>
    <TD Align=\"left\" Valign=\"top\">
      <FONT Size=\"+1\"><STRONG><EM>
&nbsp;${DIRNAME}
      </EM></STRONG></FONT>
<HR>
    </TD>
  </TR>
</P>
<P>
  <TR>
    <TD Align=\"right\" Valign=\"top\">
      <FONT Size=\"+1\"><STRONG>
Short&nbsp;Description:
      </STRONG></FONT>
    </TD>
    <TD Align=\"left\" Valign=\"top\">
      <FONT Size=\"+1\"><STRONG>
<INPUT Type=\"text\" Name=\"DIRDESC\" Value=\"${DIRDESC}\" Size=\"32\" Maxlength=\"64\"><BR>
      </STRONG></FONT>
      <FONT Size=\"-1\"><I>
The short description can be up to 64 characters and must contain only
letters, numbers or spaces.
      </I></FONT>
<HR>
    </TD>
  </TR>
</P>
<P>
  <TR>
    <TD Align=\"right\" Valign=\"top\">
      <FONT Size=\"+1\"><STRONG>
User&nbsp;ID:
      </STRONG></FONT>
    </TD>
    <TD Align=\"left\" Valign=\"top\">
      <FONT Size=\"+1\"><STRONG>
<INPUT Type=\"text\" Name=\"USERID\" Size=\"8\" Maxlength=\"8\"><BR>
      </STRONG></FONT>
      <FONT Size=\"-1\"><I>
Enter the user ID of the administrator for the
current directory.  Only this user is allowed to
modify the look-and-feel of the new directory.
      </I></FONT>
<HR>
    </TD>
  </TR>
</P>
<P>
  <TR>
    <TD Align=\"right\" Valign=\"top\">
      <FONT Size=\"+1\"><STRONG>
Password:
      </STRONG></FONT>
    </TD>
    <TD Align=\"left\" Valign=\"top\">
      <FONT Size=\"+1\"><STRONG>
<INPUT Type=\"password\" Name=\"PASSWORD\" Size=\"8\" Maxlength=\"8\"><BR>
      </STRONG></FONT>
      <FONT Size=\"-1\"><I>
Enter a password for the user ID.  The password can be up to 8
characters in length and must contain only letter and/or numbers.
      </I></FONT>
<HR>
    </TD>
  </TR>
</P>
</TABLE>
</P>

<P><HR></P>

"

################################################################

print "
<P><STRONG><FONT Size=\"+1\">Long Description of Directory</FONT></STRONG><BR>
"
if [[ -L "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.description" ]]
then

print "<P>Currently exists as a symbolic link to parent.  It may be
deleted, however modifications can only be made to top level parent file.</P>"
print "<INPUT Type=\"hidden\" Name=\"DESCRIPTION\" Value=\"\">"
print "<INPUT Type=\"checkbox\" Name=\"DELDESCRIPTION\" Value=\"1\"> Delete ?<BR>"
print "<P><BLOCKQUOTE><TABLE Border=\"2\"><TR><TD Bgcolor=\"lightyellow\"><PRE><CODE>"
cat "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.description" | grep -v "^$" | sed -e "s|<|\&lt;|g;s|>|\&gt;|g"
print "</CODE></PRE></TD></TR></TABLE></BLOCKQUOTE></P>"

else

print "
<INPUT Type=\"checkbox\" Name=\"DELDESCRIPTION\" Value=\"1\"> Delete ?<BR>
<INPUT Type=\"checkbox\" Name=\"SLINKDESCRIPTION\" Value=\"1\"> Create as symbolic link to parent ?<BR>
<TEXTAREA Name=\"DESCRIPTION\" Rows=\"25\" Cols=\"100%\">
"
if [[ -s "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.description" ]]
then
    sed -e "s|&|\&amp;|g" "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.description" | grep -v "^$"
fi

print "</TEXTAREA>"

fi

print "</P><P><HR></P>"

################################################################

print "<P><STRONG><FONT Size=\"+1\">Title Bar</FONT></STRONG><BR>"

if [[ -L "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.titlebar" ]]
then

print "<P>Currently exists as a symbolic link to parent.  It may be
deleted, however modifications can only be made to top level parent file.</P>"
print "<INPUT Type=\"hidden\" Name=\"TITLEBAR\" Value=\"\">"
print "<INPUT Type=\"checkbox\" Name=\"DELTITLEBAR\" Value=\"1\"> Delete ?<BR>"
print "<P><BLOCKQUOTE><TABLE Border=\"2\"><TR><TD Bgcolor=\"lightyellow\"><PRE><CODE>"
cat "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.titlebar" | grep -v "^$" | sed -e "s|<|\&lt;|g;s|>|\&gt;|g"
print "</CODE></PRE></TD></TR></TABLE></BLOCKQUOTE></P>"

else

print "
<INPUT Type=\"checkbox\" Name=\"DELTITLEBAR\" Value=\"1\"> Delete ?<BR>
<INPUT Type=\"checkbox\" Name=\"SLINKTITLEBAR\" Value=\"1\"> Create as symbolic link to parent ?<BR>
<TEXTAREA Name=\"TITLEBAR\" Rows=\"25\" Cols=\"100%\">
"

if [[ -s "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.titlebar" ]]
then
    sed -e "s|&|\&amp;|g" "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.titlebar" | grep -v "^$"
fi

print "</TEXTAREA>"

fi

print "</P><P><HR></P>"

################################################################

print "<P><STRONG><FONT Size=\"+1\">Link Bar</FONT></STRONG><BR>"

if [[ -L "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.linkbar" ]]
then

print "<P>Currently exists as a symbolic link to parent.  It may be
deleted, however modifications can only be made to top level parent file.</P>"
print "<INPUT Type=\"hidden\" Name=\"LINKBAR\" Value=\"\">"
print "<INPUT Type=\"checkbox\" Name=\"DELLINKBAR\" Value=\"1\"> Delete ?<BR>"
print "<P><BLOCKQUOTE><TABLE Border=\"2\"><TR><TD Bgcolor=\"lightyellow\"><PRE><CODE>"
cat "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.linkbar" | grep -v "^$" | sed -e "s|<|\&lt;|g;s|>|\&gt;|g"
print "</CODE></PRE></TD></TR></TABLE></BLOCKQUOTE></P>"

else

print "
<INPUT Type=\"checkbox\" Name=\"DELLINKBAR\" Value=\"1\"> Delete ?<BR>
<INPUT Type=\"checkbox\" Name=\"SLINKLINKBAR\" Value=\"1\"> Create as symbolic link to parent ?<BR>
<TEXTAREA Name=\"LINKBAR\" Rows=\"25\" Cols=\"100%\">
"
if [[ -s "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.linkbar" ]]
then
    sed -e "s|&|\&amp;|g" "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.linkbar" | grep -v "^$"
fi

print "</TEXTAREA>"

fi

print "</P><P><HR></P>"

################################################################

print "<P><STRONG><FONT Size=\"+1\">Contact Information</FONT></STRONG><BR>"

if [[ -L "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.forinfo" ]]
then

print "<P>Currently exists as a symbolic link to parent.  It may be
deleted, however modifications can only be made to top level parent file.</P>"
print "<INPUT Type=\"hidden\" Name=\"FORINFO\" Value=\"\">"
print "<INPUT Type=\"checkbox\" Name=\"DELFORINFO\" Value=\"1\"> Delete ?<BR>"
print "<P><BLOCKQUOTE><TABLE Border=\"2\"><TR><TD Bgcolor=\"lightyellow\"><PRE><CODE>"
cat "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.forinfo" | grep -v "^$" | sed -e "s|<|\&lt;|g;s|>|\&gt;|g;"
print "</CODE></PRE></TD></TR></TABLE></BLOCKQUOTE></P>"

else

print "
<INPUT Type=\"checkbox\" Name=\"DELFORINFO\" Value=\"1\"> Delete ?<BR>
<INPUT Type=\"checkbox\" Name=\"SLINKFORINFO\" Value=\"1\"> Create as symbolic link to parent ?<BR>
<TEXTAREA Name=\"FORINFO\" Rows=\"25\" Cols=\"100%\">
"
if [[ -s "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.forinfo" ]]
then
    sed -e "s|&|\&amp;|g" "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.forinfo" | grep -v "^$"
fi

print "</TEXTAREA>"

fi

print "</P><P><HR></P>"

################################################################

print "<P><STRONG><FONT Size=\"+1\">Directory Control File \".htaccess\"</FONT></STRONG><BR>"

if [[ -L "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.htaccessrc" ]]
then

print "<P>Currently exists as a symbolic link to parent.  It may be
deleted, however modifications can only be made to top level parent file.</P>"
print "<INPUT Type=\"hidden\" Name=\"HTACCESS\" Value=\"\">"
print "<INPUT Type=\"checkbox\" Name=\"DELHTACCESS\" Value=\"1\"> Delete ?<BR>"
print "<P><BLOCKQUOTE><TABLE Border=\"2\"><TR><TD Bgcolor=\"lightyellow\"><PRE><CODE>"
cat "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.htaccessrc" | grep -v "^$" | sed -e "s|<|\&lt;|g;s|>|\&gt;|g"
print "</CODE></PRE></TD></TR></TABLE></BLOCKQUOTE></P>"

else

print "
<INPUT Type=\"checkbox\" Name=\"DELHTACCESS\" Value=\"1\"> Delete ?<BR>
<INPUT Type=\"checkbox\" Name=\"SLINKHTACCESS\" Value=\"1\"> Create as symbolic link to parent ?<BR>
<TEXTAREA Name=\"HTACCESS\" Rows=\"25\" Cols=\"100%\">
"
if [[ -s "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.htaccessrc" ]]
then
    sed -e "s|&|\&amp;|g" "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.htaccessrc" | grep -v "^$"
fi

print "</TEXTAREA>"

fi

print "</P><P><HR></P>"

################################################################

print "
<P>
<INPUT Type=\"submit\" Value=\"Modify this Directory\">
</P>
</FORM>"

print "<P><HR></P>"

print "</BODY>
</HTML>"

