#!/bin/ksh
#############################################################
# Program:	modify.cgi
#               Copyright 1999
#
# Description:	
#
# Author:	Dana French (dfrench@aignetplex.com)
#		 
#		(405) 936-2342
#
# Date:		04/26/99
#
#############################################################
# Modifications:
#
# 04/26/99	Version: 1.0
#		Original Code
################################################################
#
# httpd Environment Variables used
#
#	DOCUMENT_ROOT		Full path to top level html dir
#	SCRIPT_NAME		CGI path to this script
#	SCRIPT_FILENAME		Full path to this script
#
################################################################
h2a()
{
  sed -e "s/%\(..\)/\`print \"ibase=16; \1\" \| bc \| awk \'\{printf\(\"%c\",\$1\)\}\'\`/g"
}
################################################################
hex2ascii()
{
  HEXTMP=`h2a`
  eval print "${HEXTMP}"
}
################################################################
sedit()
{
hex2ascii | sed -e "\
s/,/,/g;\
s/\`/\'/g;\
s/+/ /g;\
s/%2[Ff]/\//g;\
s/     / /g;\
s/    / /g;\
s/   / /g;\
s/  / /g;\
s/^ //g"
}
################################################################
chkvalue()
{
  if [[ "_${1}" = "_" ]]
  then
    print "<STRONG>ERROR:</STRONG> You did not supply a ${2}. Go back and try again.<BR>"
    EXITLEVEL="$(( ${EXITLEVEL} + 1 ))"
  else
    CHKVALUE_REMAIN=`print "${1}" | sed -e "s|[a-z,A-Z,0-9, ]||g"`
    if [[ "_${#CHKVALUE_REMAIN}" != "_" ]]
    then
      if [[ ${#CHKVALUE_REMAIN} -eq 0 ]]
      then
        print "<I>${2}</I> checked and accepted.<BR>"
      else
        print "<STRONG>ERROR:</STRONG> Invalid ${2}. Go back and try again.<BR>"
        EXITLEVEL="$(( ${EXITLEVEL} + 1 ))"
      fi
    else
      print "<STRONG>ERROR:</STRONG> Unable to perform validity check on ${2}. Go back and try again.<BR>"
      EXITLEVEL="$(( ${EXITLEVEL} + 1 ))"
    fi
  fi
}

################################################################
mkdotfile()
{
  print "<BR>Working on \"${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${3}\"<BR>"
  cd "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}"
  if [[ "${1}" = "_1" ]]
  then
    print "Checking existance of \"${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${3}\"<BR>"
    if [[ -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${3}" ]]
    then
      print "Removing \"${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${3}\"<BR>"
      rm -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${3}"
    fi
  elif [[ "${2}" = "_1" ]]
  then
    print "Checking existance of \"${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${3}\"<BR>"
    if [[ -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${3}" ]]
    then
      print "Removing \"${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${3}\"<BR>"
      rm -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${3}"
    fi
    print "Linking \"../${3}\" to \"./${3}\"<BR>"
    ln -s "../${3}" "./${3}"
  else
    print "Checking existance of \"${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${3}\"<BR>"
    if [[ -L "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${3}" ]]
    then
      print "\"${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${3}\" File exists as a symbolic link. NOT rewritten.<BR>"
    else
      print "Creating \"${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${3}\"<BR>"
      print "${VAL}" | tr '\015' '\012' > "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${3}"
    fi
  fi
}
################################################################
# DOCUMENT_ROOT="/external/ns-home/docs"
# SCRIPT_NAME="/cgi-bin/engine/engine.cgi"
# SCRIPT_FILENAME="/external/ns-home/cgi-bin/engine/engine.cgi"

DOCUMENT_BASE="/fancyIndex/"
DOCUMENT_DIR="${DOCUMENT_ROOT}${DOCUMENT_BASE}"
SCRIPT_DIR=`dirname "${SCRIPT_FILENAME}"`
SCRIPT_CGI=`dirname "${SCRIPT_NAME}"`
SEARCHTERM=""
PWPROTECTED="0"
################################################################
. ${SCRIPT_DIR}/hex2ascii.ksh
################################################################

if [ "_${*}" = "_" ]
then
    DDDIR=""
    DD_DIR=""
else
    DDDIR=`print "${*}" | sedit`
    DD_DIR=`print "${*}" | sedit`
fi

for VARVAL in `print "${QUERY_STRING}" | sed -e "s/&/	/g"`
do
  if print "${VARVAL}" | grep -i "=" > /dev/null
  then
    VAR=`print "${VARVAL%=*}" | sedit`
    VAL=`print "${VARVAL#*=}" | sedit`
    eval ${VAR}="\"${VAL}\""
  fi
done

DDDIR=`print "${DDDIR}/" | sed -e "s|//$|/|g;s|^/$||g"`
DD_DIR=`print "${DDDIR}/" | sed -e "s/ /%20/g;s|//$|/|g;s|^/$||g"`

print "content-type:text/html
pragma: no-cache

<HTML>
<HEAD>
<TITLE>Apache FancyIndex - /${DDDIR}</TITLE>
</HEAD>
"

if [[ -d "${DOCUMENT_DIR}" ]]
then
    if [[ -f "${DOCUMENT_DIR}${DDDIR}.bodytag" ]]
    then
        cat "${DOCUMENT_DIR}${DDDIR}.bodytag"
    else
        print "
<BODY Bgcolor=\"white\" Text=\"black\" Link=\"blue\" Vlink=\"red\" Alink=\"yellow\">
<BASEFONT Size=\"3\" Face=\"Arial\">
"
    fi
    if [[ -s "${DOCUMENT_DIR}${DDDIR}HEADER.html" ]]
    then
        cat "${DOCUMENT_DIR}${DDDIR}HEADER.html"
    elif [[ -s "${DOCUMENT_DIR}${DDDIR}.titlebar" ]]
    then
        cat "${DOCUMENT_DIR}${DDDIR}.titlebar"
    else
        print "<H2>Apache Fancy Index Input Form</H2>"
    fi
fi

# set | sed -e "s/$/<BR>/g"

print "<P><H2>Attempting to modify the directory ${DOCUMENT_BASE}${DDDIR}</H2></P>"

################################################################
####	First check the password protection parameters
################################################################

EXITLEVEL="0"
chkvalue "${DIRNAME}" "Directory Name"
chkvalue "${DIRDESC}" "Short Description"
chkvalue "${USERID}" "User ID"
chkvalue "${PASSWORD}" "Password"

################################################################
####	compare passwords
################################################################
EXITLEVEL="1"
if [[ -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.diradmin" ]]
then

rm -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}diradmin.tmp"
/usr/local/apache/bin/htpasswd -b -c -p "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}diradmin.tmp" "${USERID}" "${PASSWORD}" >/dev/null 2>&1
  if [[ -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}diradmin.tmp" ]]
  then

    if grep "${USERID}" "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.diradmin" | head -1 | diff "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}diradmin.tmp" - > /dev/null 2>&1
    then
      print "<BR>Administrative User Verified.<BR>"
      EXITLEVEL="0"
    else
      print "<BR><STRONG>ERROR:</STRONG> Administrative login failed.<BR>"
    fi
    rm -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}diradmin.tmp"
  else
    print "<BR><STRONG>ERROR:</STRONG> Unable to compare administrative login.<BR>"
  fi

else

  print "<BR><STRONG>ERROR:</STRONG> Unable to verify administrative user.<BR>"

fi

if [[ ${EXITLEVEL} -gt 0 ]]
then
  print "</BODY></HTML>"
  exit
fi


for VARVAL in `print "${QUERY_STRING}" | sed -e "s/&/	/g"`
do
  if print "${VARVAL}" | grep -i "=" > /dev/null
  then
    VAR=`print "${VARVAL%=*}" | sedit`
    VAL=`print "${VARVAL#*=}" | sedit`
    eval ${VAR}="\"${VAL}\""
  fi

    print "Working on <CODE>${VAR}</CODE>..."

#     case "_${VAR}" in
#         "_TITLEBAR") print "${VAL}" | tr '\015' '\012' > "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.titlebar";;
#         "_LINKBAR") print "${VAL}" | tr '\015' '\012' > "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.linkbar";;
#         "_DESCRIPTION") print "${VAL}" | tr '\015' '\012' > "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.description";;
#         "_FORINFO") print "${VAL}" | tr '\015' '\012' > "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.forinfo";;
#         "_HTACCESS") print "${VAL}" | tr '\015' '\012' > "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.htaccessrc";;
#         "_DIRDESC") print "${VAL}" | tr '\015' '\012' > "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.shortdescription";;
# 	"_DIRNAME") DIRNAME_PERCENT=`print "${DIRNAME}" | sed -e "s/ /%20/g;s/	/%20/g"`;;
#     esac

    case "_${VAR}" in
        "_TITLEBAR") mkdotfile "_${DELTITLEBAR}" "_${SLINKTITLEBAR}" ".titlebar";;
        "_LINKBAR") mkdotfile "_${DELLINKBAR}" "_${SLINKLINKBAR}" ".linkbar";;
        "_DESCRIPTION") mkdotfile "_${DELDESCRIPTION}" "_${SLINKDESCRIPTION}" ".description";;
        "_FORINFO") mkdotfile "_${DELFORINFO}" "_${SLINKFORINFO}" ".forinfo";;
        "_HTACCESS") mkdotfile "_${DELHTACCESS}" "_${SLINKHTACCESS}" ".htaccessrc";;
        "_DIRDESC") print "${VAL}" | tr '\015' '\012' > "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${DIRNAME}/.shortdescription";;
	"_DIRNAME") DIRNAME_PERCENT=`print "${DIRNAME}" | sed -e "s/ /%20/g;s/	/%20/g"`;;
    esac

    print "<BR>"

done

# print "Create new sub-directory|${SCRIPT_CGI}/mkdirform.cgi?${DD_DIR}|Create a new sub-directory under the current directory" > "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.links"
# print "Re-Index current directory|${SCRIPT_CGI}/reindex.cgi?${DD_DIR}|Reindex the control files under the current directory" >> "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.links"
# print "Modify appearance|${SCRIPT_CGI}/modform.cgi?${DD_DIR}|Modify the appearance of the current directory" >> "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.links"
# print "Add URL link|${SCRIPT_CGI}/addlinkform.cgi?${DD_DIR}|Add a URL Link to the current directory" >> "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.links"

################################################################
####  subdir htaccess file creation
####  and parent dir htaccess file modification
################################################################

[[ -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.htaccessrc" ]] && cat "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.htaccessrc" > "${DOCUMENT_DIR}${DDDIR}.htaccess"

[[ -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.htaccessrc" ]] && cat "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.htaccessrc" > "${DOCUMENT_DIR}${DDDIR}.htaccess"

cd "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.."
ls -a1 */.shortdescription 2>/dev/null | while read DIR
do
    DD_DESC=`cat "${DIR}"`
    print "AddDescription \"${DD_DESC}\" \"${DIR%/*}\"" >> "${DOCUMENT_DIR}${DDDIR}../.htaccess"
done

################################################################

print "<P><HR></P>"

if [[ -d "${DOCUMENT_DIR}${DDDIR}" ]] \
&& [[ -d "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}" ]]
then

    if [[ -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.shortdescription" ]]
    then

print "
<P>The directory ${DOCUMENT_BASE}${DDDIR} was modified successfully.
To continue, you must now run the index program.<BR>
<FORM action="reindex.cgi">
<INPUT Type=\"hidden\" Name=\"DDDIR\" Value=\"${DDDIR}\">
<input Type=\"submit\" Value=\"Click here to run the index program\">
</P>
"
    else
print "
<P>The directory description file 
${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.shortdescription
does not exist.  You must contact the appropriate personnel to fix this
problem before you can continue.</P>
"
    fi
else

print "
<P>The directory ${DOCUMENT_BASE}${DDDIR}
does not exist.  You must contact the appropriate personnel to fix this
problem before you can continue.</P>
"

fi

print "</BODY>
</HTML>"

