#!/bin/ksh
#############################################################
# Program:	ooo.cgi
#               Copyright 1999
#
# Description:	
#
# Author:	Dana French (dfrench@aignetplex.com)
#		 
#		(405) 936-2342
#
# Date:		04/26/99
#
#############################################################
# Modifications:
#
# 04/26/99	Version: 1.0
#		Original Code
################################################################
#
# httpd Environment Variables used
#
#	DOCUMENT_ROOT		Full path to top level html dir
#	SCRIPT_NAME		CGI path to this script
#	SCRIPT_FILENAME		Full path to this script
#
################################################################
h2a()
{
  sed -e "s/%\(..\)/\`print \"ibase=16; \1\" \| bc \| awk \'\{printf\(\"%c\",\$1\)\}\'\`/g"
}
################################################################
hex2ascii()
{
  HEXTMP=`h2a`
  eval print "${HEXTMP}"
}
################################################################
sedit()
{
hex2ascii | sed -e "\
s/,/,/g;\
s/\`/\'/g;\
s/+/ /g;\
s/%2[Ff]/\//g;\
s/     / /g;\
s/    / /g;\
s/   / /g;\
s/  / /g;\
s/^ //g"
}
################################################################
DOCUMENT_ROOT="/home/httpd/html"
# SCRIPT_NAME="/cgi-bin/fancyIndex/ooo.cgi"
# SCRIPT_FILENAME="/external/ns-home/cgi-bin/fancyIndex/ooo.cgi"

DOCUMENT_BASE="/fancyIndex/"
DOCUMENT_DIR="${DOCUMENT_ROOT}${DOCUMENT_BASE}"
SCRIPT_DIR=`dirname "${SCRIPT_FILENAME}"`
SCRIPT_CGI=`dirname "${SCRIPT_NAME}"`
SEARCHTERM=""

if [ "_${*}" = "_" ]
then
    DDDIR=""
    DD_DIR=""
else
    DDDIR=`print "${*}" | sedit`
    DD_DIR=`print "${*}" | sedit`
fi

for VARVAL in `print "${QUERY_STRING}" | sed -e "s/&/	/g"`
do
  if print "${VARVAL}" | grep -i "=" > /dev/null
  then
    VAR=`print "${VARVAL%=*}" | sedit`
    VAL=`print "${VARVAL#*=}" | sedit`
    eval ${VAR}="\"${VAL}\""
  fi
done

DDDIR=`print "${DDDIR}/" | sed -e "s|//$|/|g;s|^/$||g"`
DD_DIR=`print "${DDDIR}/" | sed -e "s/ /%20/g;s|//$|/|g;s|^/$||g"`

print "content-type:text/html
pragma: no-cache

<HTML>
<HEAD>
<TITLE>Apache FancyIndex - /${DDDIR}</TITLE>
</HEAD>
<BODY>
"

################################################################
if [[ -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.titlebar" ]]
then
    SUBTITLE=`basename "/${DDDIR}"`
    sed -e "s|<!-- Begin subtitle -->.*<!-- End subtitle -->|<!-- Begin subtitle -->${SUBTITLE}<!-- End subtitle -->|" "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.titlebar"
fi

[[ -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.linkbar" ]] && cat "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.linkbar"

################################################################

TODAY=`date +'%Y%m%d'`
cd "${DOCUMENT_DIR}${DDDIR}"

print "<P><CENTER><FONT Size=\"+2\"><STRONG>Out of office List</STRONG></CENTER></P>"

print "<P><DL>"

ls -1d */ | while read YYYYMMDD
do

TMPDIR=`print "${YYYYMMDD}" | sed -e "s|-||g"`

if [[ "_${DDDIR}" != "_" ]]
then
  if [[ "_${YYYYMMDD}" != "_" ]]
  then
    if [[ -d "${DOCUMENT_DIR}${DDDIR}${YYYYMMDD}" ]]
    then
      if [[ ${TMPDIR} -lt ${TODAY} ]]
      then
        rm -rf "${DOCUMENT_DIR}${DDDIR}${YYYYMMDD}"
        continue
      fi
    fi
  fi
fi

DATESTRING=`print "${YYYYMMDD%/*}" \
| sed -e "s|\(.*\)-01-\(.*\)|January \2, \1|g\
;s|\(.*\)-02-\(.*\)|February \2, \1|g\
;s|\(.*\)-03-\(.*\)|March \2, \1|g\
;s|\(.*\)-04-\(.*\)|April \2, \1|g\
;s|\(.*\)-05-\(.*\)|May \2, \1|g\
;s|\(.*\)-06-\(.*\)|June \2, \1|g\
;s|\(.*\)-07-\(.*\)|July \2, \1|g\
;s|\(.*\)-08-\(.*\)|August \2, \1|g\
;s|\(.*\)-09-\(.*\)|September \2, \1|g\
;s|\(.*\)-10-\(.*\)|October \2, \1|g\
;s|\(.*\)-11-\(.*\)|November \2, \1|g\
;s|\(.*\)-12-\(.*\)|December \2, \1|g"`

#     <DT><B><LI><FONT Size=\"4\" Color=\"black\">${YYYYMMDD%/*}</FONT></B>

print "    <P>
    <DT><B><LI><FONT Size=\"4\" Color=\"black\">${DATESTRING}</FONT></B>
"
  find "./${YYYYMMDD}" -type f -print | while read FILENAME
  do

print "      </P>
        <DD><FONT Size=\"3\" Color=\"black\">
"
    [[ ! -x "./${FILENAME}" ]] && chmod 775 "./${FILENAME}"
    . "./${FILENAME}"
    if [[ "_${OOO_STIME}" = "_Start of Day" && "_${OOO_ETIME}" = "_End of Day" ]]
    then

print "<LI> ${OOO_NAME} - out of office all day<BR><I>${OOO_COMMENT}</I>"

    else

print "<LI> ${OOO_NAME} - out of office from ${OOO_STIME} to ${OOO_ETIME}<BR><I>${OOO_COMMENT}</I>"

    fi

print "            </FONT>
        </DD>
      </P>
"
    done

print "    </DT>
    </P>
"

done

print "</DL>
</P>
"

################################################################


[[ -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.linkbar" ]] && cat "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.linkbar"
[[ -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.forinfo" ]] && cat "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.forinfo"

print "</BODY>
</HTML>"
