#!/bin/ksh
#############################################################
# Program:	oooAdd.cgi
#               Copyright 1999
#
# Description:	
#
# Author:	Dana French (dfrench@aignetplex.com)
#		 
#		(405) 936-2342
#
# Date:		04/26/99
#
#############################################################
# Modifications:
#
# 04/26/99	Version: 1.0
#		Original Code
################################################################
#
# httpd Environment Variables used
#
#	DOCUMENT_ROOT		Full path to top level html dir
#	SCRIPT_NAME		CGI path to this script
#	SCRIPT_FILENAME		Full path to this script
#
################################################################
h2a()
{
  sed -e "s/%\(..\)/\`print \"ibase=16; \1\" \| bc \| awk \'\{printf\(\"%c\",\$1\)\}\'\`/g"
}
################################################################
hex2ascii()
{
  HEXTMP=`h2a`
  eval print "${HEXTMP}"
}
################################################################
sedit()
{
hex2ascii | sed -e "\
s/,/,/g;\
s/\`/\'/g;\
s/+/ /g;\
s/%2[Ff]/\//g;\
s/     / /g;\
s/    / /g;\
s/   / /g;\
s/  / /g;\
s/^ //g"
}
################################################################
chkvalue()
{
  if [[ "_${3}" != "_NULL_OK" && "_${1}" = "_" ]]
  then
    print "<STRONG>ERROR:</STRONG> You did not supply a ${2}. Go back and try again.<BR>"
    EXITLEVEL="$(( ${EXITLEVEL} + 1 ))"
  else
    CHKVALUE_REMAIN=`print "${1}" | sed -e "s|[a-z,A-Z,0-9, ,\.,:,\,]||g"`
    if [[ "_${#CHKVALUE_REMAIN}" != "_" ]]
    then
      if [[ ${#CHKVALUE_REMAIN} -eq 0 ]]
      then
        print "<I>${2}</I> checked and accepted.<BR>"
      else
        print "<STRONG>ERROR:</STRONG> Invalid ${2}. Go back and try again.<BR>"
        EXITLEVEL="$(( ${EXITLEVEL} + 1 ))"
      fi
    else
      print "<STRONG>ERROR:</STRONG> Unable to perform validity check on ${2}. Go back and try again.<BR>"
      EXITLEVEL="$(( ${EXITLEVEL} + 1 ))"
    fi
  fi
}
################################################################
mkdotfile()
{
  print "<BR>Working on \"${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${DIRNAME}/${3}\"<BR>"
  cd "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${DIRNAME}"
  if [[ "_${1}" = "_1" ]]
  then
    print "Checking existance of \"${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${DIRNAME}/${3}\"<BR>"
    if [[ -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${DIRNAME}/${3}" ]]
    then
      print "Removing \"${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${DIRNAME}/${3}\"<BR>"
      rm -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${DIRNAME}/${3}"
    fi
  elif [[ "_${2}" = "_1" ]]
  then
    print "Checking existance of \"${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${DIRNAME}/${3}\"<BR>"
    if [[ -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${DIRNAME}/${3}" ]]
    then
      print "Removing \"${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${DIRNAME}/${3}\"<BR>"
      rm -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${DIRNAME}/${3}"
    fi
    print "Linking \"../${3}\" to \"./${3}\"<BR>"
    ln -s "../${3}" "./${3}"
  else
    print "Creating \"${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${DIRNAME}/${3}\"<BR>"
    print "${VAL}" | tr '\015' '\012' > "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${DIRNAME}/${3}"
  fi
}
################################################################
# DOCUMENT_ROOT="/external/ns-home/docs"
# SCRIPT_NAME="/cgi-bin/engine/engine.cgi"
# SCRIPT_FILENAME="/external/ns-home/cgi-bin/engine/engine.cgi"

DOCUMENT_BASE="/fancyIndex/"
DOCUMENT_DIR="${DOCUMENT_ROOT}${DOCUMENT_BASE}"
SCRIPT_DIR=`dirname "${SCRIPT_FILENAME}"`
SCRIPT_CGI=`dirname "${SCRIPT_NAME}"`
SEARCHTERM=""
PWPROTECTED="0"
ITM_URL=""
ITM_COMMENT=""

if [ "_${*}" = "_" ]
then
    DDDIR=""
    DD_DIR=""
else
    DDDIR=`print "${*}" | sedit`
    DD_DIR=`print "${*}" | sedit`
fi

DAYCNT="0"
for VARVAL in `print "${QUERY_STRING}" | sed -e "s/&/	/g"`
do
  if print "${VARVAL}" | grep -i "=" > /dev/null
  then
    VAR=`print "${VARVAL%=*}" | sedit`
    VAL=`print "${VARVAL#*=}" | sedit`
    eval ${VAR}="\"${VAL}\""
    if [[ "_${VAR}" = "_ITM_YEAR" ]]
    then
        ITM_YEARLIST[${YEARCNT}]="${VAL}"
        YEARCNT="$(( ${YEARCNT} + 1 ))"
    fi
    if [[ "_${VAR}" = "_ITM_MONTH" ]]
    then
        ITM_MONTHLIST[${MONTHCNT}]="${VAL}"
        MONTHCNT="$(( ${MONTHCNT} + 1 ))"
    fi
    if [[ "_${VAR}" = "_ITM_DAY" ]]
    then
        ITM_DAYLIST[${DAYCNT}]="${VAL}"
        DAYCNT="$(( ${DAYCNT} + 1 ))"
    fi
    if [[ "_${VAR}" = "_ITM_HOUR" ]]
    then
        ITM_HOURLIST[${HOURCNT}]="${VAL}"
        HOURCNT="$(( ${HOURCNT} + 1 ))"
    fi
    if [[ "_${VAR}" = "_ITM_MINUTE" ]]
    then
        ITM_MINUTELIST[${MINUTECNT}]="${VAL}"
        MINUTECNT="$(( ${MINUTECNT} + 1 ))"
    fi
  fi
done

DDDIR=`print "${DDDIR}/" | sed -e "s|//$|/|g;s|^/$||g"`
DD_DIR=`print "${DDDIR}/" | sed -e "s/ /%20/g;s|//$|/|g;s|^/$||g"`

print "content-type:text/html
pragma: no-cache

<HTML>
<HEAD>
<TITLE>Apache FancyIndex - /${DDDIR}</TITLE>
</HEAD>
"

if [[ -d "${DOCUMENT_DIR}" ]]
then
    if [[ -f "${DOCUMENT_DIR}${DDDIR}.bodytag" ]]
    then
        cat "${DOCUMENT_DIR}${DDDIR}.bodytag"
    else
        print "
<BODY Bgcolor=\"white\" Text=\"black\" Link=\"blue\" Vlink=\"red\" Alink=\"yellow\">
<BASEFONT Size=\"3\" Face=\"Arial\">
"
    fi
    if [[ -s "${DOCUMENT_DIR}${DDDIR}HEADER.html" ]]
    then
        cat "${DOCUMENT_DIR}${DDDIR}HEADER.html"
    elif [[ -s "${DOCUMENT_DIR}${DDDIR}.titlebar" ]]
    then
        cat "${DOCUMENT_DIR}${DDDIR}.titlebar"
    else
        print "<H2>Apache Fancy Index Input Form</H2>"
    fi
fi

# set | sed -e "s/$/<BR>/g"

print "<P><H2>Attempting to add out-of-office notice</H2></P>"

################################################################
####	First check the password protection parameters
################################################################

EXITLEVEL="0"
chkvalue "${ITM_NAME}" "Employee Name"
chkvalue "${ITM_COMMENT}" "Comment"
chkvalue "${ITM_YEAR}" "Year"
chkvalue "${ITM_MONTH}" "Month"
chkvalue "${ITM_DAY}" "Day"
chkvalue "${ITM_STIME}" "Start Time"
chkvalue "${ITM_ETIME}" "End Time"
chkvalue "${ITM_USERID}" "User ID"
chkvalue "${ITM_PASSWORD}" "Password"
chkvalue "${ITM_RETYPEPW}" "Retyped Password"

if [[ ${EXITLEVEL} -gt 0 ]]
then
  print "</BODY></HTML>"
  exit
fi

if [[ "_${ITM_PASSWORD}" != "_${ITM_RETYPEPW}" ]]
then
  print "<P><STRONG>ERROR: Passwords do not match. Go back and try again.</STRONG></P>"
  print "</BODY></HTML>"
  exit
fi

DAYCNT="${#ITM_DAYLIST[*]}"

print "DAYCNT=${DAYCNT}<br>"

LISTCNT="0"
OUTNAME="`date +'%Y%m%d%H%M%S'`${$}"
while [[ ${LISTCNT} -lt ${DAYCNT} ]]
do
  DATEDIR="${ITM_YEAR}-${ITM_MONTH}-${ITM_DAYLIST[${LISTCNT}]}"
  print "Working on ${DATEDIR}<BR>"
  if [[ ! -d "${DOCUMENT_DIR}${DDDIR}${DIRNAME}${DATEDIR}" ]]
  then 
    if mkdir "${DOCUMENT_DIR}${DDDIR}${DIRNAME}${DATEDIR}" 2>&1
    then
      print "${DATEDIR} directory created successfully<BR>"
    fi
  fi

  OUTFILE="${DOCUMENT_DIR}${DDDIR}${DIRNAME}${DATEDIR}/${OUTNAME}.app"

> ${OUTFILE}
  print "ITM_NAME=\"${ITM_NAME}\"" >> ${OUTFILE}
  print "ITM_COMMENT=\"${ITM_COMMENT}\"" >> ${OUTFILE}
  print "ITM_YEAR=\"${ITM_YEAR}\"" >> ${OUTFILE}
  print "ITM_MONTH=\"${ITM_MONTH}\"" >> ${OUTFILE}
  print "ITM_DAY=\"${ITM_DAYLIST[${LISTCNT}]}\"" >> ${OUTFILE}
  print "ITM_STIME=\"${ITM_STIME}\"" >> ${OUTFILE}
  print "ITM_ETIME=\"${ITM_ETIME}\"" >> ${OUTFILE}
  print "ITM_USERID=\"${ITM_USERID}\"" >> ${OUTFILE}
  print "ITM_PASSWORD=\"${ITM_PASSWORD}\"" >> ${OUTFILE}
  print "ITM_RETYPEPW=\"${ITM_RETYPEPW}\"" >> ${OUTFILE}

  LISTCNT="$(( ${LISTCNT} + 1 ))"
done        

print "<P>"
print "<BR><A Href=\"${SCRIPT_CGI}/oooAddForm.cgi?${DD_DIR}\">Add another out-of-office notice</A>"
print "<BR><A Href=\"${SCRIPT_CGI}/oooDelForm.cgi?${DD_DIR}\">Delete out-of-office notices</A>"
print "<BR><A href=\"${SCRIPT_CGI}/oooReindex.cgi?${DD_DIR}\">Reindex out-of-office list</A>"
print "<BR><A href=\"${DOCUMENT_BASE}${DD_DIR}\">Return to out-of-office list</A>"
print "</P>"

[[ -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.linkbar" ]] && cat "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.linkbar"
[[ -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.forinfo" ]] && cat "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.forinfo"

print "</BODY>
</HTML>"


