#!/bin/ksh
#############################################################
# Program:	oooDel.cgi
#               Copyright 1999
#
# Description:	
#
# Author:	Dana French (dfrench@aignetplex.com)
#		 
#		(405) 936-2342
#
# Date:		04/26/99
#
#############################################################
# Modifications:
#
# 04/26/99	Version: 1.0
#		Original Code
################################################################
#
# httpd Environment Variables used
#
#	DOCUMENT_ROOT		Full path to top level html dir
#	SCRIPT_NAME		CGI path to this script
#	SCRIPT_FILENAME		Full path to this script
#
################################################################
h2a()
{
  sed -e "s/%\(..\)/\`print \"ibase=16; \1\" \| bc \| awk \'\{printf\(\"%c\",\$1\)\}\'\`/g"
}
################################################################
hex2ascii()
{
  HEXTMP=`h2a`
  eval print "${HEXTMP}"
}
################################################################
sedit()
{
hex2ascii | sed -e "\
s/,/,/g;\
s/\`/\'/g;\
s/+/ /g;\
s/%2[Ff]/\//g;\
s/     / /g;\
s/    / /g;\
s/   / /g;\
s/  / /g;\
s/^ //g"
}
################################################################
chkvalue()
{
  if [[ "_${3}" != "_NULL_OK" && "_${1}" = "_" ]]
  then
    print "<STRONG>ERROR:</STRONG> You did not supply a ${2}. Go back and try again.<BR>"
    EXITLEVEL="$(( ${EXITLEVEL} + 1 ))"
  else
    CHKVALUE_REMAIN=`print "${1}" | sed -e "s|[a-z,A-Z,0-9, ,\.,:,\,]||g"`
    if [[ "_${#CHKVALUE_REMAIN}" != "_" ]]
    then
      if [[ ${#CHKVALUE_REMAIN} -eq 0 ]]
      then
        print "<I>${2}</I> checked and accepted.<BR>"
      else
        print "<STRONG>ERROR:</STRONG> Invalid ${2}. Go back and try again.<BR>"
        EXITLEVEL="$(( ${EXITLEVEL} + 1 ))"
      fi
    else
      print "<STRONG>ERROR:</STRONG> Unable to perform validity check on ${2}. Go back and try again.<BR>"
      EXITLEVEL="$(( ${EXITLEVEL} + 1 ))"
    fi
  fi
}
################################################################
mkdotfile()
{
  print "<BR>Working on \"${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${DIRNAME}/${3}\"<BR>"
  cd "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${DIRNAME}"
  if [[ "_${1}" = "_1" ]]
  then
    print "Checking existance of \"${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${DIRNAME}/${3}\"<BR>"
    if [[ -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${DIRNAME}/${3}" ]]
    then
      print "Removing \"${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${DIRNAME}/${3}\"<BR>"
      rm -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${DIRNAME}/${3}"
    fi
  elif [[ "_${2}" = "_1" ]]
  then
    print "Checking existance of \"${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${DIRNAME}/${3}\"<BR>"
    if [[ -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${DIRNAME}/${3}" ]]
    then
      print "Removing \"${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${DIRNAME}/${3}\"<BR>"
      rm -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${DIRNAME}/${3}"
    fi
    print "Linking \"../${3}\" to \"./${3}\"<BR>"
    ln -s "../${3}" "./${3}"
  else
    print "Creating \"${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${DIRNAME}/${3}\"<BR>"
    print "${VAL}" | tr '\015' '\012' > "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${DIRNAME}/${3}"
  fi
}
################################################################
# DOCUMENT_ROOT="/external/ns-home/docs"
# SCRIPT_NAME="/cgi-bin/engine/engine.cgi"
# SCRIPT_FILENAME="/external/ns-home/cgi-bin/engine/engine.cgi"

DOCUMENT_BASE="/fancyIndex/"
DOCUMENT_DIR="${DOCUMENT_ROOT}${DOCUMENT_BASE}"
SCRIPT_DIR=`dirname "${SCRIPT_FILENAME}"`
SCRIPT_CGI=`dirname "${SCRIPT_NAME}"`
SEARCHTERM=""
PWPROTECTED="0"
ITM_URL=""
ITM_COMMENT=""

if [ "_${*}" = "_" ]
then
    DDDIR=""
    DD_DIR=""
else
    DDDIR=`print "${*}" | sedit`
    DD_DIR=`print "${*}" | sedit`
fi

DAYCNT="0"
for VARVAL in `print "${QUERY_STRING}" | sed -e "s/&/	/g"`
do
  if print "${VARVAL}" | grep -i "=" > /dev/null
  then
    VAR=`print "${VARVAL%=*}" | sedit`
    VAL=`print "${VARVAL#*=}" | sedit`
    eval ${VAR}="\"${VAL}\""
    if [[ "_${VAR}" = "_ITM_YEAR" ]]
    then
        ITM_YEARLIST[${YEARCNT}]="${VAL}"
        YEARCNT="$(( ${YEARCNT} + 1 ))"
    fi
    if [[ "_${VAR}" = "_ITM_MONTH" ]]
    then
        ITM_MONTHLIST[${MONTHCNT}]="${VAL}"
        MONTHCNT="$(( ${MONTHCNT} + 1 ))"
    fi
    if [[ "_${VAR}" = "_ITM_DAY" ]]
    then
        ITM_DAYLIST[${DAYCNT}]="${VAL}"
        DAYCNT="$(( ${DAYCNT} + 1 ))"
    fi
    if [[ "_${VAR}" = "_ITM_HOUR" ]]
    then
        ITM_HOURLIST[${HOURCNT}]="${VAL}"
        HOURCNT="$(( ${HOURCNT} + 1 ))"
    fi
    if [[ "_${VAR}" = "_ITM_MINUTE" ]]
    then
        ITM_MINUTELIST[${MINUTECNT}]="${VAL}"
        MINUTECNT="$(( ${MINUTECNT} + 1 ))"
    fi
  fi
done

DDDIR=`print "${DDDIR}/" | sed -e "s|//$|/|g;s|^/$||g"`
DD_DIR=`print "${DDDIR}/" | sed -e "s/ /%20/g;s|//$|/|g;s|^/$||g"`

print "content-type:text/html
pragma: no-cache

<HTML>
<HEAD>
<TITLE>Apache FancyIndex - /${DDDIR}</TITLE>
</HEAD>
"

if [[ -d "${DOCUMENT_DIR}" ]]
then
    if [[ -f "${DOCUMENT_DIR}${DDDIR}.bodytag" ]]
    then
        cat "${DOCUMENT_DIR}${DDDIR}.bodytag"
    else
        print "
<BODY Bgcolor=\"white\" Text=\"black\" Link=\"blue\" Vlink=\"red\" Alink=\"yellow\">
<BASEFONT Size=\"3\" Face=\"Arial\">
"
    fi
    if [[ -s "${DOCUMENT_DIR}${DDDIR}HEADER.html" ]]
    then
        cat "${DOCUMENT_DIR}${DDDIR}HEADER.html"
    elif [[ -s "${DOCUMENT_DIR}${DDDIR}.titlebar" ]]
    then
        cat "${DOCUMENT_DIR}${DDDIR}.titlebar"
    else
        print "<H2>Apache Fancy Index Input Form</H2>"
    fi
fi

# set | sed -e "s/$/<BR>/g"

print "<P><H2>Attempting to delete out-of-office notice</H2></P>"

################################################################
####	First check the password protection parameters
################################################################

EXITLEVEL="0"
chkvalue "${ITM_USERID}" "User ID"
chkvalue "${ITM_PASSWORD}" "Password"

if [[ ${EXITLEVEL} -gt 0 ]]
then
  print "</BODY></HTML>"
  exit
fi

CHK_USERID="${ITM_USERID}"
CHK_PASSWORD="${ITM_PASSWORD}"

print "<P><H2>Deleting Out-of-Office Notifications</H2></P>"

for VARVAL in `print "${QUERY_STRING}" | sed -e "s/&/	/g"`
do
  if print "${VARVAL}" | grep -i "=" > /dev/null
  then
    VAR=`print "${VARVAL%=*}" | sedit`
    VAL=`print "${VARVAL#*=}" | sedit`
    if print "${VAR}" | grep "ITM_FILE_" >/dev/null 2>&1
    then
      ITM_FILE=`print "${VAR}" | sed -e "s|ITM_FILE_||g"`
      ITM_USERID=""
      ITM_PASSWORD=""
      . "${DOCUMENT_DIR}${DDDIR}${ITM_FILE}"

# print "ITM_USERID=${ITM_USERID}<BR>"
# print "CHK_USERID=${CHK_USERID}<BR>"
# print "ITM_PASSWORD=${ITM_PASSWORD}<BR>"
# print "CHK_PASSWORD=${CHK_PASSWORD}<BR>"

      if [[ "_${ITM_USERID}" = "_${CHK_USERID}" ]]
      then
        if [[ "_${ITM_PASSWORD}" = "_${CHK_PASSWORD}" ]]
        then
          rm -f "${DOCUMENT_DIR}${DDDIR}${ITM_FILE}"
        else
          print "<BR><STRONG>ERROR</STRONG>: Passwords do not match.  Unable to remove \"${DOCUMENT_DIR}${DDDIR}${ITM_FILE}\"<BR>"
        fi
      else
        print "<BR><STRONG>ERROR</STRONG>: User ID's do not match.  Unable to remove \"${DOCUMENT_DIR}${DDDIR}${ITM_FILE}\"<BR>"
      fi

      if [[ -f "${DOCUMENT_DIR}${DDDIR}${ITM_FILE}" ]]
      then
        print "<BR><STRONG>ERROR</STRONG>: Unable to remove \"${DOCUMENT_DIR}${DDDIR}${ITM_FILE}\"<BR>"
      else
        print "Successfully removed \"${DOCUMENT_DIR}${DDDIR}${ITM_FILE}\"<BR>"
      fi
      ITM_DIR=`dirname "${DOCUMENT_DIR}${DDDIR}${ITM_FILE}"`
      rmdir "${ITM_DIR}" 2>/dev/null
    fi
  fi
done

################################################################

print "<P>"
print "<BR><A Href=\"${SCRIPT_CGI}/oooAddForm.cgi?${DD_DIR}\">Add an out-of-office notice</A>"
print "<BR><A Href=\"${SCRIPT_CGI}/oooDelForm.cgi?${DD_DIR}\">Delete another out-of-office notice</A>"
print "<BR><A href=\"${SCRIPT_CGI}/oooReindex.cgi?${DD_DIR}\">Reindex out-of-office list</A>"
print "<BR><A href=\"${DOCUMENT_BASE}${DD_DIR}\">Return to out-of-office list</A>"
print "</P>"

[[ -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.linkbar" ]] && cat "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.linkbar"
[[ -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.forinfo" ]] && cat "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.forinfo"

print "</BODY>
</HTML>"


