#!/bin/ksh
#############################################################
# Program:	oooReindex.cgi
#               Copyright 1999
#
# Description:	
#
# Author:	Dana French (dfrench@aignetplex.com)
#		 
#		(405) 936-2342
#
# Date:		04/26/99
#
#############################################################
# Modifications:
#
# 04/26/99	Version: 1.0
#		Original Code
################################################################
#
# httpd Environment Variables used
#
#	DOCUMENT_ROOT		Full path to top level html dir
#	SCRIPT_NAME		CGI path to this script
#	SCRIPT_FILENAME		Full path to this script
#
################################################################
h2a()
{
  sed -e "s/%\(..\)/\`print \"ibase=16; \1\" \| bc \| awk \'\{printf\(\"%c\",\$1\)\}\'\`/g"
}
################################################################
hex2ascii()
{
  HEXTMP=`h2a`
  eval print "${HEXTMP}"
}
################################################################
sedit()
{
hex2ascii | sed -e "\
s/,/,/g;\
s/\`/\'/g;\
s/+/ /g;\
s/%2[Ff]/\//g;\
s/     / /g;\
s/    / /g;\
s/   / /g;\
s/  / /g;\
s/^ //g"
}
################################################################
# DOCUMENT_ROOT="/home/httpd/html"
# SCRIPT_NAME="/cgi-bin/fancyIndex/oooReindex.cgi"
# SCRIPT_FILENAME="/external/ns-home/cgi-bin/fancyIndex/oooReindex.cgi"

DOCUMENT_BASE="/fancyIndex/"
DOCUMENT_DIR="${DOCUMENT_ROOT}${DOCUMENT_BASE}"
SCRIPT_DIR=`dirname "${SCRIPT_FILENAME}"`
SCRIPT_CGI=`dirname "${SCRIPT_NAME}"`
SEARCHTERM=""

if [ "_${*}" = "_" ]
then
    DDDIR=""
    DD_DIR=""
else
    DDDIR=`print "${*}" | sedit`
    DD_DIR=`print "${*}" | sedit`
fi

for VARVAL in `print "${QUERY_STRING}" | sed -e "s/&/	/g"`
do
  if print "${VARVAL}" | grep -i "=" > /dev/null
  then
    VAR=`print "${VARVAL%=*}" | sedit`
    VAL=`print "${VARVAL#*=}" | sedit`
    eval ${VAR}="\"${VAL}\""
  fi
done

DDDIR=`print "${DDDIR}/" | sed -e "s|//$|/|g;s|^/$||g"`
DD_DIR=`print "${DDDIR}/" | sed -e "s/ /%20/g;s|//$|/|g;s|^/$||g"`

print "content-type:text/html
pragma: no-cache

<HTML>
<HEAD>
<TITLE>Apache FancyIndex - /${DDDIR}</TITLE>
</HEAD>
<BODY>
"

################################################################
# [[ -f "${DOCUMENT_DIR}${DDDIR}.titlebar" ]] && cat "${DOCUMENT_DIR}${DDDIR}.titlebar" | tee "${DOCUMENT_DIR}${DDDIR}HEADER.html"
# [[ -f "${DOCUMENT_DIR}${DDDIR}.linkbar" ]] && cat "${DOCUMENT_DIR}${DDDIR}.linkbar" | tee -a >> "${DOCUMENT_DIR}${DDDIR}HEADER.html"

# original .titlebar [[ -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.titlebar" ]] && cat "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.titlebar" | tee "${DOCUMENT_DIR}${DDDIR}HEADER.html"

rm -f "${DOCUMENT_DIR}${DDDIR}HEADER.html"
if [[ -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.titlebar" ]]
then
    SUBTITLE=`basename "/${DDDIR}"`
    sed -e "s|<!-- Begin subtitle -->.*<!-- End subtitle -->|<!-- Begin subtitle -->${SUBTITLE}<!-- End subtitle -->|" "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.titlebar" | tee "${DOCUMENT_DIR}${DDDIR}HEADER.html"
fi

[[ -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.linkbar" ]] && cat "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.linkbar" | tee -a >> "${DOCUMENT_DIR}${DDDIR}HEADER.html"
################################################################

print "
<!-- Begin directories -->
<P><BLOCKQUOTE><FONT Size=\"+1\"><STRONG>
" | tee -a "${DOCUMENT_DIR}${DDDIR}HEADER.html"

cd "${DOCUMENT_DIR}${DDDIR}"
URLPATH="${DOCUMENT_BASE}"
pwd | sed -e "s|${DOCUMENT_ROOT}||g;s|^/||g;s|/$||g" | tr '/' '\012' | while read DIR
do
    if [[ "_${DIR}" = "_fancyIndex" ]]
    then

      print "<A Href=\"${URLPATH}\"> Home </A>" | tee -a "${DOCUMENT_DIR}${DDDIR}HEADER.html"

    else

      URLPATH=`print "${URLPATH}${DIR}/" | sed -e "s/ /%20/g;s/	/%20/g"`
      print " : <A Href=\"${URLPATH}\"> ${DIR} </A>" | tee -a "${DOCUMENT_DIR}${DDDIR}HEADER.html"

    fi

  done

  print "
</STRONG></FONT></BLOCKQUOTE></P>
<!-- End directories -->
" | tee -a "${DOCUMENT_DIR}${DDDIR}HEADER.html"

################################################################
# [[ -f "${DOCUMENT_DIR}${DDDIR}.description" ]] && cat "${DOCUMENT_DIR}${DDDIR}.description" | tee -a "${DOCUMENT_DIR}${DDDIR}HEADER.html"
[[ -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.description" ]] && cat "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.description" | tee -a "${DOCUMENT_DIR}${DDDIR}HEADER.html"
################################################################


################################################################
# Begin inserting out-of-office notices
################################################################

TODAY=`date +'%Y%m%d'`
cd "${DOCUMENT_DIR}${DDDIR}"

print "<P><CENTER><FONT Size=\"+2\"><STRONG>Out of office List</STRONG></FONT></CENTER></P>" | tee -a "${DOCUMENT_DIR}${DDDIR}HEADER.html"

print "<P><DL>" | tee -a "${DOCUMENT_DIR}${DDDIR}HEADER.html"

ls -1d */ | while read YYYYMMDD
do

TMPDIR=`print "${YYYYMMDD}" | sed -e "s|-||g"`

if [[ "_${DDDIR}" != "_" ]]
then
  if [[ "_${YYYYMMDD}" != "_" ]]
  then
    if [[ -d "${DOCUMENT_DIR}${DDDIR}${YYYYMMDD}" ]]
    then
      if [[ ${TMPDIR} -lt ${TODAY} ]]
      then
        rm -rf "${DOCUMENT_DIR}${DDDIR}${YYYYMMDD}"
        continue
      fi
    fi
  fi
fi

DATESTRING=`print "${YYYYMMDD%/*}" \
| sed -e "s|\(.*\)-01-\(.*\)|January \2, \1|g\
;s|\(.*\)-02-\(.*\)|February \2, \1|g\
;s|\(.*\)-03-\(.*\)|March \2, \1|g\
;s|\(.*\)-04-\(.*\)|April \2, \1|g\
;s|\(.*\)-05-\(.*\)|May \2, \1|g\
;s|\(.*\)-06-\(.*\)|June \2, \1|g\
;s|\(.*\)-07-\(.*\)|July \2, \1|g\
;s|\(.*\)-08-\(.*\)|August \2, \1|g\
;s|\(.*\)-09-\(.*\)|September \2, \1|g\
;s|\(.*\)-10-\(.*\)|October \2, \1|g\
;s|\(.*\)-11-\(.*\)|November \2, \1|g\
;s|\(.*\)-12-\(.*\)|December \2, \1|g"`

#     <DT><B><LI><FONT Size=\"4\" Color=\"black\">${YYYYMMDD%/*}</FONT></B>

print "    <P>
    <DT><B><LI><FONT Size=\"4\" Color=\"black\">${DATESTRING}</FONT></B>
" | tee -a "${DOCUMENT_DIR}${DDDIR}HEADER.html"

  find "./${YYYYMMDD}" -type f -name \*.app -print | while read FILENAME
  do

print "      </P>
        <DD><FONT Size=\"3\" Color=\"black\">
" | tee -a "${DOCUMENT_DIR}${DDDIR}HEADER.html"

    [[ ! -x "./${FILENAME}" ]] && chmod 775 "./${FILENAME}"
    . "./${FILENAME}"
    if [[ "_${ITM_STIME}" = "_Start of Day" && "_${ITM_ETIME}" = "_End of Day" ]]
    then

print "<LI> ${ITM_NAME} - out of office all day<BR><I>${ITM_COMMENT}</I>" | tee -a "${DOCUMENT_DIR}${DDDIR}HEADER.html"

    else

print "<LI> ${ITM_NAME} - out of office from ${ITM_STIME} to ${ITM_ETIME}<BR><I>${ITM_COMMENT}</I>" | tee -a "${DOCUMENT_DIR}${DDDIR}HEADER.html"

    fi

print "            </FONT>
        </DD>
      </P>
" | tee -a "${DOCUMENT_DIR}${DDDIR}HEADER.html"

    done

print "    </DT>
    </P>
" | tee -a "${DOCUMENT_DIR}${DDDIR}HEADER.html"

done

print "</DL>
</P>
" | tee -a "${DOCUMENT_DIR}${DDDIR}HEADER.html"

################################################################
# end inserting out-of-office notices
################################################################

print "
<P><B>Links:</B><BR>
<P><CENTER><TABLE Border=\"0\" Cellpadding=\"2\" Cellspacing=\"2\" Width=\"100%\">
" | tee "${DOCUMENT_DIR}${DDDIR}README.html"

rm -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.index"
cd "${DOCUMENT_DIR}${DDDIR}"
ls -1 *.url 2>/dev/null | while read LINKNAME
do
  if [[ "_${LINKNAME}" != "_" ]]
  then
    URL_LINK=""
    URL_NAME=""
    URL_DESC=""

    [[ ! -x "./${LINKNAME}" ]] && chmod 775 "./${LINKNAME}"
    . "./${LINKNAME}"

    if [[ "_${URL_LINK}" != "_" ]]
    then
      if [[ "_${URL_NAME}" != "_" ]]
      then
        if [[ "_${URL_DESC}" != "_" ]]
        then
print "${URL_NAME}|${URL_LINK}|${URL_DESC}" >> "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.index"
        fi
      fi
    fi
  fi

done

# if [[ -s "${DOCUMENT_DIR}${DDDIR}.index" ]]
if [[ -s "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.index" ]]
then

sed -e "s/|\(.*\)$/FIELDPIPE01\1/g\
;s/|\(.*\)$/FIELDPIPE02\1/g\
;s|^\(.*\)FIELDPIPE01\(.*\)FIELDPIPE02\(.*\)$|<P><TR><TD Width=\"20%\" Align=\"left\" Valign=\"middle\"><FONT Size=\"-1\"><A Href=\"\2\">\1</A>:</FONT></TD><TD><FONT Size=\"-1\">\3</FONT></TD></TR></P>|g\
;s|<A Href=\"\">\(.*\)</A>:|<A Href=\"${DOCUMENT_BASE}${DD_DIR}\1\">\1</A>:|g" < "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.index" | tee -a "${DOCUMENT_DIR}${DDDIR}README.html"

fi

if [[ -s "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.index" ]] \
&& [[ -s "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.links" ]]
then

print "
<P><TR><TD Width=\"20%\" Align=\"left\" Valign=\"middle\">
<FONT Size=\"-1\"><HR></FONT>
</TD><TD>
<FONT Size=\"-1\"><HR></FONT>
</TD></TR></P>
" | tee -a "${DOCUMENT_DIR}${DDDIR}README.html"

fi


# if [[ -s "${DOCUMENT_DIR}${DDDIR}.links" ]]
if [[ -s "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.links" ]]
then

sed -e "s/|\(.*\)$/FIELDPIPE01\1/g\
;s/|\(.*\)$/FIELDPIPE02\1/g\
;s|^\(.*\)FIELDPIPE01\(.*\)FIELDPIPE02\(.*\)$|<P><TR><TD Width=\"20%\" Align=\"left\" Valign=\"middle\"><FONT Size=\"-1\"><A Href=\"\2\">\1</A>:</FONT></TD><TD><FONT Size=\"-1\">\3</FONT></TD></TR></P>|g\
;s|<A Href=\"\">\(.*\)</A>:|<A Href=\"${DOCUMENT_BASE}${DD_DIR}\1\">\1</A>:|g" < "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.links" | tee -a "${DOCUMENT_DIR}${DDDIR}README.html"

fi

print "</TABLE></CENTER></P>" | tee -a "${DOCUMENT_DIR}${DDDIR}README.html"

# [[ -f "${DOCUMENT_DIR}${DDDIR}.linkbar" ]] && cat "${DOCUMENT_DIR}${DDDIR}.linkbar" | tee -a "${DOCUMENT_DIR}${DDDIR}README.html"
# [[ -f "${DOCUMENT_DIR}${DDDIR}.forinfo" ]] && cat "${DOCUMENT_DIR}${DDDIR}.forinfo" | tee -a "${DOCUMENT_DIR}${DDDIR}README.html"
[[ -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.linkbar" ]] && cat "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.linkbar" | tee -a "${DOCUMENT_DIR}${DDDIR}README.html"
[[ -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.forinfo" ]] && cat "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.forinfo" | tee -a "${DOCUMENT_DIR}${DDDIR}README.html"

################################################################
####  subdir htaccess file creation
####  and parent dir htaccess file modification
################################################################

# [[ -f "${DOCUMENT_DIR}${DDDIR}.htaccessrc" ]] && cat "${DOCUMENT_DIR}${DDDIR}.htaccessrc" > "${DOCUMENT_DIR}${DDDIR}.htaccess"
[[ -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.htaccessrc" ]] && cat "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.htaccessrc" > "${DOCUMENT_DIR}${DDDIR}.htaccess"

cd "${DOCUMENT_DIR}${DDDIR}"
ls -1 *.desc 2>/dev/null | while read FILENAME
do
  if [[ "_${FILENAME}" != "_" ]]
  then
    FILE_LINK=""
    FILE_NAME=""
    FILE_DESC=""

    [[ ! -x "./${FILENAME}" ]] && chmod 775 "./${FILENAME}"
    . "./${FILENAME}" 2>&1

    if [[ "_${FILE_NAME}" != "_" ]]
    then
      if [[ "_${FILE_DESC}" != "_" ]]
      then
print "AddDescription \"${FILE_DESC}\" \"${FILE_NAME}\"" >> "${DOCUMENT_DIR}${DDDIR}.htaccess"
      fi
    fi
  fi

done

################################################################

# cd "${DOCUMENT_DIR}${DDDIR}"
cd "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}"
# ls -a1 .DD_* | while read DIR
ls -a1 */.shortdescription 2>/dev/null | while read DIR
do
    DD_DESC=`cat "${DIR}"`
    print "AddDescription \"${DD_DESC}\" \"${DIR%/*}\"" >> "${DOCUMENT_DIR}${DDDIR}.htaccess"
done

################################################################

cd "${DOCUMENT_DIR}${DDDIR}"
find . -type d -print | while read DIRNAME
do
    print "IndexIgnore \"${DIRNAME}\"" >> "${DOCUMENT_DIR}${DDDIR}.htaccess"
done

# if [[ -s "${DOCUMENT_DIR}${DDDIR}.dirs" ]]
# then
# 
# sed -e "s/|\(.*\)$/FIELDPIPE01\1/g\
# ;s|^\(.*\)FIELDPIPE01\(.*\)$|AddDescription \"\2\" \"\1\"|g" < "${DOCUMENT_DIR}${DDDIR}.dirs" >> ".htaccess"
# 
# fi

################################################################

print "
</BODY>
</HTML>"
