#!/bin/ksh
#############################################################
# Program:	orgchartMkdir.cgi
#               Copyright 1999
#
# Description:	
#
# Author:	Dana French (dfrench@aignetplex.com)
#		 
#		(405) 936-2342
#
# Date:		04/26/99
#
#############################################################
# Modifications:
#
# 04/26/99	Version: 1.0
#		Original Code
################################################################
#
# httpd Environment Variables used
#
#	DOCUMENT_ROOT		Full path to top level html dir
#	SCRIPT_NAME		CGI path to this script
#	SCRIPT_FILENAME		Full path to this script
#
################################################################
h2a()
{
  sed -e "s/%\(..\)/\`print \"ibase=16; \1\" \| bc \| awk \'\{printf\(\"%c\",\$1\)\}\'\`/g"
}
################################################################
hex2ascii()
{
  HEXTMP=`h2a`
  eval print "${HEXTMP}"
}
################################################################
sedit()
{
hex2ascii | sed -e "\
s/,/,/g;\
s/\`/\'/g;\
s/+/ /g;\
s/%2[Ff]/\//g;\
s/     / /g;\
s/    / /g;\
s/   / /g;\
s/  / /g;\
s/^ //g"
}
################################################################
chkvalue()
{
  if [[ "_${1}" = "_" ]]
  then
    print "<STRONG>ERROR:</STRONG> You did not supply a ${2}. Go back and try again.<BR>"
    EXITLEVEL="$(( ${EXITLEVEL} + 1 ))"
  else
    CHKVALUE_REMAIN=`print "${1}" | sed -e "s|[a-z,A-Z,0-9, ,\.,@]||g"`
    if [[ "_${#CHKVALUE_REMAIN}" != "_" ]]
    then
      if [[ ${#CHKVALUE_REMAIN} -eq 0 ]]
      then
        print "<I>${2}</I> checked and accepted.<BR>"
      else
        print "<STRONG>ERROR:</STRONG> Invalid ${2}. Go back and try again.<BR>"
        EXITLEVEL="$(( ${EXITLEVEL} + 1 ))"
      fi
    else
      print "<STRONG>ERROR:</STRONG> Unable to perform validity check on ${2}. Go back and try again.<BR>"
      EXITLEVEL="$(( ${EXITLEVEL} + 1 ))"
    fi
  fi
}
################################################################
mkdotfile()
{
  print "<BR>Working on \"${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${ENT_NAME}/${3}\"<BR>"
  cd "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${ENT_NAME}"
  if [[ "_${1}" = "_1" ]]
  then
    print "Checking existance of \"${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${ENT_NAME}/${3}\"<BR>"
    if [[ -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${ENT_NAME}/${3}" ]]
    then
      print "Removing \"${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${ENT_NAME}/${3}\"<BR>"
      rm -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${ENT_NAME}/${3}"
    fi
  elif [[ "_${2}" = "_1" ]]
  then
    print "Checking existance of \"${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${ENT_NAME}/${3}\"<BR>"
    if [[ -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${ENT_NAME}/${3}" ]]
    then
      print "Removing \"${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${ENT_NAME}/${3}\"<BR>"
      rm -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${ENT_NAME}/${3}"
    fi
    print "Linking \"../${3}\" to \"./${3}\"<BR>"
    ln -s "../${3}" "./${3}"
  else
    print "Creating \"${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${ENT_NAME}/${3}\"<BR>"
    print "${VAL}" | tr '\015' '\012' > "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${ENT_NAME}/${3}"
  fi
}
################################################################




# DOCUMENT_ROOT="/external/ns-home/docs"
# SCRIPT_NAME="/cgi-bin/engine/engine.cgi"
# SCRIPT_FILENAME="/external/ns-home/cgi-bin/engine/engine.cgi"

DOCUMENT_BASE="/fancyIndex/"
DOCUMENT_DIR="${DOCUMENT_ROOT}${DOCUMENT_BASE}"
SCRIPT_DIR=`dirname "${SCRIPT_FILENAME}"`
SCRIPT_CGI=`dirname "${SCRIPT_NAME}"`
SEARCHTERM=""
ENT_PWPROTECT="0"
################################################################
. ${SCRIPT_DIR}/hex2ascii.ksh
################################################################

if [ "_${*}" = "_" ]
then
    DDDIR=""
    DD_DIR=""
else
    DDDIR=`print "${*}" | sedit`
    DD_DIR=`print "${*}" | sedit`
fi

for VARVAL in `print "${QUERY_STRING}" | sed -e "s/&/	/g"`
do
  if print "${VARVAL}" | grep -i "=" > /dev/null
  then
    VAR=`print "${VARVAL%=*}" | sedit`
    VAL=`print "${VARVAL#*=}" | sedit`
    eval ${VAR}="\"${VAL}\""
  fi
done

DDDIR=`print "${DDDIR}/" | sed -e "s|//$|/|g;s|^/$||g"`
DD_DIR=`print "${DDDIR}/" | sed -e "s/ /%20/g;s|//$|/|g;s|^/$||g"`

print "content-type:text/html
pragma: no-cache

<HTML>
<HEAD>
<TITLE>Apache FancyIndex - /${DDDIR}</TITLE>
</HEAD>
"

if [[ -d "${DOCUMENT_DIR}" ]]
then
    if [[ -f "${DOCUMENT_DIR}${DDDIR}.bodytag" ]]
    then
        cat "${DOCUMENT_DIR}${DDDIR}.bodytag"
    else
        print "
<BODY Bgcolor=\"white\" Text=\"black\" Link=\"blue\" Vlink=\"red\" Alink=\"yellow\">
<BASEFONT Size=\"3\" Face=\"Arial\">
"
    fi
    if [[ -s "${DOCUMENT_DIR}${DDDIR}HEADER.html" ]]
    then
        cat "${DOCUMENT_DIR}${DDDIR}HEADER.html"
    elif [[ -s "${DOCUMENT_DIR}${DDDIR}.titlebar" ]]
    then
        cat "${DOCUMENT_DIR}${DDDIR}.titlebar"
    else
        print "<H2>Apache Fancy Index Input Form</H2>"
    fi
fi

# set | sed -e "s/$/<BR>/g"

print "<P><H2>Attempting to create a subdivision</H2></P>"

################################################################
####	First check the password protection parameters
################################################################

EXITLEVEL="0"
chkvalue "${ENT_NAME}" "Subdivision Name"
chkvalue "${ENT_DESC}" "Short Description"
chkvalue "${ENT_USERID}" "User ID"
chkvalue "${ENT_PASSWORD}" "Password"

################################################################
####	begin comparing passwords
################################################################
EXITLEVEL="1"
if [[ -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.diradmin" ]]
then

rm -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}diradmin.tmp"
/usr/local/apache/bin/htpasswd -b -c -p "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}diradmin.tmp" "${ENT_USERID}" "${ENT_PASSWORD}" >/dev/null 2>&1
  if [[ -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}diradmin.tmp" ]]
  then
    if grep "${ENT_USERID}" "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.diradmin" | head -1 | diff - "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}diradmin.tmp" > /dev/null 2>&1
    then
      print "<BR>Administrative User Verified.<BR>"
      EXITLEVEL="0"
    else
      print "<BR><STRONG>ERROR:</STRONG> Administrative login failed.<BR>"
    fi
    rm -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}diradmin.tmp"
  else
    print "<BR><STRONG>ERROR:</STRONG> Unable to compare administrative login.<BR>"
  fi

else

  print "<BR><STRONG>ERROR:</STRONG> Unable to verify administrative user.<BR>"

fi

if [[ ${EXITLEVEL} -gt 0 ]]
then

[[ -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.linkbar" ]] && cat "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.linkbar"
[[ -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.forinfo" ]] && cat "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.forinfo"

print "</BODY></HTML>"
exit

fi
################################################################
####	end comparing passwords
################################################################
	
if [[ ! -d "${DOCUMENT_DIR}${DDDIR}${ENT_NAME}" ]]
then 
    if mkdir "${DOCUMENT_DIR}${DDDIR}${ENT_NAME}" 2>&1
    then
        print "${DOCUMENT_BASE}${DDDIR}${ENT_NAME} Subdivision created successfully<BR>"
        if mkdir "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${ENT_NAME}" 2>&1
        then
            print "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${ENT_NAME} subdivision created successfully<BR>"
        else
            print "<BR><STRONG>ERROR:</STRONG> Unable to create subdivision ${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${ENT_NAME}<BR>"
            print "</BODY></HTML>"
            exit
        fi
    else
        print "<BR><STRONG>ERROR:</STRONG> unable to create subdivision ${DOCUMENT_BASE}${DDDIR}${ENT_NAME}<BR>"
        print "</BODY></HTML>"
        exit
    fi
else
    print "<STRONG>ERROR:</STRONG> ${DOCUMENT_BASE}${DDDIR}${ENT_NAME} Subdivision already exists<BR>"
fi

for VARVAL in `print "${QUERY_STRING}" | sed -e "s/&/	/g"`
do
  if print "${VARVAL}" | grep -i "=" > /dev/null
  then
    VAR=`print "${VARVAL%=*}" | sedit`
    VAL=`print "${VARVAL#*=}" | sedit`
    eval ${VAR}="\"${VAL}\""
  fi

  print "Working on <CODE>${VAR}</CODE>..."

    case "_${VAR}" in
        "_TITLEBAR") mkdotfile "${DELTITLEBAR}" "${SLINKTITLEBAR}" ".titlebar";;
        "_LINKBAR") mkdotfile "${DELLINKBAR}" "${SLINKLINKBAR}" ".linkbar";;
        "_DESCRIPTION") mkdotfile "${DELDESCRIPTION}" "${SLINKDESCRIPTION}" ".description";;
        "_FORINFO") mkdotfile "${DELFORINFO}" "${SLINKFORINFO}" ".forinfo";;
        "_HTACCESS") mkdotfile "${DELHTACCESS}" "${SLINKHTACCESS}" ".htaccessrc";;
        "_ENT_DESC") print "${VAL}" | tr '\015' '\012' > "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${ENT_NAME}/.shortdescription";;
	"_ENT_NAME") ENT_NAME_PERCENT=`print "${ENT_NAME}" | sed -e "s/ /%20/g;s/	/%20/g"`;;
    esac
    print "<BR>"

done

print "Utilities|${SCRIPT_CGI}/utilities.cgi?${DD_DIR}${ENT_NAME_PERCENT}|Utilities to control the look and feel of the current directory.  Also user and password utils for password protected directories." >> "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${ENT_NAME}/.links"
print "Add an Item|${SCRIPT_CGI}/orgchartAddForm.cgi?${DD_DIR}${ENT_NAME_PERCENT}|Add an Item" >> "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${ENT_NAME}/.links"
print "Add a Subdivision|${SCRIPT_CGI}/orgchartSubForm.cgi?${DD_DIR}${ENT_NAME_PERCENT}|Add a Subdivision" >> "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${ENT_NAME}/.links"
print "Manage Subdivision|${SCRIPT_CGI}/orgchartManageForm.cgi?${DD_DIR}${ENT_NAME_PERCENT}|Administrative management of subdivision" >> "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${ENT_NAME}/.links"
print "Reindex Subdivision|${SCRIPT_CGI}/orgchartReindex.cgi?${DD_DIR}${ENT_NAME_PERCENT}|Reindex the control files under the Subdivision" >> "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${ENT_NAME}/.links"

################################################################
####  subdir htaccess file creation
####  and parent dir htaccess file modification
################################################################

[[ -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${ENT_NAME}/.htaccessrc" ]] && cat "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${ENT_NAME}/.htaccessrc" > "${DOCUMENT_DIR}${DDDIR}${ENT_NAME}/.htaccess"
[[ -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.htaccessrc" ]] && cat "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.htaccessrc" > "${DOCUMENT_DIR}${DDDIR}.htaccess"

cd "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}"
ls -a1 */.shortdescription 2>/dev/null | while read DIR
do
    DD_DESC=`cat "${DIR}"`
    print "AddDescription \"${DD_DESC}\" \"${DIR%/*}\"" >> "${DOCUMENT_DIR}${DDDIR}.htaccess"
done

################################################################
####  create the Subdivision administrator file
################################################################

mkdotfile "0" "1" ".diradmin"

################################################################
####  create the administrators data file
################################################################

mkdotfile "0" "1" ".admin"

################################################################

print "<P><HR></P>"

if [[ -d "${DOCUMENT_DIR}${DDDIR}${ENT_NAME}" ]] \
&& [[ -d "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${ENT_NAME}" ]]
then

    if [[ -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${ENT_NAME}/.shortdescription" ]]
    then

print "
<P>The Subdivision ${DOCUMENT_BASE}${DDDIR}${ENT_NAME} was created successfully.
To continue, you must now run the index program.<BR>
<FORM action="orgchartReindex.cgi">
<INPUT Type=\"hidden\" Name=\"DDDIR\" Value=\"${DDDIR}${ENT_NAME}\">
<input Type=\"submit\" Value=\"Click here to run the index program\">
</P>
"
    else
print "
<P>The subdivision description file 
${DOCUMENT_BASE}${DDDIR}${ENT_NAME}/.shortdescription
does not exist.  You must contact the appropriate personnel to fix this
problem before you can continue.</P>
"
    fi
else

print "
<P>The subdivision ${DOCUMENT_BASE}${DDDIR}${ENT_NAME}
does not exist.  You must contact the appropriate personnel to fix this
problem before you can continue.</P>
"

fi

print "</BODY>
</HTML>"


