#!/bin/ksh
#############################################################
# Program:	remindAdd.cgi
#               Copyright 1999
#
# Description:	
#
# Author:	Dana French (dfrench@aignetplex.com)
#		 
#		(405) 936-2342
#
# Date:		04/26/99
#
#############################################################
# Modifications:
#
# 04/26/99	Version: 1.0
#		Original Code
################################################################
#
# httpd Environment Variables used
#
#	DOCUMENT_ROOT		Full path to top level html dir
#	SCRIPT_NAME		CGI path to this script
#	SCRIPT_FILENAME		Full path to this script
#
################################################################
h2a()
{
  sed -e "s/%\(..\)/\`print \"ibase=16; \1\" \| bc \| awk \'\{printf\(\"%c\",\$1\)\}\'\`/g"
}
################################################################
hex2ascii()
{
  HEXTMP=`h2a`
  eval print "${HEXTMP}"
}
################################################################
sedit()
{
hex2ascii | sed -e "\
s/,/,/g;\
s/\`/\'/g;\
s/+/ /g;\
s/%2[Ff]/\//g;\
s/     / /g;\
s/    / /g;\
s/   / /g;\
s/  / /g;\
s/^ //g"
}
################################################################
chkvalue()
{
  if [[ "_${3}" != "_NULL_OK" && "_${1}" = "_" ]]
  then
    print "<STRONG>ERROR:</STRONG> You did not supply a ${2}. Go back and try again.<BR>"
    EXITLEVEL="$(( ${EXITLEVEL} + 1 ))"
  else
    CHKVALUE_REMAIN=`print "${1}" | sed -e "s|[a-z,A-Z,0-9, ,\.,:,\,]||g"`
    if [[ "_${#CHKVALUE_REMAIN}" != "_" ]]
    then
      if [[ ${#CHKVALUE_REMAIN} -eq 0 ]]
      then
        print "<I>${2}</I> checked and accepted.<BR>"
      else
        print "<STRONG>ERROR:</STRONG> Invalid ${2}. Go back and try again.<BR>"
        EXITLEVEL="$(( ${EXITLEVEL} + 1 ))"
      fi
    else
      print "<STRONG>ERROR:</STRONG> Unable to perform validity check on ${2}. Go back and try again.<BR>"
      EXITLEVEL="$(( ${EXITLEVEL} + 1 ))"
    fi
  fi
}
################################################################
mkdotfile()
{
  print "<BR>Working on \"${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${DIRNAME}/${3}\"<BR>"
  cd "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${DIRNAME}"
  if [[ "_${1}" = "_1" ]]
  then
    print "Checking existance of \"${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${DIRNAME}/${3}\"<BR>"
    if [[ -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${DIRNAME}/${3}" ]]
    then
      print "Removing \"${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${DIRNAME}/${3}\"<BR>"
      rm -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${DIRNAME}/${3}"
    fi
  elif [[ "_${2}" = "_1" ]]
  then
    print "Checking existance of \"${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${DIRNAME}/${3}\"<BR>"
    if [[ -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${DIRNAME}/${3}" ]]
    then
      print "Removing \"${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${DIRNAME}/${3}\"<BR>"
      rm -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${DIRNAME}/${3}"
    fi
    print "Linking \"../${3}\" to \"./${3}\"<BR>"
    ln -s "../${3}" "./${3}"
  else
    print "Creating \"${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${DIRNAME}/${3}\"<BR>"
    print "${VAL}" | tr '\015' '\012' > "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${DIRNAME}/${3}"
  fi
}
################################################################
# DOCUMENT_ROOT="/external/ns-home/docs"
# SCRIPT_NAME="/cgi-bin/engine/engine.cgi"
# SCRIPT_FILENAME="/external/ns-home/cgi-bin/engine/engine.cgi"

DOCUMENT_BASE="/fancyIndex/"
DOCUMENT_DIR="${DOCUMENT_ROOT}${DOCUMENT_BASE}"
SCRIPT_DIR=`dirname "${SCRIPT_FILENAME}"`
SCRIPT_CGI=`dirname "${SCRIPT_NAME}"`
SEARCHTERM=""
PWPROTECTED="0"
REM_URL=""
REM_COMMENT=""

if [ "_${*}" = "_" ]
then
    DDDIR=""
    DD_DIR=""
else
    DDDIR=`print "${*}" | sedit`
    DD_DIR=`print "${*}" | sedit`
fi

DAYCNT="0"
for VARVAL in `print "${QUERY_STRING}" | sed -e "s/&/	/g"`
do
  if print "${VARVAL}" | grep -i "=" > /dev/null
  then
    VAR=`print "${VARVAL%=*}" | sedit`
    VAL=`print "${VARVAL#*=}" | sedit`
    eval ${VAR}="\"${VAL}\""
    if [[ "_${VAR}" = "_REM_YEAR" ]]
    then
        REM_YEARLIST[${YEARCNT}]="${VAL}"
        YEARCNT="$(( ${YEARCNT} + 1 ))"
    fi
    if [[ "_${VAR}" = "_REM_MONTH" ]]
    then
        REM_MONTHLIST[${MONTHCNT}]="${VAL}"
        MONTHCNT="$(( ${MONTHCNT} + 1 ))"
    fi
    if [[ "_${VAR}" = "_REM_DAY" ]]
    then
        REM_DAYLIST[${DAYCNT}]="${VAL}"
        DAYCNT="$(( ${DAYCNT} + 1 ))"
    fi
    if [[ "_${VAR}" = "_REM_HOUR" ]]
    then
        REM_HOURLIST[${HOURCNT}]="${VAL}"
        HOURCNT="$(( ${HOURCNT} + 1 ))"
    fi
    if [[ "_${VAR}" = "_REM_MINUTE" ]]
    then
        REM_MINUTELIST[${MINUTECNT}]="${VAL}"
        MINUTECNT="$(( ${MINUTECNT} + 1 ))"
    fi
  fi
done

DDDIR=`print "${DDDIR}/" | sed -e "s|//$|/|g;s|^/$||g"`
DD_DIR=`print "${DDDIR}/" | sed -e "s/ /%20/g;s|//$|/|g;s|^/$||g"`

print "content-type:text/html
pragma: no-cache

<HTML>
<HEAD>
<TITLE>Apache FancyIndex - /${DDDIR}</TITLE>
</HEAD>
"

if [[ -d "${DOCUMENT_DIR}" ]]
then
    if [[ -f "${DOCUMENT_DIR}${DDDIR}.bodytag" ]]
    then
        cat "${DOCUMENT_DIR}${DDDIR}.bodytag"
    else
        print "
<BODY Bgcolor=\"white\" Text=\"black\" Link=\"blue\" Vlink=\"red\" Alink=\"yellow\">
<BASEFONT Size=\"3\" Face=\"Arial\">
"
    fi
    if [[ -s "${DOCUMENT_DIR}${DDDIR}HEADER.html" ]]
    then
        cat "${DOCUMENT_DIR}${DDDIR}HEADER.html"
    elif [[ -s "${DOCUMENT_DIR}${DDDIR}.titlebar" ]]
    then
        cat "${DOCUMENT_DIR}${DDDIR}.titlebar"
    else
        print "<H2>Apache Fancy Index Input Form</H2>"
    fi
fi

# set | sed -e "s/$/<BR>/g"

print "<P><H2>Attempting to schedule personal reminders</H2></P>"

################################################################
####	First check the password protection parameters
################################################################

EXITLEVEL="0"
chkvalue "${REM_NAME}" "Reminder Name"
chkvalue "${REM_COMMENT}" "Description" "NULL_OK"
if [[ "_${REM_EMAIL}" = "_" ]]
then
    print "<STRONG>ERROR:</STRONG> You did not supply an E-mail address. Go back and try again.<BR>"
    EXITLEVEL="$(( ${EXITLEVEL} + 1 ))"
else
    print "<I>E-mail address</I> checked and accepted.<BR>"
fi
chkvalue "${REM_YEAR}" "Year"
chkvalue "${REM_MONTH}" "Month"
chkvalue "${REM_DAY}" "Day"
chkvalue "${REM_HOUR}" "Hour"
chkvalue "${REM_MINUTE}" "Minute"

if [[ ${EXITLEVEL} -gt 0 ]]
then
  print "</BODY></HTML>"
  exit
fi

YEARCNT="${#REM_YEARLIST[*]}"
MONTHCNT="${#REM_MONTHLIST[*]}"
DAYCNT="${#REM_DAYLIST[*]}"
HOURCNT="${#REM_HOURLIST[*]}"
MINUTECNT="${#REM_MINUTELIST[*]}"

NOW=`date +"%Y%m%d%H%M"`
YEARINC="0"
MONTHINC="0"
DAYINC="0"
HOURINC="0"
MINUTEINC="0"
NBR="0"
while [[ ${YEARINC} -lt ${YEARCNT} ]]
do
  while [[ ${MONTHINC} -lt ${MONTHCNT} ]]
  do
    while [[ ${DAYINC} -lt ${DAYCNT} ]]
    do
      while [[ ${HOURINC} -lt ${HOURCNT} ]]
      do
        while [[ ${MINUTEINC} -lt ${MINUTECNT} ]]
        do

          if [[ ${REM_YEARLIST[${YEARINC}]}${REM_MONTHLIST[${MONTHINC}]}${REM_DAYLIST[${DAYINC}]}${REM_HOURLIST[${HOURINC}]}${REM_MINUTELIST[${MINUTEINC}]} -lt ${NOW} ]]
          then
            print "<BR><P><STRONG>ERROR:</STRONG> Scheduled date/time \"${REM_YEARLIST[${YEARINC}]}/${REM_MONTHLIST[${MONTHINC}]}/${REM_DAYLIST[${DAYINC}]} ${REM_HOURLIST[${HOURINC}]}:${REM_MINUTELIST[${MINUTEINC}]}\" is in the past.  Unable to schedule a reminder at the selected time.<BR>"
            break
          fi

          OUTNAME="${REM_YEARLIST[${YEARINC}]}${REM_MONTHLIST[${MONTHINC}]}${REM_DAYLIST[${DAYINC}]}${REM_HOURLIST[${HOURINC}]}${REM_MINUTELIST[${MINUTEINC}]}"
          OUTFILE="${DOCUMENT_DIR}${DDDIR}${DIRNAME}${OUTNAME}.app"
          OUTSCRIPT="${DOCUMENT_DIR}${DDDIR}${DIRNAME}${OUTNAME}.sh"

          if [[ -f "${OUTFILE}" ]]
          then
            print "<BR><P><STRONG>ERROR:</STRONG> A reminder already exists at the scheduled time of \"${REM_YEARLIST[${YEARINC}]}/${REM_MONTHLIST[${MONTHINC}]}/${REM_DAYLIST[${DAYINC}]} ${REM_HOURLIST[${HOURINC}]}:${REM_MINUTELIST[${MINUTEINC}]}\".  Unable to schedule a reminder at the selected time.<BR>"
            break
          fi
          
          > "${OUTFILE}"
          print "REM_ID=\"${REM_YEARLIST[${YEARINC}]}${REM_MONTHLIST[${MONTHINC}]}${REM_DAYLIST[${DAYINC}]}${REM_HOURLIST[${HOURINC}]}${REM_MINUTELIST[${MINUTEINC}]}\"" >> "${OUTFILE}"
          print "REM_NAME=\"${REM_NAME}\"" >> "${OUTFILE}"
          print "REM_COMMENT=\"${REM_COMMENT}\"" >> "${OUTFILE}"
          print "REM_EMAIL=\"${REM_EMAIL}\"" >> "${OUTFILE}"
          print "REM_YEAR=\"${REM_YEARLIST[${YEARINC}]}\"" >> "${OUTFILE}"
          print "REM_MONTH=\"${REM_MONTHLIST[${MONTHINC}]}\"" >> "${OUTFILE}"
          print "REM_DAY=\"${REM_DAYLIST[${DAYINC}]}\"" >> "${OUTFILE}"
          print "REM_HOUR=\"${REM_HOURLIST[${HOURINC}]}\"" >> "${OUTFILE}"
          print "REM_MINUTE=\"${REM_MINUTELIST[${MINUTEINC}]}\"" >> "${OUTFILE}"

          print "echo \"${REM_YEARLIST[${YEARINC}]}/${REM_MONTHLIST[${MONTHINC}]}/${REM_DAYLIST[${DAYINC}]} ${REM_HOURLIST[${HOURINC}]}:${REM_MINUTELIST[${MINUTEINC}]} ${REM_COMMENT}\" | mail -s \"${REM_NAME}\" ${REM_EMAIL}" >> "${OUTSCRIPT}"
          print "rm -f \"${OUTFILE}\"" >> "${OUTSCRIPT}"
          print "rm -f \"${OUTSCRIPT}\"" >> "${OUTSCRIPT}"
          print "echo \"${OUTSCRIPT}\" | at \"${REM_HOURLIST[${HOURINC}]}:${REM_MINUTELIST[${MINUTEINC}]}\" \"${REM_MONTHLIST[${MONTHINC}]}/${REM_DAYLIST[${DAYINC}]}/${REM_YEARLIST[${YEARINC}]}\"<BR>"
          chmod 700 "${OUTFILE}"
          chmod 700 "${OUTSCRIPT}"
          TMP=`print "\"${OUTSCRIPT}\"" | at "${REM_HOURLIST[${HOURINC}]}:${REM_MINUTELIST[${MINUTEINC}]}" "${REM_MONTHLIST[${MONTHINC}]}/${REM_DAYLIST[${DAYINC}]}/${REM_YEARLIST[${YEARINC}]}" 2>&1 | grep -iv "warning"`
          print "REM_ATJOB=\"${TMP}\"" >> "${OUTFILE}"

          NBR="$(( ${NBR} + 1 ))"
          MINUTEINC="$(( ${MINUTEINC} + 1 ))"
        done        
        MINUTEINC="0"
        HOURINC="$(( ${HOURINC} + 1 ))"
      done        
      HOURINC="0"
      DAYINC="$(( ${DAYINC} + 1 ))"
    done        
    DAYINC="0"
    MONTHINC="$(( ${MONTHINC} + 1 ))"
  done        
  MONTHINC="0"
  YEARINC="$(( ${YEARINC} + 1 ))"
done        

print "<P><STRONG>${NBR} Personal Reminders Scheduled</STRONG></P>"

print "<P><STRONG>Personal Reminder Scheduled</STRONG>:  This reminder
was automatically scheduled to run at the specified date and time.  To
remove this reminder, go to the link labeled \"Manage personal
reminders\".</P>"

if [[ -s "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.admin" ]]
then
    REM_EMAIL=""
    . "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.admin"
    if [[ "_${REM_EMAIL}" != "_" ]]
    then

print "
A personal reminder has been scheduled as follows:

SUBJECT: ${REM_NAME}
TO: ${REM_EMAIL}
YEAR: ${REM_YEARLIST[*]}
MONTH: ${REM_MONTHLIST[*]}
DAY: ${REM_DAYLIST[*]}
HOUR: ${REM_HOURLIST[*]}
MINUTE: ${REM_MINUTELIST[*]}

${REM_COMMENT}
" | mail -s "Personal Reminder Scheduled" "${REM_EMAIL}"

print "<P><STRONG>Notification Sent</STRONG>: The administrator
of this reminders area has been sent notification that a personal reminder
has been scheduled.</P>"

    fi
fi

print "<P>"
print "<BR><A Href=\"${SCRIPT_CGI}/remindAddForm.cgi?${DD_DIR}\">Add another personal reminder</A>"
print "<BR><A Href=\"${SCRIPT_CGI}/remindManageForm.cgi?${DD_DIR}\">Manage personal reminders</A>"
print "<BR><A href=\"${SCRIPT_CGI}/remindReindex.cgi?${DD_DIR}\">Reindex personal reminders area</A>"
print "<BR><A href=\"${DOCUMENT_BASE}${DD_DIR}\">Return to personal reminders area</A>"
print "</P>"

[[ -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.linkbar" ]] && cat "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.linkbar"
[[ -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.forinfo" ]] && cat "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.forinfo"

print "</BODY>
</HTML>"


