#!/bin/ksh
#############################################################
# Program:	remindDeletedForm.cgi
#               Copyright 1999
#
# Description:	
#
# Author:	Dana French (dfrench@aignetplex.com)
#		 
#		(405) 936-2342
#
# Date:		04/26/99
#
#############################################################
# Modifications:
#
# 04/26/99	Version: 1.0
#		Original Code
################################################################
#
# httpd Environment Variables used
#
#	DOCUMENT_ROOT		Full path to top level html dir
#	SCRIPT_NAME		CGI path to this script
#	SCRIPT_FILENAME		Full path to this script
#
################################################################
h2a()
{
  sed -e "s/%\(..\)/\`print \"ibase=16; \1\" \| bc \| awk \'\{printf\(\"%c\",\$1\)\}\'\`/g"
}
################################################################
hex2ascii()
{
  HEXTMP=`h2a`
  eval print "${HEXTMP}"
}
################################################################
sedit()
{
hex2ascii | sed -e "\
s/,/,/g;\
s/\`/\'/g;\
s/+/ /g;\
s/%2[Ff]/\//g;\
s/     / /g;\
s/    / /g;\
s/   / /g;\
s/  / /g;\
s/^ //g"
}
################################################################
chkvalue()
{
  if [[ "_${1}" = "_" ]]
  then
    print "<STRONG>ERROR:</STRONG> You did not supply a ${2}. Go back and try again.<BR>"
    EXITLEVEL="$(( ${EXITLEVEL} + 1 ))"
  else
    CHKVALUE_REMAIN=`print "${1}" | sed -e "s|[a-z,A-Z,0-9, ,\.,:]||g"`
    if [[ "_${#CHKVALUE_REMAIN}" != "_" ]]
    then
      if [[ ${#CHKVALUE_REMAIN} -eq 0 ]]
      then
        print "<I>${2}</I> checked and accepted.<BR>"
      else
        print "<STRONG>ERROR:</STRONG> Invalid ${2}. Go back and try again.<BR>"
        EXITLEVEL="$(( ${EXITLEVEL} + 1 ))"
      fi
    else
      print "<STRONG>ERROR:</STRONG> Unable to perform validity check on ${2}. Go back and try again.<BR>"
      EXITLEVEL="$(( ${EXITLEVEL} + 1 ))"
    fi
  fi
}
################################################################
# DOCUMENT_ROOT="/external/ns-home/docs"
# SCRIPT_NAME="/cgi-bin/engine/engine.cgi"
# SCRIPT_FILENAME="/external/ns-home/cgi-bin/engine/engine.cgi"

DOCUMENT_BASE="/fancyIndex/"
DOCUMENT_DIR="${DOCUMENT_ROOT}${DOCUMENT_BASE}"
SCRIPT_DIR=`dirname "${SCRIPT_FILENAME}"`
SCRIPT_CGI=`dirname "${SCRIPT_NAME}"`
SEARCHTERM=""
PWPROTECTED="0"

if [ "_${*}" = "_" ]
then
    DDDIR=""
    DD_DIR=""
else
    DDDIR=`print "${*}" | sedit`
    DD_DIR=`print "${*}" | sedit`
fi

DAYCNT="0"
for VARVAL in `print "${QUERY_STRING}" | sed -e "s/&/	/g"`
do
  if print "${VARVAL}" | grep -i "=" > /dev/null
  then
    VAR=`print "${VARVAL%=*}" | sedit`
    VAL=`print "${VARVAL#*=}" | sedit`
    eval ${VAR}="\"${VAL}\""
  fi
done

DDDIR=`print "${DDDIR}/" | sed -e "s|//$|/|g;s|^/$||g"`
DD_DIR=`print "${DDDIR}/" | sed -e "s/ /%20/g;s|//$|/|g;s|^/$||g"`

print "content-type:text/html
pragma: no-cache

<HTML>
<HEAD>
<TITLE>Apache FancyIndex - /${DDDIR}</TITLE>
</HEAD>
"

if [[ -d "${DOCUMENT_DIR}" ]]
then
    if [[ -f "${DOCUMENT_DIR}${DDDIR}.bodytag" ]]
    then
        cat "${DOCUMENT_DIR}${DDDIR}.bodytag"
    else
        print "
<BODY Bgcolor=\"white\" Text=\"black\" Link=\"blue\" Vlink=\"red\" Alink=\"yellow\">
<BASEFONT Size=\"3\" Face=\"Arial\">
"
    fi

    if [[ -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.titlebar" ]]
    then
        SUBTITLE=`basename "/${DDDIR}"`
        sed -e "s|<!-- Begin subtitle -->.*<!-- End subtitle -->|<!-- Begin subtitle -->${SUBTITLE}<!-- End subtitle -->|" "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.titlebar"
    else
        print "<P><CENTER><H2>Apache Fancy Index Input Form</H2></CENTER></P>"
    fi
    [[ -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.linkbar" ]] && cat "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.linkbar"

#     if [[ -s "${DOCUMENT_DIR}${DDDIR}HEADER.html" ]]
#     then
#         cat "${DOCUMENT_DIR}${DDDIR}HEADER.html"
#     elif [[ -s "${DOCUMENT_DIR}${DDDIR}.titlebar" ]]
#     then
#         cat "${DOCUMENT_DIR}${DDDIR}.titlebar"
#     else
#         print "<H2>Apache Fancy Index Input Form</H2>"
#     fi

fi

# set | sed -e "s/$/<BR>/g"

print "
<P><FONT Size=\"4\"><STRONG>
Return to <A Href=\"${DOCUMENT_BASE}${DD_DIR}\">${DDDIR}</A>
</STRONG></FONT></P>
"

################################################################
####	First check the password protection parameters
################################################################

print "
<FORM Method=\"get\" Action=\"remindManage.cgi\">
<INPUT Type=\"hidden\" Name=\"DDDIR\" Value=\"${DDDIR}\">
"

print "<P><CENTER><H2>Manage Deleted Personal Reminders</H2></CENTER></P>"

print "
<P><CENTER><TABLE Border=\"1\">
<P>
  <TR>
    <TH Bgcolor="lightblue">
      <FONT Size=\"+1\" Color=\"darkblue\">
Change Status
      </FONT>
    </TH>
    <TH Bgcolor="lightblue">
      <FONT Size=\"+1\" Color=\"darkblue\">
Reminder
<BR>Name
      </FONT>
    </TH>
    <TH Bgcolor="lightblue">
      <FONT Size=\"+1\" Color=\"darkblue\">
Description
<BR>and E-mail
      </FONT>
    </TH>
    <TH Bgcolor="lightblue">
      <FONT Size=\"+1\" Color=\"darkblue\">
Scheduled Date
<BR>MM/DD/YYYY
      </FONT>
    </TH>
    <TH Bgcolor="lightblue">
      <FONT Size=\"+1\" Color=\"darkblue\">
Scheduled Time
<BR>HH:MM
      </FONT>
    </TH>
  </TR>
</P>
"

cd "${DOCUMENT_DIR}${DDDIR}${DIRNAME}"
find "${DOCUMENT_DIR}${DDDIR}${DIRNAME}" -name \*.del -print | while read REM_FULLFILE
do

. "${REM_FULLFILE}"

REM_FILE=`print "${REM_FULLFILE}" | sed -e "s|${DOCUMENT_DIR}${DDDIR}${DIRNAME}||g"`

print "
<P>
  <TR>
    <TD Align=\"left\" Valign=\"middle\">
      <FONT Size=\"2\">
<INPUT Type=\"radio\" Name=\"REM_FILE_${REM_FILE}\" Value=\"schedule\"> Change to Scheduled<BR>
<INPUT Type=\"radio\" Name=\"REM_FILE_${REM_FILE}\" Value=\"unschedule\"> Change to Unscheduled<BR>
<INPUT Type=\"radio\" Name=\"REM_FILE_${REM_FILE}\" Value=\"purge\"> Purge this Record<BR>
<INPUT Type=\"radio\" Name=\"REM_FILE_${REM_FILE}\" Value=\"unmark\"> No Changes<BR>
      </FONT>
    </TD>
    <TD Align=\"left\" Valign=\"middle\">
      <FONT Size=\"4\">
${REM_NAME}
      </FONT>
    </TD>
    <TD Align=\"left\" Valign=\"middle\">
      <FONT Size=\"2\">
${REM_COMMENT}
<BR>${REM_EMAIL}
      </FONT>
    </TD>
    <TD Align=\"center\" Valign=\"middle\">
      <FONT Size=\"4\">
${REM_MONTH}/${REM_DAY}/${REM_YEAR}
      </FONT>
    </TD>
    <TD Align=\"center\" Valign=\"middle\">
      <FONT Size=\"4\">
${REM_HOUR}:${REM_MINUTE}
      </FONT>
    </TD>
  </TR>
</P>
"
done

print "</TABLE></CENTER></P>"

################################################################

print "
<P><CENTER>
<INPUT Type=\"submit\" Value=\"Commit Changes\">
</CENTER></P>
</FORM>"

print "
<P><FONT Size=\"4\"><STRONG>
<BR>Return to <A Href=\"${DOCUMENT_BASE}${DD_DIR}\">${DDDIR}</A>
</STRONG></FONT></P>
"

[[ -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.linkbar" ]] && cat "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.linkbar"
[[ -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.forinfo" ]] && cat "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.forinfo"

print "</BODY>
</HTML>"

