#!/bin/ksh
#############################################################
# Program:	remindManage.cgi
#               Copyright 1999
#
# Description:	
#
# Author:	Dana French (dfrench@aignetplex.com)
#		 
#		(405) 936-2342
#
# Date:		04/26/99
#
#############################################################
# Modifications:
#
# 04/26/99	Version: 1.0
#		Original Code
################################################################
#
# httpd Environment Variables used
#
#	DOCUMENT_ROOT		Full path to top level html dir
#	SCRIPT_NAME		CGI path to this script
#	SCRIPT_FILENAME		Full path to this script
#
################################################################
h2a()
{
  sed -e "s/%\(..\)/\`print \"ibase=16; \1\" \| bc \| awk \'\{printf\(\"%c\",\$1\)\}\'\`/g"
}
################################################################
hex2ascii()
{
  HEXTMP=`h2a`
  eval print "${HEXTMP}"
}
################################################################
sedit()
{
hex2ascii | sed -e "\
s/,/,/g;\
s/\`/\'/g;\
s/+/ /g;\
s/%2[Ff]/\//g;\
s/     / /g;\
s/    / /g;\
s/   / /g;\
s/  / /g;\
s/^ //g"
}
################################################################
chkvalue()
{
  if [[ "_${1}" = "_" ]]
  then
    print "<STRONG>ERROR:</STRONG> You did not supply a ${2}. Go back and try again.<BR>"
    EXITLEVEL="$(( ${EXITLEVEL} + 1 ))"
  else
    CHKVALUE_REMAIN=`print "${1}" | sed -e "s|[a-z,A-Z,0-9, ]||g"`
    if [[ "_${#CHKVALUE_REMAIN}" != "_" ]]
    then
      if [[ ${#CHKVALUE_REMAIN} -eq 0 ]]
      then
        print "<I>${2}</I> checked and accepted.<BR>"
      else
        print "<STRONG>ERROR:</STRONG> Invalid ${2}. Go back and try again.<BR>"
        EXITLEVEL="$(( ${EXITLEVEL} + 1 ))"
      fi
    else
      print "<STRONG>ERROR:</STRONG> Unable to perform validity check on ${2}. Go back and try again.<BR>"
      EXITLEVEL="$(( ${EXITLEVEL} + 1 ))"
    fi
  fi
}

################################################################
mkdotfile()
{
  print "<BR>Working on \"${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${3}\"<BR>"
  cd "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}"
  if [[ "${1}" = "_1" ]]
  then
    print "Checking existance of \"${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${3}\"<BR>"
    if [[ -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${3}" ]]
    then
      print "Removing \"${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${3}\"<BR>"
      rm -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${3}"
    fi
  elif [[ "${2}" = "_1" ]]
  then
    print "Checking existance of \"${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${3}\"<BR>"
    if [[ -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${3}" ]]
    then
      print "Removing \"${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${3}\"<BR>"
      rm -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${3}"
    fi
    print "Linking \"../${3}\" to \"./${3}\"<BR>"
    ln -s "../${3}" "./${3}"
  else
    print "Creating \"${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${3}\"<BR>"
    print "${VAL}" | tr '\015' '\012' > "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}${3}"
  fi
}
################################################################
# DOCUMENT_ROOT="/external/ns-home/docs"
# SCRIPT_NAME="/cgi-bin/engine/engine.cgi"
# SCRIPT_FILENAME="/external/ns-home/cgi-bin/engine/engine.cgi"

DOCUMENT_BASE="/fancyIndex/"
DOCUMENT_DIR="${DOCUMENT_ROOT}${DOCUMENT_BASE}"
SCRIPT_DIR=`dirname "${SCRIPT_FILENAME}"`
SCRIPT_CGI=`dirname "${SCRIPT_NAME}"`
SEARCHTERM=""
PWPROTECTED="0"

if [ "_${*}" = "_" ]
then
    DDDIR=""
    DD_DIR=""
else
    DDDIR=`print "${*}" | sedit`
    DD_DIR=`print "${*}" | sedit`
fi

for VARVAL in `print "${QUERY_STRING}" | sed -e "s/&/	/g"`
do
  if print "${VARVAL}" | grep -i "=" > /dev/null
  then
    VAR=`print "${VARVAL%=*}" | sedit`
    VAL=`print "${VARVAL#*=}" | sedit`
    eval ${VAR}="\"${VAL}\""
  fi
done

DDDIR=`print "${DDDIR}/" | sed -e "s|//$|/|g;s|^/$||g"`
DD_DIR=`print "${DDDIR}/" | sed -e "s/ /%20/g;s|//$|/|g;s|^/$||g"`

print "content-type:text/html
pragma: no-cache

<HTML>
<HEAD>
<TITLE>Apache FancyIndex - /${DDDIR}</TITLE>
</HEAD>
"

if [[ -d "${DOCUMENT_DIR}" ]]
then
    if [[ -f "${DOCUMENT_DIR}${DDDIR}.bodytag" ]]
    then
        cat "${DOCUMENT_DIR}${DDDIR}.bodytag"
    else
        print "
<BODY Bgcolor=\"white\" Text=\"black\" Link=\"blue\" Vlink=\"red\" Alink=\"yellow\">
<BASEFONT Size=\"3\" Face=\"Arial\">
"
    fi
    if [[ -s "${DOCUMENT_DIR}${DDDIR}HEADER.html" ]]
    then
        cat "${DOCUMENT_DIR}${DDDIR}HEADER.html"
    elif [[ -s "${DOCUMENT_DIR}${DDDIR}.titlebar" ]]
    then
        cat "${DOCUMENT_DIR}${DDDIR}.titlebar"
    else
        print "<H2>Apache Fancy Index Input Form</H2>"
    fi
fi

# set | sed -e "s/$/<BR>/g"

################################################################
#    begin updating personal reminders
################################################################

print "<P><H2>Modifying Personal Reminders</H2></P>"

for VARVAL in `print "${QUERY_STRING}" | sed -e "s/&/	/g"`
do
  if print "${VARVAL}" | grep -i "=" > /dev/null
  then
    VAR=`print "${VARVAL%=*}" | sedit`
    VAL=`print "${VARVAL#*=}" | sedit`
    if print "${VAR}" | grep "REM_FILE_" >/dev/null 2>&1
    then
      REM_FILE=`print "${VAR}" | sed -e "s|REM_FILE_||g"`

      if [[ "_${VAL}" = "_delete" ]]
      then
        if [[ -f "${DOCUMENT_DIR}${DDDIR}${REM_FILE%.*}.del" ]]
        then
          rm -f "${DOCUMENT_DIR}${DDDIR}${REM_FILE%.*}.del"
        fi
        . "${DOCUMENT_DIR}${DDDIR}${REM_FILE}"
        JOBID=`print "${REM_ATJOB}" | cut -d" " -f2`
        print "<BR>Unscheduling job ID ${JOBID}"
        atrm "${JOBID}" 2>&1
        mv "${DOCUMENT_DIR}${DDDIR}${REM_FILE}" "${DOCUMENT_DIR}${DDDIR}${REM_FILE%.*}.del"
        print "<BR>\"${DOCUMENT_DIR}${DDDIR}${REM_FILE}\" reminder deleted"
      fi

      if [[ "_${VAL}" = "_schedule" ]]
      then
        if [[ -f "${DOCUMENT_DIR}${DDDIR}${REM_FILE%.*}.app" ]]
        then
          print "<BR><STRONG>ERROR</STRONG>: Unable to schedule reminder \"${DOCUMENT_DIR}${DDDIR}${REM_FILE}\"<BR>"
        else  

          . "${DOCUMENT_DIR}${DDDIR}${REM_FILE}"
          TMP=`print "\"${DOCUMENT_DIR}${DDDIR}${REM_FILE%.*}.sh\"" | at "${REM_HOUR}:${REM_MINUTE}" "${REM_MONTH}/${REM_DAY}/${REM_YEAR}" 2>&1 | grep -iv "warning"`
          print "<BR>${TMP}<BR>"
          print "REM_ATJOB=\"${TMP}\"" >> "${DOCUMENT_DIR}${DDDIR}${REM_FILE}"

          mv "${DOCUMENT_DIR}${DDDIR}${REM_FILE}" "${DOCUMENT_DIR}${DDDIR}${REM_FILE%.*}.app"
          print "\"${DOCUMENT_DIR}${DDDIR}${REM_FILE}\" reminder scheduled<BR>"
        fi
      fi

      if [[ "_${VAL}" = "_unschedule" ]]
      then
        if [[ -f "${DOCUMENT_DIR}${DDDIR}${REM_FILE%.*}.sub" ]]
        then
          print "<BR><STRONG>ERROR</STRONG>: Unable to unschedule reminder \"${DOCUMENT_DIR}${DDDIR}${REM_FILE}\"<BR>"
        else
          . "${DOCUMENT_DIR}${DDDIR}${REM_FILE}"
          JOBID=`print "${REM_ATJOB}" | cut -d" " -f2`
          print "<BR>Unscheduling job ID ${JOBID}"
          atrm "${JOBID}" 2>&1
          mv "${DOCUMENT_DIR}${DDDIR}${REM_FILE}" "${DOCUMENT_DIR}${DDDIR}${REM_FILE%.*}.sub"
          print "<BR>\"${DOCUMENT_DIR}${DDDIR}${REM_FILE}\" reminder unscheduled<BR>"
        fi
      fi

      if [[ "_${VAL}" = "_purge" ]]
      then
        rm -f "${DOCUMENT_DIR}${DDDIR}${REM_FILE}"
        rm -f "${DOCUMENT_DIR}${DDDIR}${REM_FILE%.*}.sh"
        print "<BR>\"${DOCUMENT_DIR}${DDDIR}${REM_FILE}\" reminder purged"
      fi

    fi
  fi
done

print "<P>"
print "<BR><A Href=\"${SCRIPT_CGI}/remindAddForm.cgi?${DD_DIR}\">Add another personal reminder</A>"
print "<BR><A Href=\"${SCRIPT_CGI}/remindManageForm.cgi?${DD_DIR}\">Manage personal reminders</A>"
print "<BR><A href=\"${SCRIPT_CGI}/remindReindex.cgi?${DD_DIR}\">Reindex personal reminders</A>"
print "<BR><A href=\"${DOCUMENT_BASE}${DD_DIR}\">Return to personal reminders area</A>"
print "</P>"

[[ -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.linkbar" ]] && cat "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.linkbar"
[[ -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.forinfo" ]] && cat "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.forinfo"

print "</BODY>
</HTML>"

