#!/usr/bin/perl

# Copyright (c) 1996 Steven E. Brenner
# $Id: uploadFile.cgi,v 1.2 1996/03/30 01:35:32 brenner Exp $


require "./cgi-lib.pl";

# When writing files, several options can be set... here we just set one
# Limit upload size to avoid using too much memory
$cgi_lib'maxdata = 50000; 


# Start off by reading and parsing the data.  Save the return value.
# We could also save the file's name and content type, but we don't
# do that in this example.
$ret = &ReadParse;


# A bit of error checking never hurt anyone
&CgiDie("Error in reading and parsing of CGI input") if !defined $ret;
&CgiDie("No data uploaded") if !$ret;


${DOCUMENT_ROOT} = "$ENV{'DOCUMENT_ROOT'}";
${DOCUMENT_BASE} = "/fancyIndex/";
${DOCUMENT_DIR}  = "${DOCUMENT_ROOT}${DOCUMENT_BASE}";
${DDDIR}         = "$in{'DDDIR'}";

$outfile = "${DOCUMENT_ROOT}" . "${DOCUMENT_BASE}" . "${DDDIR}" . "$in{'SAVEASNAME'}";

print "content-type:text/html
pragma: no-cache

<HTML>
<HEAD>
<TITLE>Apache FancyIndex - /${DDDIR}</TITLE>
</HEAD>
<BODY>
";

################################################################
if ( -e  "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.titlebar" ) {
    open(INFILE, "<${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.titlebar" );
    @{INBUF} = <INFILE>;
    close(INFILE);
    print "@{INBUF}";
}

################################################################
if ( -e  "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.linkbar" ) {
    open(INFILE, "<${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.linkbar" );
    @{INBUF} = <INFILE>;
    close(INFILE);
    print "@{INBUF}";
}

################################################################

${URLPATH} = "${DOCUMENT_BASE}${DDDIR}";
${URLPATH} =~ s/ /%20/g;
${DD_DIR}  =  "${DDDIR}";
${DD_DIR}  =~ s/ /%20/g;
${DD_DIR}  =~ s/\/$//g;

print "
<!-- Begin directories -->
<P><BLOCKQUOTE><FONT Size=\"+1\"><STRONG>
<A Href=\"uploadFileForm.cgi?${DD_DIR}\">Upload another file</A><BR>
Return to <A Href=\"${URLPATH}\">${DDDIR}</A>
</STRONG></FONT></BLOCKQUOTE></P>
<!-- End directories -->
";


################################################################
# Begin upload code
################################################################

################################################################
if ( -e  "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.uploadFile" ) {

    if (open(OUTFILE, ">${outfile}")) {
        binmode OUTFILE;
        print OUTFILE "$in{'UPFILE'}";
        close(OUTFILE);
    }
    
    if (open(OUTFILE, ">${outfile}.desc")) {
        binmode OUTFILE;
        print OUTFILE "FILE_NAME=\"$in{'SAVEASNAME'}\"\n";
        print OUTFILE "FILE_DESC=\"$in{'NOTE'}\"\n";
        close(OUTFILE);
    }
    
    # print "Uploaded file = ${outfile}<BR>\n";
    if ( -e ${outfile} ) {
        if ( (stat ${outfile})[7] < 1 ) {
            print "<BR><STRONG>ERROR:</STRONG> uploaded filesize is less than 1 byte<BR>\n";
        }
    
        print "Target Directory = ${DOCUMENT_BASE}${DDDIR}<BR>\n";
        print "Target Filename = $in{'SAVEASNAME'}<BR>\n";
        print "File Description = $in{'NOTE'}<BR>\n";
    
        print "<P><STRONG>File upload complete.</STRONG></P>";
    }

} else {

    print "<BR><STRONG>ERROR:</STRONG> File uploads to this directory are not allowed.<BR>\n";

}
    
################################################################
print "
<!-- Begin directories -->
<P><BLOCKQUOTE><FONT Size=\"+1\"><STRONG>
<A Href=\"uploadFileForm.cgi?${DD_DIR}\">Upload another file</A><BR>
Return to <A Href=\"${URLPATH}\">${DDDIR}</A>
</STRONG></FONT></BLOCKQUOTE></P>
<!-- End directories -->
";

################################################################
if ( -e  "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.linkbar" ) {
    open(INFILE, "<${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.linkbar" );
    @{INBUF} = <INFILE>;
    close(INFILE);
    print "@{INBUF}";
}

################################################################
if ( -e  "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.forinfo" ) {
    open(INFILE, "<${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.forinfo" );
    @{INBUF} = <INFILE>;
    close(INFILE);
    print "@{INBUF}";
}

print &HtmlBot;
