#!/bin/ksh
#############################################################
# Program:	userPasswd.cgi
#               Copyright 1999
#
# Description:	
#
# Author:	Dana French (dfrench@aignetplex.com)
#		 
#		(405) 936-2342
#
# Date:		04/26/99
#
#############################################################
# Modifications:
#
# 04/26/99	Version: 1.0
#		Original Code
################################################################
#
# httpd Environment Variables used
#
#	DOCUMENT_ROOT		Full path to top level html dir
#	SCRIPT_NAME		CGI path to this script
#	SCRIPT_FILENAME		Full path to this script
#
################################################################
h2a()
{
  sed -e "s/%\(..\)/\`print \"ibase=16; \1\" \| bc \| awk \'\{printf\(\"%c\",\$1\)\}\'\`/g"
}
################################################################
hex2ascii()
{
  HEXTMP=`h2a`
  eval print "${HEXTMP}"
}
################################################################
sedit()
{
hex2ascii | sed -e "\
s/,/,/g;\
s/\`/\'/g;\
s/+/ /g;\
s/%2[Ff]/\//g;\
s/     / /g;\
s/    / /g;\
s/   / /g;\
s/  / /g;\
s/^ //g"
}
################################################################
chkvalue()
{
  if [[ "_${3}" != "_NULL_OK" && "_${1}" = "_" ]]
  then
    print "<STRONG>ERROR:</STRONG> You did not supply a ${2}. Go back and try again.<BR>"
    EXITLEVEL="$(( ${EXITLEVEL} + 1 ))"
  else
    CHKVALUE_REMAIN=`print "${1}" | sed -e "s|[a-z,A-Z,0-9, ,\.,:,\,]||g"`
    if [[ "_${#CHKVALUE_REMAIN}" != "_" ]]
    then
      if [[ ${#CHKVALUE_REMAIN} -eq 0 ]]
      then
        print "<I>${2}</I> checked and accepted.<BR>"
      else
        print "<STRONG>ERROR:</STRONG> Invalid ${2}. Go back and try again.<BR>"
        EXITLEVEL="$(( ${EXITLEVEL} + 1 ))"
      fi
    else
      print "<STRONG>ERROR:</STRONG> Unable to perform validity check on ${2}. Go back and try again.<BR>"
      EXITLEVEL="$(( ${EXITLEVEL} + 1 ))"
    fi
  fi
}
################################################################
# DOCUMENT_ROOT="/external/ns-home/docs"
# SCRIPT_NAME="/cgi-bin/engine/engine.cgi"
# SCRIPT_FILENAME="/external/ns-home/cgi-bin/engine/engine.cgi"

DOCUMENT_BASE="/fancyIndex/"
DOCUMENT_DIR="${DOCUMENT_ROOT}${DOCUMENT_BASE}"
SCRIPT_DIR=`dirname "${SCRIPT_FILENAME}"`
SCRIPT_CGI=`dirname "${SCRIPT_NAME}"`
SEARCHTERM=""

if [ "_${*}" = "_" ]
then
    DDDIR=""
    DD_DIR=""
else
    DDDIR=`print "${*}" | sedit`
    DD_DIR=`print "${*}" | sedit`
fi

for VARVAL in `print "${QUERY_STRING}" | sed -e "s/&/	/g"`
do
  if print "${VARVAL}" | grep -i "=" > /dev/null
  then
    VAR=`print "${VARVAL%=*}" | sedit`
    VAL=`print "${VARVAL#*=}" | sedit`
    eval ${VAR}="\"${VAL}\""
  fi
done

DDDIR=`print "${DDDIR}/" | sed -e "s|//$|/|g;s|^/$||g"`
DD_DIR=`print "${DDDIR}/" | sed -e "s/ /%20/g;s|//$|/|g;s|^/$||g"`

print "content-type:text/html
pragma: no-cache

<HTML>
<HEAD>
<TITLE>Apache FancyIndex - /${DDDIR}</TITLE>
</HEAD>
"

if [[ -d "${DOCUMENT_DIR}" ]]
then
    if [[ -f "${DOCUMENT_DIR}${DDDIR}.bodytag" ]]
    then
        cat "${DOCUMENT_DIR}${DDDIR}.bodytag"
    else
        print "
<BODY Bgcolor=\"white\" Text=\"black\" Link=\"blue\" Vlink=\"red\" Alink=\"yellow\">
<BASEFONT Size=\"3\" Face=\"Arial\">
"
    fi

    if [[ -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.titlebar" ]]
    then
        SUBTITLE=`basename "/${DDDIR}"`
        sed -e "s|<!-- Begin subtitle -->.*<!-- End subtitle -->|<!-- Begin subtitle -->${SUBTITLE}<!-- End subtitle -->|" "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.titlebar"
    fi
    [[ -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.linkbar" ]] && cat "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.linkbar"

#     if [[ -s "${DOCUMENT_DIR}${DDDIR}HEADER.html" ]]
#     then
#         cat "${DOCUMENT_DIR}${DDDIR}HEADER.html"
#     elif [[ -s "${DOCUMENT_DIR}${DDDIR}.titlebar" ]]
#     then
#         cat "${DOCUMENT_DIR}${DDDIR}.titlebar"
#     else
#         print "<H2>Apache Fancy Index Input Form</H2>"
#     fi

fi

# set | sed -e "s/$/<BR>/g"

print "
<P><FONT Size=\"4\"><STRONG>
Return to <A Href=\"${DOCUMENT_BASE}${DD_DIR}\">${DDDIR}</A>
</STRONG></FONT></P>
"

print "<P><H2>Changing password for ${USERID}</H2></P>"


################################################################
####	First check the password protection parameters
################################################################

EXITLEVEL="0"
chkvalue "${USERID}" "User ID"
chkvalue "${PASSWORD}" "User Password"
chkvalue "${NEW_PASSWORD}" "New Password"
chkvalue "${NEW_RETYPEPW}" "Retyped New Password"

################################################################
####	compare passwords
################################################################
EXITLEVEL="1"
if [[ -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.htpasswd" ]]
then

rm -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}userPasswd${$}.tmp"
/usr/local/apache/bin/htpasswd -b -c -p "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}userPasswd${$}.tmp" "${USERID}" "${PASSWORD}" >/dev/null 2>&1
  if [[ -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}userPasswd${$}.tmp" ]]
  then

chmod 600 "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}userPasswd${$}.tmp" ]]
grep "${USERID}" "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.UID_${USERID}" | diff "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}userPasswd${$}.tmp" -

    if grep "${USERID}" "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.UID_${USERID}" | head -1 | diff "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}userPasswd${$}.tmp" - > /dev/null 2>&1
    then
      print "<BR>User Verified.<BR>"
      EXITLEVEL="0"
    else
      print "<BR><STRONG>ERROR:</STRONG> Improper user ID or password.<BR>"
    fi
    rm -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}userPasswd${$}.tmp"
  else
    print "<BR><STRONG>ERROR:</STRONG> Unable to compare user login.<BR>"
  fi

else

  print "<BR><STRONG>ERROR:</STRONG> Unable to verify user.<BR>"

fi

if [[ ${EXITLEVEL} -gt 0 ]]
then

[[ -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.linkbar" ]] && cat "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.linkbar"
[[ -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.forinfo" ]] && cat "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.forinfo"

print "</BODY></HTML>"
exit

fi

################################################################

if [[ "_${NEW_PASSWORD}" = "_${NEW_RETYPEPW}" ]]
then

  touch "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.htpasswd" 2>&1
  touch "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.UID_${USERID}" 2>&1
  chmod 600 "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.htpasswd" 2>&1
  chmod 600 "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.UID_${USERID}" 2>&1
  /usr/local/apache/bin/htpasswd -b "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.htpasswd" "${USERID}" "${NEW_PASSWORD}" 2>&1
  /usr/local/apache/bin/htpasswd -b -p "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.UID_${USERID}" "${USERID}" "${NEW_PASSWORD}" > /dev/null 2>&1

  print "<P><STRONG><EM>"
  grep "${USERID}" "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.htpasswd" 2>&1 | sed -e "s/$/<BR>/g"
  print "</EM></STRONG></P>"

  print "<P><STRONG>"
  print "Password for \"${USERID}\" has been changed.<BR>"
  print "</STRONG></P>"
else

  print "<P><STRONG>ERROR: Passwords do not match. Go back and try again.</STRONG></P>"

fi

print "
<P><FONT Size=\"4\"><STRONG>
Return to <A Href=\"${DOCUMENT_BASE}${DD_DIR}\">${DDDIR}</A>
</STRONG></FONT></P>
"

[[ -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.linkbar" ]] && cat "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.linkbar"
[[ -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.forinfo" ]] && cat "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.forinfo"

print "</BODY>
</HTML>"

