#!/bin/ksh
#############################################################
# Program:	utilities.cgi
#               Copyright 1999
#
# Description:	
#
# Author:	Dana French (dfrench@aignetplex.com)
#		 
#		(405) 936-2342
#
# Date:		04/26/99
#
#############################################################
# Modifications:
#
# 04/26/99	Version: 1.0
#		Original Code
################################################################
#
# httpd Environment Variables used
#
#	DOCUMENT_ROOT		Full path to top level html dir
#	SCRIPT_NAME		CGI path to this script
#	SCRIPT_FILENAME		Full path to this script
#
################################################################
h2a()
{
  sed -e "s/%\(..\)/\`print \"ibase=16; \1\" \| bc \| awk \'\{printf\(\"%c\",\$1\)\}\'\`/g"
}
################################################################
hex2ascii()
{
  HEXTMP=`h2a`
  eval print "${HEXTMP}"
}
################################################################
sedit()
{
hex2ascii | sed -e "\
s/,/,/g;\
s/\`/\'/g;\
s/+/ /g;\
s/%2[Ff]/\//g;\
s/     / /g;\
s/    / /g;\
s/   / /g;\
s/  / /g;\
s/^ //g"
}
################################################################
# DOCUMENT_ROOT="/external/ns-home/docs"
# SCRIPT_NAME="/cgi-bin/engine/engine.cgi"
# SCRIPT_FILENAME="/external/ns-home/cgi-bin/engine/engine.cgi"

DOCUMENT_BASE="/fancyIndex/"
DOCUMENT_DIR="${DOCUMENT_ROOT}${DOCUMENT_BASE}"
SCRIPT_DIR=`dirname "${SCRIPT_FILENAME}"`
SCRIPT_CGI=`dirname "${SCRIPT_NAME}"`
SEARCHTERM=""

if [ "_${*}" = "_" ]
then
    DDDIR=""
    DD_DIR=""
else
    DDDIR=`print "${*}" | sedit`
    DD_DIR=`print "${*}" | sedit`
fi

for VARVAL in `print "${QUERY_STRING}" | sed -e "s/&/	/g"`
do
  if print "${VARVAL}" | grep -i "=" > /dev/null
  then
    VAR=`print "${VARVAL%=*}" | sedit`
    VAL=`print "${VARVAL#*=}" | sedit`
    eval ${VAR}="\"${VAL}\""
  fi
done

DDDIR=`print "${DDDIR}/" | sed -e "s|//$|/|g;s|^/$||g"`
DD_DIR=`print "${DDDIR}/" | sed -e "s/ /%20/g;s|//$|/|g;s|^/$||g"`

print "content-type:text/html
pragma: no-cache

<HTML>
<HEAD>
<TITLE>Apache FancyIndex - /${DDDIR}</TITLE>
</HEAD>
"

if [[ -d "${DOCUMENT_DIR}" ]]
then
    if [[ -f "${DOCUMENT_DIR}${DDDIR}.bodytag" ]]
    then
        cat "${DOCUMENT_DIR}${DDDIR}.bodytag"
    else
        print "
<BODY Bgcolor=\"white\" Text=\"black\" Link=\"blue\" Vlink=\"red\" Alink=\"yellow\">
<BASEFONT Size=\"3\" Face=\"Arial\">
"
    fi

    if [[ -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.titlebar" ]]
    then
        SUBTITLE=`basename "/${DDDIR}"`
        [[ "_${DDDIR}" = "_" ]] && SUBTITLE=""
        sed -e "s|<!-- Begin subtitle -->.*<!-- End subtitle -->|<!-- Begin subtitle -->${SUBTITLE}<!-- End subtitle -->|" "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.titlebar"
    fi
    [[ -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.linkbar" ]] && cat "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.linkbar"

fi

# set | sed -e "s/$/<BR>/g"

print "<P><FONT Size=\"4\"><STRONG>
Return to <A Href=\"${DOCUMENT_BASE}${DD_DIR}\">${DDDIR}"
[[ "_${DDDIR}" = "_" ]] && print "HOME"
print "</A></STRONG></FONT></P>"

print "
<P><HR></P>
<P><H2>User Utilities</H2></P>
<P>
<UL>
"

if [[ -s "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.htpasswd" ]]
then

    print "
<LI> <A Href=\"${SCRIPT_CGI}/userPasswdForm.cgi?${DD_DIR}\">Change password</A> - Allows the user to change their password
"

else

    print "
<LI> <FONT Color=\"gray\">Change password</FONT> - Allows the user to change their password - This directory is not password protected
"

fi

print "
<LI> <A Href=\"${SCRIPT_CGI}/mkdirform.cgi?${DD_DIR}\">Create a new directory</A> - Allows the user to create and administer a new subdirectory under the current directory
"


if [[ -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.uploadFile" ]]
then

    print "
<LI> <A Href=\"${SCRIPT_CGI}/uploadFileForm.cgi?${DD_DIR}\">Upload a File</A> - Allows any user to upload a file to the current directory
"

else

    print "
<LI> <FONT Color=\"gray\">Upload a File</FONT> - Allows any user to upload a file to the current directory - This directory does not allow file uploads
"

fi

print "
<LI> <A Href=\"${SCRIPT_CGI}/addlinkform.cgi?${DD_DIR}\">Add URL Link</A> - Add a URL link to the current directory
<LI> <A Href=\"${SCRIPT_CGI}/adddescform.cgi?${DD_DIR}\">Add File Description</A> - Add a file description to a file in the current directory
<LI> <A Href=\"${SCRIPT_CGI}/delLinkForm.cgi?${DD_DIR}\">Delete a URL Link</A> - Delete a URL link from the current directory
<LI> <A Href=\"${SCRIPT_CGI}/delDescForm.cgi?${DD_DIR}\">Delete a File Description</A> - Delete a file description from the current directory
</UL>
</P>
"

print "
<P><HR></P>
<P><H2>Directory Administrator Utilities</H2></P>
<P>
<UL>
"

if [[ -s "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.htpasswd" ]]
then

    print "
<LI> <A Href=\"${SCRIPT_CGI}/grantAccessForm.cgi?${DD_DIR}\">Grant Access</A> - Grant a user access to this directory
<LI> <A Href=\"${SCRIPT_CGI}/denyAccessForm.cgi?${DD_DIR}\">Deny Access</A> - Deny a user access to this directory
"

else

    print "
<LI> <FONT Color=\"gray\">Grant Access</FONT> - Grant a user access to this directory - This directory is not password protected
<LI> <FONT Color=\"gray\">Deny Access</FONT> - Deny a user access to this directory - This directory is not password protected
"

fi

print "
<LI> <A Href=\"${SCRIPT_CGI}/adminPasswdForm.cgi?${DD_DIR}\">Change Password</A> - Allows the directory administrator to change their password
"


if [[ -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.admuploadFile" ]]
then

    print "
<LI> <A Href=\"${SCRIPT_CGI}/admuploadFileForm.cgi?${DD_DIR}\">Upload a File</A> - Allows the directory administrator to upload a file to the current directory
"

else

    print "
<LI> <FONT Color=\"gray\">Upload a File</FONT> - Allows the directory administrator to upload a file to the current directory - This directory does not allow file uploads
"

fi

print "
<LI> <A Href=\"${SCRIPT_CGI}/reindex.cgi?${DD_DIR}\">Reindex current directory</A> - Reindexes the control files under the current directory
<LI> <A Href=\"${SCRIPT_CGI}/modform.cgi?${DD_DIR}\">Modify Appearance</A> - Modify the appearance of the current directory
</UL>
</P>
"

print "<P><FONT Size=\"4\"><STRONG>
Return to <A Href=\"${DOCUMENT_BASE}${DD_DIR}\">${DDDIR}"
[[ "_${DDDIR}" = "_" ]] && print "HOME"
print "</A></STRONG></FONT></P>"

[[ -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.linkbar" ]] && cat "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.linkbar"
[[ -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.forinfo" ]] && cat "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.forinfo"

print "</BODY>
</HTML>"

